====
ellc
====

Generate light curves or radial velocity curves for a binary
star system with the ellc light curve model. [1]_

Installation of this module requires python >2.7 and numpy >1.10.0

To install this module linux-like systems run the following command
$ python setup.py install 
or to install on your system if you have root access
$ sudo  python setup.py install 

Routines in this module:

  lc(t_obs, radius_1, radius_2, sbratio, incl, ... ) 

  rv(t_obs, radius_1, radius_2, sbratio, incl, t_zero, period, a, q, ...)

  fluxes(t_obs, radius_1, radius_2, sbratio, incl, ... ) 
  
  ldy.LimbGravityDarkeningCoeffs()

Documentation and examples for each routine are included in the file headers
and can be viewed from within python in the normal way, e.g., 
 >>> import ellc
 >>> print(ellc.ldy.__doc__)

The easiest way to fit a single light curve is use ellc_emcee (you will need
to add the appropriate /bin/ directory to your path). Run the command
ellc_emcee and follow the prompts. You can grab the output from this script in
the log file and use this as the basis of a new input file for this script.
Use ./ellc_emcee.py -h to see command-line options.

Please cite Maxted (2016) if you published results based on this software.
See sub-directory examples/ for scripts used to generate the figures in this
paper. 

.. rubric:: References
.. [1] Maxted, P.F.L. 2016. A fast, flexible light curve model for detached
   eclipsing binary stars and transiting exoplanets. A&A 591, A111

 The coordiate system used in the program changed in version 1.5.0 compared to
the description in Maxted A&A 591, A111, 2016. This was required to fix a bug
with the flux-weighted radial velocity in cases where detailed
heating/reflection was used. 

 See below for a description of the coordinate systems displayed in coords.png

-Pierre Maxted
 September 2016


 Coordinate transformation for ellc 

 Assumes that the stellar rotation axis and orbital angular momentum axes are
 parallel.
 
 The star is defined by an ellipsoid which is offset by a distance D from the
 centre-of-mass of the star towards the companion.

 Star coordinate system is (x, y, z) with origin at the star's centre-of-mass
 - x towards the companion
 - y in the orbital plane with star motion towards negative y
 - z parallel to rotation/orbital angular momentum vector

 Ellipsoid coordinate system is (x', y', z') with origin at the centre of the
 ellipsoid, i.e., x' = x - D, y' = y, z' = z.

 Observer coordinate system (u, v, w) with origin at the centre-of-mass of the
 binary
 - u in the plane of the sky perpendicular to the angular momentum vector
 - v in the plane of the sky parallel to the angular momentum vector
 - w pointing towards the observer

 The ellipsoid defining the star projected onto the plane of the sky is an
 ellipse. The projected coordinate system is (s, t, p) with the same origin as
 (x',y',z') and the same orientation as (u, v, w).
 
 The inclination, incl, is the angle between the orbital angular momentum
 vector and the line of sight.

 The angle phi is measured from the x-axis to the projection of the w-axis
 in the x-y plane.

Scripts to generate plots for Maxted, 2016 A&A 591, A111, 2016, and other
plots for testing purposes.

 The executable file ".py" file in each folder/sub-directory will, by default,
produce a screen plot of the results. To produce the .eps file add the
optional argument to the command "--eps", e.g., 
$ ./KPD1946+4340  --eps

batman/
run_batman.py - Generate plot to compare ellc to batman
batman.eps    - output from run_batman.py
                  
DoublePartial/ 
DoublePartial.py   - Generate plot to compare ellc to Nightfall 
DoublePartial.cfg  - Nightfall input file 
NightfallCurve.dat - From "nightfall -C DoublePartial.cfg -R1 -F -M -N1000"
DoublePartial.eps  - Output from DoublePartial.py

ellc_emcee/
HD23642.in    - Example input to ellc_emcee - light curve of HD23642
HD23642.dat   - Kepler K2 light curve for HD23642
HD23642.log   - ellc_emcee -g very_sparse -l HD23642.log < HD23642.in
chain.csv     - Output emcee chain from same command (this takes some time...)
model.csv     - Output model light curve from same command
plot_chain.py - Compare selected parameters to results in arXiv:1602.01901v1
corner.eps    - Output from plot_chain.py
plot_lcfit.py - Plot model fit to light curve
lcfit.eps     - Output from plot_lcfit.py
N.B. From version 1.5.0, include reflection factor for star 1 as a free
parameter since this was effectively fixed at 0 in previous versions (bug fix
in version 1.4.3)

GD448/
GD448.py           - Generate plot to compare ellc to Nightfall for GD448
GD448_rv.py        - Generate plot to compare ellc to Nightfall for GD448
GD448.cfg          - Nightfall input file
NightfallCurve.dat - From "nightfall -N1000 -F -C GD448.cfg -OP 5 -M -R9"
GD448.eps          - Output from GD448.py  
GD448_rv.eps       - Output from GD448.py  
 
J0113+31/
J0113+31.py  - Analysis of J0113+31 using ellc  (this takes some time...)
table*.dat   - Data from Gomez Maqueo Chew et al., 2014A&A...572A..50G
J0113+31.eps - Output from J0113+31.py - light curve plots
corner.eps   - Output from J0113+31.py - parameter correlation plots

KPD1946+4340/
KPD1946+4340.py   - Comparison of ellc model to Kepler data for KPD1946+4340
kplr007975824.dat - Phase-binned short-cadence Kepler data for KPD1946+4340
KPD1946+4340.eps  - Output from KPD1946+4340.py

KSint/
KSint.py   - Generate plot to compare ellc to KSint
inputs.txt - KSint input file
lc.dat     - Output from KSint
KSint.eps  - Output from KSint.py

PhotRM/
PhotRM.py  - Generate plot of the photometric R-M effect using ellc
PhotRM.eps - Output from PhotRM.py
N.B. A bug fix in version 1.5.0 means that this results shown in the plot are
not the same as the ones in the paper.

arome/
arome.dat  - Output from arome-1.0.0/examples/f77multiple.f 
arome.py   - Comparison of ellc model to arome for R-M effect
arome.eps  - Output from arome.py 

Ellipsoidal/

NightfallCurve.dat - From "nightfall -C Ellipsoidal.cfg -F -N1000 -L2 "
nightfall.log      - Screen output from nightfall in debug mode.

power-2/
power-2.py  - Plots to test power-2 limb darkening law against claret law
power-2.eps - Output from power-2.py

! This file is part of the ellc binary star model
! Copyright (C) 2016 Pierre Maxted
! 
! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

module stellar
! Stellar astrophysics functions for ellc
!
! HISTORY
! -------
!  24 Feb 2017
!   Added catch to avoid getting stuck in while loop.
!
! 5 May 2017
!  Added tabulated limb darkening law.
!
! 14 Sep 2016
! Improved definition/handling of coordinates to fix problems with radial
! velocities in bright().
! Improved calculation of local surface gravity - now done at Roche
! equipotential instead of at the ellipsoid surface.
! p.maxted@keele.ac.uk
!
! Apr 2016
! Added exact_grav option to bright
! p.maxted@keele.ac.uk
!
! Jan 2016
! First version 
! p.maxted@keele.ac.uk
!
!
use constants
use utils

implicit none

! Routines for calculating geometry
public starshape     ! Ellipsoidal approximation to shape of a body in a binary
public roche         ! Roche potential from  Wilson, 1979ApJ...234.1054
public roche_l1      ! Position of the inner Lagrangian point
public droche        ! Derivative of Roche potential 
! Stellar surface flux distribution
public limbdark      ! Limb darkening laws
public bright        ! Stellar surface brightness and/or rad. vel.
public ld_quad_match ! Quadratic coefficients to match another limb darking law
public gmodel_coeffs ! Calculate coeffs of surface gravity approximating func.
! Keplerian orbits
public eanom         ! Eccentric anomaly from mean anomaly
public trueanom      ! True anomaly from mean anomaly
public t_ecl_to_peri ! Time of periastron passage prior to a time of eclipse.
public delta_func    ! Helper function for t_ecl_to_peri

contains

function starshape(radius, rsep, spar, ecc, q, model, rtol, &
                   verbose) result(abcd)
implicit none 
! Semi-major axes (A,B,C) and offset towards companion, D, from centre-of-mass
! to geometrical centre of an ellipsoid that approximates the shape of a
! star in a binary system. 
!
! All quantities measured in units of semi-major axis of binary.
! A = semi-major axis on x-axis towards companion
! B = semi-major axis in orbital plane perpendicular to x-axis
! C = semi-major axis on an axis perpendicular to orbital angular momentum
!     vector
!
! Rotation and orbital angular momentum vectors are assumed parallel.
!
! For invalid input all return values are set to bad_dble
!
! Polytropic models use rotational distortion from interpolation in Table 1 of
! James, 1964ApJ...140..552J.
!
! Tidal distortion for polytropes is from Chandrasekhar, 1933MNRAS..93..449C.
!
! Tidal and rotational distortion are assumed to be independent.
!
! The definition of the Roche potential is from Wilson, 1979ApJ...234.1054W
! 
! RADIUS= Radius of a sphere with the same volume as the ellipsoid to be
!         calculated. For the Roche model only, set radius=1 to specify
!         a star that fills its Roche lobe.
! RSEP  = Separation of the stars in units of the semi-major axis.
! SPAR  = angular velocity of star/pseudo-synchronous angular velocity OR
!         for Correia (2014A&A...570L...5C) model, fluid second Love number 
!         for radial displacement, h_f.
! ECC   = eccentricity
! Q     = mass of companion/mass of star
! RTOL  = Tolerance on fractional difference (ABC**(1/3)-radius)/radius.
!         If RTOL <= EPSILON(0.0), e.g., 0.0, then EPSILON(0.0) 
!         (machine precision) is used as the tolerance.
!
! MODEL
!       = -2 - Roche model with precise volume calculation
!       = -1 - Roche model
!       =  0 - spherical star
!       =  1 - polytrope n = 1.5
!       =  2 - polytrope n = 3
!
! VERBOSE : 0 = silent
!           1 = error messages
!           2 = warning messages
!           3 = informational messages
!           4 = debugging
!
!-

double precision, intent(in) :: radius  ! Radius of a sphere with the same volume as the ellipsoid
double precision, intent(in) :: rsep    ! Separation of the stars in units of the semi-major axis
double precision, intent(in) :: spar    ! angular velocity of star/pseudo-synchronous angular velocity
double precision, intent(in) :: ecc     ! eccentricity of the orbit
double precision, intent(in) :: q       ! mass of companion/mass of star
double precision, intent(in) :: rtol    ! Tolerance on fractional difference (ABC**(1/3)-radius)/radius
integer, intent(in)  :: model   ! Model used to calculate star shape (see constants)
integer, intent(in)  :: verbose ! Verbosity level for error reporting
double precision             :: abcd(4) ! semi-major axis on x-axis towards companion

! Local variables
double precision :: rt, t, ttol, tlo, thi
double precision :: a,b,c,d
double precision :: ksi,r_0,vfac,n,n2,r2,r3,r4,r5,r6,q2,q3
double precision :: rsep_l
integer :: it
integer, parameter :: itmax = 100

abcd = (/bad_dble, bad_dble, bad_dble, bad_dble/)

if(verbose >= v_debug) then
  print *,'starshape: radius, q, ecc, rsep, model = ', &
  radius,q,ecc,rsep,model
endif 
if ((radius <= 0.d0).or.(radius.gt.1.d0))then
  if(verbose >= v_error)then
    print *,'starshape: error: invalid input radius: ',radius
  endif
  return
endif

! If rsep is within 4*epsilon(0.d0) of 1-ecc or 1+ecc then assume that this
! is due to round-off error 
! Use rsep_l as a local copy of rsep which is within the allowed range.
tlo = rsep - (1.d0-ecc)
thi = (1.d0+ecc) - rsep
ttol = 4.0d0*epsilon(0.d0)
if ((tlo > 0).and.(thi > 0)) then
  rsep_l = rsep
else if (abs(tlo) < ttol) then
  rsep_l = (1.d0-ecc)
else if (abs(thi) < ttol) then
  rsep_l = (1.d0+ecc)
else
  if(verbose >= v_error)then
    print *,'starshape: error: rsep out of range: ', rsep,ecc
  endif
  return
endif

ttol = max(rtol, epsilon(0.d0))
rt = radius

select case (model)

case(starshape_roche_v)

  t = 1
  it = 0 
  do while (t.gt.ttol)
    it = it + 1
    if (it > itmax) then
      if(verbose >= v_error) then
        print *,'starshape: failed to converge : t  = ',t
      endif
      return
    endif

    if(d.eq.bad_dble) return
    if (radius.eq.1.d0) then
      t = 0
    else
      ksi = rsep_l*roche(x=rt,y=0.0d0,z=0.0d0,d=rsep_l,q=q,f=1.0d0)
      n = (q+1d0)/2d0
      r_0 = 1d0/(ksi-q)
      r2 = r_0**2
      r3 = r2*r_0
      r4 = r3*r_0
      r5 = r4*r_0
      r6 = r5*r_0
      q2 = q**2
      q3 = q2*q
      n2 = n**2
      vfac = (1d0 + r6*(12d0*q2/5d0  &
      + 15d0*q2*r2/7d0 + 2d0*q2*r4 + 22d0*q3*r3/7d0 + 157*q3*r5/7d0 &
      + 2d0*n/r3 + 32d0*n2/5d0 + 176*n**3*r3/7d0 + 8d0*n*q/5d0 &
      + 296*n*q*(2d0*q+n)*r3/35d0 + 26d0*n*q*(q+3d0*n)*r5/35d0 ))
      t = vfac**third*r_0*rsep_l/radius
      rt = rt/t
      t = abs(t-1.d0)
    endif
  end do
  call shape_roche(rt,rsep_l,spar,q,a,b,c,d,verbose-1)

case(starshape_roche)

  t = 1
  it = 0
  do while (t.gt.ttol)
    it = it + 1
    if (it > itmax) then
      if(verbose >= v_error) then
        print *,'starshape: failed to converge : t  = ',t
      endif
      return
    endif

    call shape_roche(rt,rsep_l,spar,q,a,b,c,d,verbose-1)
    if(d.eq.bad_dble) return
    if (radius.eq.1.d0) then
      t = 0
    else
      t = (a*b*c)**third/radius
      rt = rt/t
      t = abs(t-1.d0)
    endif
  end do

case(starshape_sphere)

  a = radius
  b = radius
  c = radius
  d = 0
  t = 0

case(starshape_poly1p5)

  t = 1
  it = 0
  do while (t.gt.ttol)
    it = it + 1
    if (it > itmax) then
      if(verbose >= v_error) then
        print *,'starshape: failed to converge : t, radius  = ',t,radius
      endif
      return
    endif
    call shape_n1p5(rt,rsep_l,spar,ecc,q,a,b,c,d,verbose-1)
    if(d.eq.bad_dble) return
    t = (a*b*c)**third/radius
    rt = rt/t
    t = abs(t-1.d0)
  end do

case(starshape_poly3p0)

  t = 1
  it = 0
  do while (t.gt.ttol)
    it = it + 1
    if (it > itmax) then
      if(verbose >= v_error) then
        print *,'starshape: failed to converge : t  = ',t
      endif
      return
    endif
    call shape_n3p0(rt,rsep_l,spar,ecc,q,a,b,c,d,verbose-1)
    if(d.eq.bad_dble) return
    t = (a*b*c)**third/radius
    rt = rt/t
    t = abs(t-1.d0)
  end do


case(starshape_love)

  t = 1
  it = 0
  do while (t.gt.ttol)
    it = it + 1
    if (it > itmax) then
      if(verbose >= v_error) then
        print *,'starshape: failed to converge : t  = ',t
      endif
      return
    endif
    call shape_love(rt,rsep_l,spar,q,a,b,c,d,verbose-1)
    if(d.eq.bad_dble) return
    t = (a*b*c)**third/radius
    rt = rt/t
    t = abs(t-1.d0)
  end do

case default
  if(verbose >= v_error) then
    print *,'starshape: error: invalid input model'
  endif
  return

end select

if(verbose >= v_debug) then
  print *,'starshape: normal exit : a,b,c,d,t  = ',a,b,c,d,t
endif

abcd = (/a, b, c, d/)
return

end function starshape

!-----------------------------------------------------------------------

subroutine shape_n1p5(radius,rsep,frot,ecc,qmass,a,b,c,d,verbose)
implicit none
double precision, intent(in)  :: radius, rsep, frot, ecc, qmass
double precision, intent(out) :: a, b, c, d
integer, intent(in)           :: verbose

! Local variables
integer, parameter :: npar = 1
double precision   :: ar, par(npar), a1, a2, w
double precision   :: dxip,dxie
double precision   :: dsig0
double precision   :: qnu3,qnu4,qnu5
integer            :: ii
double precision, parameter :: delta2=1.2892d0
double precision, parameter :: delta3=1.1079d0
double precision, parameter :: delta4=1.0562d0
double precision, parameter :: tol = 1.0d-6

! These fractional changes in polar and equatorial radii and 
! fraction change in volume equivalent radius based on columns xi_p, xi_e and
! 10^-2V in Table 1 of James, 1964
!
double precision tdxip(25),tdxie(25)
data tdxip/ &
 0.0000000d0,-0.0042422d0,-0.0084843d0,-0.0127265d0,-0.0169960d0, &
-0.0212929d0,-0.0255898d0,-0.0298867d0,-0.0342383d0,-0.0385900d0, &
-0.0429690d0,-0.0473753d0,-0.0518091d0,-0.0562976d0,-0.0607860d0, &
-0.0653293d0,-0.0699272d0,-0.0745525d0,-0.0792510d0,-0.0840221d0, &
-0.0888390d0,-0.0927801d0,-0.0947780d0,-0.0968033d0,-0.0978160d0/ 
data tdxie/ &
0.00000000d0,0.00747167d0,0.01524440d0,0.02331819d0,0.03174777d0, &
0.04056051d0,0.04981116d0,0.05949970d0,0.06970825d0,0.08046417d0, &
0.09190432d0,0.10408342d0,0.11713832d0,0.13117850d0,0.14642290d0, &
0.16311785d0,0.18161914d0,0.20250151d0,0.22653128d0,0.25521375d0, &
0.29153210d0,0.33124418d0,0.35885927d0,0.40092506d0,0.45073622d0/

par(1) = frot**2 * radius**3 * (1.d0+qmass) * (1.d0-ecc**2) / (1.d0-ecc)**4

a1 = 0.d0
a2 = 1.09d-2
ar =  zbrent(func_n1p5,a1,a2,tol,npar,par,verbose-1)
if(verbose >= v_debug) print *,'shape_n1p5: ar =',ar
if (ar < 0.d0) then
  a = bad_dble
  b = bad_dble
  c = bad_dble
  d = bad_dble
  if(verbose >= v_error) print *,'shape_n1p5: radius out of range.',radius,frot,ecc,qmass
  return
endif

! Interpolate values of fractional changes in radius
if(ar < 1.0d-2) then
  w = 0.2d4*ar
  ii = 1+int(w)
  w = dble(ii)-w
  dxip = w*tdxip(ii) + (1.d0-w)*tdxip(ii+1)
  dxie = w*tdxie(ii) + (1.d0-w)*tdxie(ii+1)
else if(ar < 1.04d-2) then
  w = 0.25d4*(ar-1.0d-2)
  dxie = (1.d0-w)*tdxie(21) + w*tdxie(22)
  dxip = (1.d0-w)*tdxip(21) + w*tdxip(22)
else if(ar <= 1.08d-2) then
  w = 0.5d4*(ar-1.04d-2)
  ii = 22+int(w)
  w = dble(ii-21)-w
  dxie = w*tdxie(ii) + (1.d0-w)*tdxie(ii+1)
  dxip = w*tdxip(ii) + (1.d0-w)*tdxip(ii+1)
else if(ar <= 1.09d-2) then
  w = ar-1.08d-2
  dxie = (1.d0-w)*tdxie(24) + w*tdxie(25)
  dxip = (1.d0-w)*tdxip(24) + w*tdxip(25)
else
  print *,'shape_n1p5: invalid value of ar',ar
  stop
endif

a = radius*(1.d0+dxie)
b = a
c = radius*(1.d0+dxip)

! Tidal distortion
ar = radius/rsep
qnu3 = qmass*ar**3 
qnu4 = qnu3*ar
qnu5 = qnu4*ar
a = a*(1.d0 + 0.5d0*(delta2*qnu3+delta4*qnu5))
dsig0 = 1.d0 - 0.5d0*delta2*qnu3 + 0.375d0*delta4*qnu5
b = b*dsig0
c = c*dsig0
d = delta3*qnu4*radius

return

end subroutine shape_n1p5

!-----------------------------------------------------------------------

double precision function func_n1p5(a,npar,par,verbose)
implicit none
!
! par(1) = f^2 * (1+q) * r_v**3 * (1.d0-ecc**2)/(1.d0-ecc)**4
! 
integer, intent(in)          :: npar, verbose
double precision, intent(in) :: a, par(npar)

! Local variables
double precision array(25)
integer ii
double precision w

! The values in this array are 2*pi*m/3*v where m and v are from Table 1 of
! James, 1964ApJ...140..552J. Return value is linear interpolation in this
! table multiplied by par(1) then subtracted from a
! Out-of range values returned as bad_dble
data array/ &
0.02782105d0,0.02768557d0,0.02754373d0,0.02739694d0,0.02724204d0, &
0.02708024d0,0.02691018d0,0.02673288d0,0.02654358d0,0.02634414d0, &
0.02613295d0,0.02590672d0,0.02566646d0,0.02540777d0,0.02512701d0, &
0.02482182d0,0.02448562d0,0.02410966d0,0.02368468d0,0.02319031d0, &
0.02259155d0,0.02198336d0,0.02160056d0,0.02109994d0,0.02071318d0/

if (verbose > v_debug) print *,'func_n1p5: a =', a

if(a < 0.d0) then
  func_n1p5 = bad_dble
else if(a < 1.0d-2) then
  w = a/0.05d-2
  ii = 1+int(w)
  w = dble(ii)-w
  func_n1p5 = a-par(1)*(w*array(ii) + (1.d0-w)*array(ii+1))
else if(a < 1.04d-2) then
  w = (a-1.0d-2)/0.04d-2
  func_n1p5 = a-par(1)*((1.d0-w)*array(21) + w*array(22))
else if(a <= 1.08d-2) then
  w = (a-1.04d-2)/0.02d-2
  ii = 22+int(w)
  w = dble(ii-21)-w
  func_n1p5 = a-par(1)*(w*array(ii) + (1.d0-w)*array(ii+1))
else if(a <= 1.09d-2) then
  w = a-1.08d-2
  func_n1p5 = a-par(1)*((1.d0-w)*array(24) + w*array(25))
else
  func_n1p5 = bad_dble
endif
return

end function func_n1p5

!-----------------------------------------------------------------------

subroutine shape_n3p0(radius,rsep,frot,ecc,qmass,a,b,c,d,verbose)
implicit none
double precision, intent(in)  :: radius, rsep, frot, ecc, qmass
double precision, intent(out) :: a, b, c, d
integer, intent(in)           :: verbose

! Local variables
integer, parameter :: npar = 1
double precision   :: ar, par(npar), a1, a2, w
double precision   :: dxip,dxie
double precision   :: dsig0
double precision   :: qnu3,qnu4,qnu5
integer            :: ii
double precision, parameter :: delta2=1.0289d0
double precision, parameter :: delta3=1.00736d0
double precision, parameter :: delta4=1.00281d0
double precision, parameter :: tol = 1.0d-6

! These fractional changes in polar and equatorial radii and 
! fraction change in volume equivalent radius based on columns xi_p, xi_e and
! 10^-2v in table 1 of James, 1964
!
double precision tdxip(24),tdxie(24)
data tdxip/ &
 0.0000000d0,-0.0015862d0,-0.0031623d0,-0.0047471d0,-0.0063333d0, &
-0.0079138d0,-0.0094956d0,-0.0110731d0,-0.0126667d0,-0.0142500d0, &
-0.0158232d0,-0.0174036d0,-0.0189855d0,-0.0205674d0,-0.0221536d0, &
-0.0237558d0,-0.0253406d0,-0.0269311d0,-0.0285232d0,-0.0291582d0, &
-0.0297919d0,-0.0301109d0,-0.0304298d0,-0.0307503d0/
data tdxie/ &
0.00000000d0,0.00692635d0,0.01416734d0,0.02175631d0,0.02972951d0, &
0.03812610d0,0.04700117d0,0.05640546d0,0.06641728d0,0.07712796d0, &
0.08861727d0,0.10106498d0,0.11461754d0,0.12951130d0,0.14608118d0, &
0.16478972d0,0.18633434d0,0.21185324d0,0.24351697d0,0.25880946d0, &
0.27637255d0,0.28627707d0,0.29714145d0,0.30924118d0/

par(1)=frot**2 * radius**3 * (1.d0+qmass) * (1.d0-ecc**2)/(1.d0-ecc)**4
a1 = 0.d0
a2 = 9.7d-4
ar =  zbrent(func_n3p0,a1,a2,tol,npar,par,verbose-1)
if(verbose >= v_debug) print *,'shape_n3p0: ar =',ar
if (ar < 0.d0) then
  a = bad_dble
  b = bad_dble
  c = bad_dble
  d = bad_dble
  if(verbose >= 1) print *,'shape_n3p0: radius out of range.',radius,frot,ecc,qmass
  return
endif

! Interpolate values of fractional changes in radius
if(ar.lt.9.0d-4) then
  w = ar/0.5d-4
  ii = 1+int(w)
  w = dble(ii)-w
  dxip = w*tdxip(ii) + (1.d0-w)*tdxip(ii+1)
  dxie = w*tdxie(ii) + (1.d0-w)*tdxie(ii+1)
else if(ar.lt. 9.4d-4) then
  w = (a-9.0d-4)/0.2d-4
  ii = 19+int(w)
  w = dble(ii-18)-w
  dxip = w*tdxip(ii) + (1.d0-w)*tdxip(ii+1)
  dxie = w*tdxie(ii) + (1.d0-w)*tdxie(ii+1)
else if(ar <= 9.7d-4) then
  w = (a-9.4d-4)/0.1d-4
  ii = 21+int(w)
  w = dble(ii-20)-w
  dxip = w*tdxip(ii) + (1.d0-w)*tdxip(ii+1)
  dxie = w*tdxie(ii) + (1.d0-w)*tdxie(ii+1)
else
  print *,'shape_n3p0: invalid value of ar',ar
  stop
endif
a = radius*(1.d0+dxie)
b = a
c = radius*(1.d0+dxip)

! Tidal distortion
ar = radius/rsep
qnu3 = qmass*ar**3 
qnu4 = qnu3*ar
qnu5 = qnu4*ar
a = a*(1.d0 + 0.5d0*(delta2*qnu3+delta4*qnu5))
dsig0 = 1.d0 - 0.5d0*delta2*qnu3 + 0.375d0*delta4*qnu5
b = b*dsig0
c = c*dsig0
d = delta3*qnu4*radius

return

end subroutine shape_n3p0

!-----------------------------------------------------------------------

double precision function func_n3p0(a,npar,par,verbose)
implicit none
!
! par(1) = f^2 * (1+q) * r_v**3 * (1.d0-ecc**2)/(1.d0-ecc)**4
! 
integer, intent(in)          :: npar, verbose
double precision, intent(in) :: a, par(npar)

! Local variables
double precision array(24)
integer ii
double precision w
! The values in this array are 2*pi*m/3*v where m and v are from table 1 of
! james, 1964apj...140..552j. Return value is linear interpolation in this
! table multiplied by par(1) then subtracted from a
! out-of range values returned as bad_dble
data array/ &
0.00307603d0,0.00304253d0,0.00300812d0,0.00297269d0,0.00293619d0, &
0.00289851d0,0.00285958d0,0.00281926d0,0.00277739d0,0.00273384d0, &
0.00268838d0,0.00264078d0,0.00259069d0,0.00253778d0,0.00248146d0, &
0.00242103d0,0.00235546d0,0.00228318d0,0.00220144d0,0.00216504d0, &
0.00212572d0,0.00210468d0,0.00208254d0,0.00205903d0/

if (verbose > v_debug) print *,'func_n1p5: a =', a

if(a < 0.d0) then
  func_n3p0 = bad_dble
else if(a < 9.0d-4) then
  w = a/0.5d-4
  ii = 1+int(w)
  w = dble(ii)-w
  func_n3p0 = a-par(1)*(w*array(ii) + (1.d0-w)*array(ii+1))
else if(a < 9.4d-4) then
  w = (a-9.0d-4)/0.2d-4
  ii = 19+int(w)
  w = dble(ii-18)-w
  func_n3p0 = a-par(1)*(w*array(ii) + (1.d0-w)*array(ii+1))
else if(a <=  9.7d-4) then
  w = (a-9.4d-4)/0.1d-4
  ii = 21+int(w)
  w = dble(ii-20)-w
  func_n3p0 = a-par(1)*(w*array(ii) + (1.d0-w)*array(ii+1))
else
  func_n3p0 = bad_dble
endif
return
end function func_n3p0

!-----------------------------------------------------------------------

subroutine shape_roche(radius,rsep,frot,qmass,a,b,c,d,verbose)
implicit none

double precision, intent(in)  :: radius, rsep, frot, qmass
double precision, intent(out) :: a, b, c, d
integer, intent(in)           ::  verbose

! Local variables
double precision   :: pot, rl1, xf, xb
integer, parameter :: npar = 4
double precision   :: par(npar)
double precision, parameter :: tol=1.0d-6

rl1 = roche_l1(qmass,frot)
if (radius == 1.d0) then
  xf = rl1
else
  if (radius > rl1) then
    if(verbose >= v_error) then
      print *,' shape_roche: star exceeds roche lobe'
      print *,' shape_roche: radius,rl1,q = ',radius,rl1,qmass
    endif
    a = bad_dble
    b = bad_dble
    c = bad_dble
    d = bad_dble
    return
  endif
  xf = radius
endif
pot = roche(xf,0.d0,0.d0,rsep,qmass,frot)
par(1) = pot
par(2) = rsep
par(3) = qmass
par(4) = frot
b = zbrent(func_b,radius*0.5d0,radius*1.1d0,tol,npar,par,verbose-1)
c = zbrent(func_c,radius*0.5d0,radius*1.1d0,tol,npar,par,verbose-1)
xb = zbrent(func_a,-radius*1.5d0,-radius*0.5d0,tol,npar,par,verbose-1)
d = 0.5*(xf+xb)
a = xf - d

end subroutine shape_roche

!-----------------------------------------------------------------------

subroutine shape_love(radius,rsep,h_f,qmass,a,b,c,d,verbose)
implicit none

double precision, intent(in)  :: radius, rsep, h_f, qmass
double precision, intent(out) :: a, b, c, d
integer, intent(in)           :: verbose
double precision              :: qr

! RADIUS = Radius of a spherical planet in unit of stellar radii.
! RSEP   = Separation of between bodies in unit of stellar radii.
! qmass  = mass of star/mass of planet
! h_f    = fluid second love number as used in Correia()
! a,b,c  = the semi-major axes of the ellipse in units of stellar radii
! d      = d is an offset towards the companion from the centre-of-mass of the
!           planet to the geometric centre of the ellipsoid
!
! Local variables.
!qr      = planet asymmetry as defined in correia


b=radius
qr=0.5d0*h_f*qmass*(b/rsep)**3       !from eqn(12) in correia(2014)
if (qr >= 1) then
    if (verbose > v_silent) print *,'shape_love: qr >1; b, qr  =', b, qr
    a = bad_dble
    b = bad_dble
    c = bad_dble
    d = bad_dble
    return
endif

a = b*(1.d0+3.d0*qr)          !eqn(10)
c = b*(1.d0-qr)               !eqn(11)
d = radius*qmass*radius**4    !From Chandrasekhar using delta_3 = 1

if (verbose > v_debug) print *,'shape_love: a,c,d,qr =', a,c,d,qr
end subroutine shape_love

!-----------------------------------------------------------------------

double precision function func_a(a,npar,par,verbose)
implicit none
integer, intent(in)          :: npar, verbose
double precision, intent(in) :: a, par(npar)
if (verbose > v_debug) print *,'func_a: ', a
func_a=par(1)-roche(a,0.d0,0.d0,par(2),par(3),par(4))
return 
end function func_a

!-----------------------------------------------------------------------

double precision function func_b(b,npar,par,verbose)
implicit none
integer, intent(in)          :: npar, verbose
double precision, intent(in) :: b, par(npar)
if (verbose > v_debug) print *,'func_b: ', b
func_b = par(1)-roche(0.d0,b,0.d0,par(2),par(3),par(4))
return 
end function func_b

!-----------------------------------------------------------------------

double precision function func_c(c,npar,par,verbose)
implicit none
integer, intent(in)          :: npar, verbose
double precision, intent(in) :: c, par(npar)
if (verbose > v_debug) print *,'func_c: ', c
func_c=par(1)-roche(0.d0,0.d0,c,par(2),par(3),par(4))
return 
end function func_c

!-----------------------------------------------------------------------

double precision function func_r(r,npar,par,verbose)
implicit none
integer, intent(in)          :: npar, verbose
double precision, intent(in) :: r, par(npar)
if (verbose > v_debug) print *,'func_r: ', r
func_r=par(1)-roche(par(2)*r,par(3)*r,par(4)*r,par(5),par(6),par(7))
!print *,'func_r (',real(r),') = ',real(func_r),', target =',real(par(1))
!print *,'func_r',real(r),real(par(1)-func_r),real(par(1))
return 
end function func_r

!-----------------------------------------------------------------------

double precision function roche(x, y, z, d, q, f, iscomp)
!+
!
! Roche potential according to the definition of Wilson, 1979ApJ...234.1054W
!
! Input position is (X, Y, Z)
!  - origin at centre-of-mass of the star.
!  - x-axis towards companion
!  - y-axis in orbtial plane opposite to direction of orbital motion
!  - z-axis parallel to orbital angular momentum vector
!  - all lengths relative to the semi-major axis of the binary.
! 
! Q is mass ratio = mass companion/mass of star.
!
! D is instantaneous separation of the centres.
!
! F is the synchronization index of the star, i.e. the ratio of sidereal 
! rotational and orbital frequency
!
! To evaluate the potential for the companion to a star with consistent
! units for two stars:
!  - set "ISCOMP" to .TRUE.
!  - Use the value of F appropriate for the companion
!  - Measure position from the centre of the companion with x-axis
!    towards the star
!  - Use mass ratio Q = mass of companion/mass star, as before.
!  
! Invalid input returns the values bad_dble
!
! p.maxted@keele.ac.uk, Jun 2015 
!
!-
implicit none
double precision, intent(in)  :: q       ! mass ratio = mass of companion/mass of star
double precision, intent(in)  :: x, y, z ! position (x, y, z) at which to evaluate the function
double precision, intent(in)  :: d       ! instantaneous separation of the stars
double precision, intent(in)  :: f       ! synchronization index of the star
logical, intent(in), optional :: iscomp  ! Set .true. to calculate potential due to companion star

! Local variables
double precision qq, r, r2, nu, lam, d2
logical iscomp_l

if (present(iscomp)) then
  iscomp_l = iscomp
else
  iscomp_l = .false.
endif

if (q <= 0.d0) then
  roche = bad_dble
  return
endif

if (iscomp_l) then
  qq = 1.d0/q
else
  qq = q
endif

r2 = x**2 + y**2 + z**2
if (r2 == 0.d0) then
  roche = bad_dble
  return
endif

r = sqrt(r2)
nu = z/r
lam = x/r
d2 = d**2
roche = 1.d0/r + qq*( 1.d0/sqrt(d2+r2-2.0d0*r*lam*d) - r*lam/d2 ) &
+ 0.5d0 * f**2 * (1.d0+qq) * r2 * (1.d0-nu**2) 
if (iscomp_l) roche = roche/qq + 0.5d0*(qq-1.d0)/qq

return
end function roche

!-----------------------------------------------------------------------

double precision function roche_l1(q, f)
implicit none
double precision, intent(in) ::  q   ! (mass of companion) / (mass of star)  
double precision, intent(in),optional ::  f   ! Rotation factor
!+
!
! Position of the inner Lagrangian point in terms of the separation of 
! two stars which have mass ratio, q.
! Works by solving for root of a quintic polynomial, by Newton-Raphson
! iteration
! Q = (mass of companion) / (mass of star)
! L1 = (distance from centre of star to inner Lagrangian point)/separation
!
! Optional input factor f is the asynchronous rotation factor as defined by
! Wilson, 1979ApJ...234.1054W
!
! For invalid input return value is bad_dble
!
!-
double complex   ::  az(6) = (/ &
   dcmplx(-1.d0,0.0d0),dcmplx(2.0d0,0.0d0),dcmplx(-1.d0,0.0d0), &
   dcmplx(0.d0,0.0d0),dcmplx(0.0d0,0.0d0),dcmplx(0.d0,0.0d0) /)
double complex   ::  z
integer ::  m
double precision :: fac

if(q <= 0.d0) then
  roche_l1 = bad_dble
  return
endif

if (present(f)) then 
  fac = f**2*(1.0d0+q)
  az(4) =dcmplx( fac + 2.0d0*q,0.0d0)
  az(5) =dcmplx(-2.0d0*fac - q,0.0d0)
  az(6) =dcmplx( fac          ,0.0d0)
else
  az(4) =dcmplx( 1.0d0 + 3.0d0*q,0.0d0)
  az(5) =dcmplx(-2.0d0 - 3.0d0*q,0.0d0)
  az(6) =dcmplx( 1.0d0 + q      ,0.0d0)
endif
z     =dcmplx( 1.0d0/(1.0d0+q),0.0d0)
m=5
roche_l1 = dble(laguerre(az,m,z))
return

end function roche_l1

!-----------------------------------------------------------------------

double precision function droche(q, x, y, z, d, f)
!+
!  Evaluates magnitude of the derivative of the dimensionless Roche potential
! at a point X,Y,Z measured from the centre of mass of the star in units of
! the semi-major axis of the binary.
!
! D = instantaneous separation of the stars. 
!
! Q = mass ratio = mass of companion/mass of star.
!
! F = synchronization index of the star, i.e. the ratio of sidereal 
!     rotational and orbital frequency
! 
! Roche potential according to the definition of Wilson, 1979ApJ...234.1054W
!
! Invalid input returns the values bad_dble
!
! p.maxted@keele.ac.uk, Jun 2015 
!
!-
implicit none
double precision, intent(in) :: q       ! mass ratio = mass of companion/mass of star
double precision, intent(in) :: x, y, z ! position (x, y, z) at which to evaluate the function
double precision, intent(in) :: d       ! instantaneous separation of the stars
double precision, intent(in) :: f       ! synchronization index of the star

! Local variables
double precision domx,domy,domz
double precision t1, t2, f21q

if (d <= 0.d0) then
  droche = bad_dble
  return
endif

t1 = x**2 + y**2 + z**2
if (t1 == 0.d0) then
  droche = bad_dble
  return
endif
t1 = t1**(-1.5d0)

t2 = (d-x)**2 + y**2 + z**2
if (t2 == 0.d0) then
  droche = bad_dble
  return
endif
t2 = q*t2**(-1.5d0)

f21q = f**2*(1.d0+q)

domx = -x*t1 + (d-x)*t2 + f21q*x - q/d**2
domy = -y*(t1 + t2 - f21q)
domz = -z*(t1 + t2)
droche = sqrt(domx**2 + domy**2 + domz**2)
return
end function droche

!-------------------------------------------------------------------------------

double precision function limbdark(mu, law, ldc)
! Limb darkening
implicit none
double precision,intent(in) :: mu     ! Cosine of the viewing angle
double precision,intent(in) :: ldc(:) ! Limb darkening coefficients/data
integer, intent(in) :: law    ! Limb darkening law - see constants.f90
! If law < -1 then ldc(:) is assumed to be a grid of specific intensity values
! tabulated on a uniform grid of abs(law) mu values, for 0 to 1. The specific
! intensity for the input value of mu is then determined  by linear 
! interpolation.

integer :: i, n
double precision :: w

if (law  < -1 ) then
  n =  abs(law)
  w = 1 + mu * (n-1)
  i = int(w)
  w = w - dble(i)
  if (i < n) then 
    limbdark =  (1.0d0-w)*ldc(i) + w*ldc(i+1)
  else
    limbdark = ldc(n)
  endif
  return
endif

select case (law)

case(ld_none) ! no limb darkening
  limbdark = 1.d0
  return

case(ld_linear) ! linear
  limbdark = 1.d0 - ldc(1)*(1.d0-mu)
  return

case(ld_quadratic) ! quadratic
  limbdark = 1.d0 - ldc(1)*(1.d0-mu) - ldc(2)*(1.d0-mu)**2
  return

case(ld_sing) ! sing 3-parameter
  limbdark = 1.d0 - ldc(1)*(1.d0-mu) - ldc(2)*(1.d0-mu**1.5d0) &
           - ldc(3)*(1.d0-mu**2)
  return

case(ld_claret) ! claret 4-parameter
  limbdark = 1.d0 - ldc(1)*(1.d0-sqrt(mu)) - ldc(2)*(1.d0-mu) &
           - ldc(3)*(1.d0-mu**1.5d0)- ldc(4)*(1.d0-mu**2)
  return

case(ld_logarithmic) ! logarithmic
  limbdark = 1.d0 - ldc(1)*(1.d0-mu) - ldc(2)*mu*log(mu)
  return

case(ld_square_root) ! square-root
  limbdark = 1.d0 - ldc(1)*(1.d0-mu) - ldc(2)*(1.d0-sqrt(mu))
  return

case(ld_exponential) ! exponential
  limbdark = 1.d0 - ldc(1)*(1.d0-mu) - ldc(2)/(1.d0-exp(mu))
  return

case(ld_power2) ! power-2 
  limbdark = 1.d0 - ldc(1)*(1.d0-mu**ldc(2))
  return

case default ! 
  limbdark = bad_dble
end select

end function limbdark

!-------------------------------------------------------------------------------

function ld_quad_match(law, ldc) result(ldc_q) 
! Set coefficients of a quadratic limb darkening law so that the intensity
! profile matches at mu= 0, 0.5, 1.0
! N.B.  these are the coefficients on the quadratic limb darkening law as used
! in eker, i.e.,  I_0[1 - u_1.mu + u_2.mu^2], so u_2 is the negative of the
! normal quadratic limb darkening coefficient.
implicit none
integer, intent(in) :: law    ! Limb darkening law - see constants.f90
double precision,intent(in) :: ldc(:)    ! Limb darkening coefficients
double precision            :: ldc_q(2) ! Quadratic limb darkening coefficients

double precision :: x0, x1

select case (law)

case(ld_none) ! no limb darkening
  ldc_q = (/ 0.0d0, 0.0d0 /)
  return

case(ld_linear) ! linear
  ldc_q = (/ ldc(1), 0.0d0 /)
  return

case(ld_quadratic) ! quadratic
  ldc_q = (/ ldc(1), -ldc(2) /)
  return

case default ! other
  x0 = limbdark(0.0d0, law, ldc)
  x1 = limbdark(0.5d0, law, ldc)
  ldc_q = (/ 3.0d0 - 4.0d0*x1 + x0, -4.0d0*x1 + 2.0d0*x0 + 2.0d0 /)
  return
end select

end function ld_quad_match
        
!-------------------------------------------------------------------------------
function gmodel_coeffs(abcd, rsep, frot, qmass,  verbose) result(gmodel) 
implicit none
double precision,intent(in) :: abcd(4)
double precision,intent(in) :: rsep  
double precision,intent(in) :: frot  
double precision,intent(in) :: qmass
integer, intent(in)         :: verbose
double precision :: gmodel(3)

! Local variables
double precision,parameter  :: rtol = 0.0d0
double precision  :: gpole,gside,gback,gfront
double precision  :: ax(3),xarr(3),garr(3)

gpole = droche(qmass, 0.0d0, 0.0d0, abcd(3), rsep, frot)
gside = droche(qmass, 0.0d0, abcd(2), 0.0d0, rsep, frot)
gback = droche(qmass, abcd(4)-abcd(1), 0.0d0, 0.0d0, rsep, frot)
gfront= droche(qmass, abcd(4)+abcd(1), 0.0d0, 0.0d0, rsep, frot)

if (verbose >= v_debug) then
  print *,' gmodel_coeff:  '
  print *,' abcd = ',abcd
  print *,' rsep = ',rsep
  print *,' frot = ',frot
  print *,' g_pole = ',gpole
  print *,' g_side = ',gside
  print *,' g_back = ',gback
  print *,' g_front= ',gfront
endif

xarr = [abcd(4)+abcd(1), abcd(4), abcd(4)-abcd(1)]
garr = [gfront/gpole-1.0d0,gside/gpole-1.0d0,gback/gpole-1.0d0]
ax = parfit(xarr,garr)
if (verbose >= v_debug) then
  print *,'xfit ',xarr
  print *,'gfit ',garr
  print *,'ax = ',ax
endif
gmodel(1:3) = ax

end function gmodel_coeffs
!-------------------------------------------------------------------------------
double precision function bright(f, g, npar, par, verbose)
!
!  Surface brightness at a point on an ellipsoidal star. 
!
!  To apply Doppler boosting set vscale to the rotation speed at the point
! (x,y,z) = (0,b,0) in km/s and set kboost to the Doppler boosting factor.
! 
!  To return the flux-weighted radial velocity set rvflag/=0 and vscale.
!
! For spherical stars only, sky-projected angle lambda between orbital and
! stellar rotation axes, can be non-zero.
!
! par(1) = Intensity at the centre of the stellar disc
! par(2) = a
! par(3) = b
! par(4) = c 
! par(5) = d 
! par(6) = inc
! par(7) = phi
! par(8) = rsep (separation between centres-of-mass)
!
! int(par(9)) = ldlaw = code for limb darkening law. 
! If ldlaw > -1 ...
! par(10) = Limb darkening coefficient 1
! par(11) = Limb darkening coefficient 2
! par(12) = Limb darkening coefficient 3
! par(13) = Limb darkening coefficient 4
!
! par(14:16) = Surface gravity model coefficients (if .not.exact_grav)
!              OR
! par(14) = q, mass ratio = mass of companion/mass of star (if exact_grav)
! par(15) = g0, local surface gravity at the pole (if exact_grav)
! par(16) = frot, asynchronous rotation factor
!
! par(17) = Gravity darkening coefficient (-v in Wood's notation)
! par(18) = Incident flux from companion
! par(19) = Heating/reflection model coefficient
! par(20) = Heating/reflection model exponent
! par(21) = Heating/reflection linear limb darkening coefficient
! par(22) = Companion radius/semi-major axis
! par(23) = lambda = sky-projected angle between orbital and rotation axes.
! par(24) = vscale = rotation speed at (x,y,z)=(0,b,0) in km/s
! par(25) = kboost = Doppler boosting factor
! par(26) = rvflag /= 0 to calculate flux-weighted radial velocity.
! par(27) = { 0 to flag .not.exact_grav
!           { potential at sub-stellar point for exact_grav case
! par(28-31) = Coordinate transformation 
! par(32)    = 0 to ignore coordinate transformation
! par(33:npar) = specific intensity values from mu=0 to mu=1 (if ldlaw < -1).
!
! Position (s,t) in projected star coordinates s given by the following
! transformation of the  input coordinates  (if npar >= 31)
!   s = par(28) + par(30)*f + par(31)*g
 !  t = par(29) - par(31)*f + par(30)*g
! otherwise
!   s = f
!   t = g
! 
! **  If you use this transformation, remember to multiply the result of your
! integration by the Jacobian = par(30)**2 + par(31)**2
!
!
implicit none
integer, intent(in)  :: npar, verbose
double precision, intent(in) :: f,g,par(npar)

! Local variables
double precision :: I_0, F_0,s,t,a,b,c,d,inc,phi,rsep,ldc(4)
double precision :: gmodel(3),vgrav,H_0,H_1,uheat,rcomp, q, g0, frot
double precision :: ap,bp,cp,dp
double precision, save :: cosi,sini,sinsqi,sinsqphi,cossqi,cossqphi
double precision, save :: sin2i,sin2phi,sinphi,cosphi
double precision, save :: phi_save = not_set_dble, inc_save = not_set_dble
double precision :: p,x,xp,y,yp,z,zp,s2,t2,st,a2,b2,c2,mu,lambda,rv,kboost
double precision :: ldfac,gfac,heat,radpt,r,rsq,cosgam,dcosgam
double precision :: omsini, omcosi, sinl, cosl, pot
double precision, parameter :: c_kms = iau_c*1.0d-3 ! Speed of light in km/s
integer,parameter :: nrpar=7
double precision :: rpar(nrpar)
double precision, parameter :: rtol=1.0d-4,mutol=1.0d-12
integer :: ldlaw
logical :: rvflag,exact_grav

I_0   = par(1)
a     = par(2) 
b     = par(3) 
c     = par(4) 
d     = par(5) 
inc   = par(6) 
phi   = par(7) 
rsep  = par(8) 
ldlaw = int(par(9))
ldc(1:4)    = par(10:13) 
pot = par(27)
exact_grav = pot.ne.0.0d0
if (exact_grav) then
  q  = par(14) 
  g0 = par(15) 
  frot = par(16) 
else
  gmodel(1:3) = par(14:16)
  g0 = not_set_dble
endif
vgrav  = par(17)
F_0    = par(18) 
H_0    = par(19)
H_1    = par(20)
uheat  = par(21)
rcomp  = par(22)
lambda = par(23)
omsini = par(24)/b
kboost = par(25)
rvflag = par(26).ne.0.0d0
if (par(32) /= 0) then
  s = par(28) + par(30)*f + par(31)*g
  t = par(29) - par(31)*f + par(30)*g
else
  s = f
  t = g
endif

if ((omsini/=0.0d0).and.(lambda/=0.0d0).and.(abs(a-c)>epsilon(0.0d0))) then
  if(verbose >= v_error) then
    print *,'Error in bright - lambda /= 0 for non-spherical star.'
    print *,lambda,omsini
    print *,a,b,c,inc,phi,s,t
  endif
  bright = bad_dble
  return
endif

! Dark star, no heating ...
heat = F_0*H_0
if ((I_0 == 0.0d0).and.(heat == 0.0d0)) then
  bright = 0
  return
endif

if (inc /= inc_save) then
  inc_save = inc
  cosi = cos(inc)
  sini = sin(inc)
  cossqi = cosi**2
  sinsqi = sini**2
  sin2i = 2.d0*cosi*sini
endif
if (phi /= phi_save) then
  phi_save = phi
  cosphi = cos(phi)
  sinphi = sin(phi)
  cossqphi = cosphi**2
  sinsqphi = sinphi**2
  sin2phi = 2.d0*cosphi*sinphi
endif

a2 = a**2
b2 = b**2
c2 = c**2
s2 = s**2
t2 = t**2
st = s*t

ap = sinsqi*cossqphi/a2 + sinsqi*sinsqphi/b2 + cossqi/c2
bp = (sini*sin2phi*s - sin2i*cossqphi*t)/a2   &
   - (sini*sin2phi*s + sin2i*sinsqphi*t)/b2   &
   + sin2i*t/c2
cp = (sinsqphi*s2 + cossqi*cossqphi*t2 - cosi*sin2phi*st)/a2 &
   + (cossqphi*s2 + cossqi*sinsqphi*t2 + cosi*sin2phi*st)/b2 &
   + sinsqi*t2/c2 - 1.d0
dp = bp**2 - 4.d0*ap*cp

if (dp < 0.d0) then
  ! The is usually a round-off error problem. 
  ! Assume this is the case and do the calculation for the point on the limb
  if(verbose >= v_debug) then
    print *,'bright: No such point on surface.'
    print *,hypot(s,t)-a,hypot(s,t)-b,hypot(s,t)-c
    print *,a,b,c,inc,phi,dp
    print *,s,t,npar
    print *,f,g,par(28:31)
    print *,ap,bp,cp
  endif
  dp = 0
endif

p = (-bp + sqrt(dp))/(2.d0*ap)

! Coordinates of input point (s,t) in (x', y', z') coordinates centred on
! geometric centre of ellipsoid
xp = sinphi*s - cosi*cosphi*t + sini*cosphi*p
yp = cosphi*s + cosi*sinphi*t - sini*sinphi*p 
zp =            sini*t        + cosi*p        

! Coordinates of input point (s,t) in (x,y,z) coordinates centred on
! centre-of-mass of the star
x = xp+d
y = yp
z = zp

! cosine of the angle between the line of sight and the surface normal to a
! triaxial ellipsoid.
mu = (xp*cosphi*sini/a2 -yp*sinphi*sini/b2 + zp*cosi/c2) &
   /       sqrt((xp/a2)**2 + (yp/b2)**2 +(zp/c2)**2)   

if(verbose >= v_debug) then
  print *,'bright: mu = ',mu
endif

if (abs(mu) < mutol) then
    mu = mutol
else if (abs(mu-1.d0) < mutol) then
    mu = 1-mutol
else if ((mu < 0.d0).or.(mu > 1.d0)) then
    print *,'Error in bright - mu out of range'
    print *,a,b,c,inc,phi,dp
    print *,s,t,npar
    print *,xp,y,z,a2,b2,c2
    print *,sini,cosi,sinphi,cosphi,mu
    bright = bad_dble
    return
endif

! Limb darkening
if (ldlaw < -1) then
  ldfac = limbdark(mu, ldlaw, par(33:npar))
else
  ldfac = limbdark(mu, ldlaw, ldc)
endif
if (ldfac == bad_dble) then
  if(verbose >= v_error) then
    print *,'Error in bright - invalid parameters for limbdark.'
    print *,ldlaw,ldc
    print *,par(33),par(npar)
  endif
  bright = bad_dble
  return
endif

if (vgrav /= 0.0d0) then
  if (exact_grav) then
    rpar(1) = pot
    rpar(2) = x
    rpar(3) = y
    rpar(4) = z
    rpar(5) = rsep
    rpar(6) = q
    rpar(7) = frot
    r = zbrent(func_r,0.9d0,1.1d0,rtol,nrpar,rpar,verbose-1)
    gfac = (droche(q, r*x, r*y, r*z, rsep, frot)/g0)**vgrav
  else
    gfac =  (poly(gmodel(1:3),x)*(1.0d0-z**2/c2) + 1.0d0)**vgrav
  endif
else
  gfac = 1
endif

! Heating/reflection
if (heat /=  0.d0) then
  radpt   = sqrt(xp**2 + y**2 + z**2)
  rsq =  radpt**2 - 2.d0*xp*(rsep-d) + (rsep-d)**2
  r =  sqrt(rsq)
  cosgam = (xp*(rsep-d)/radpt - radpt)/r
  dcosgam = (radpt-rcomp)/r
  if (cosgam < -dcosgam) then
    heat = 0
  else if (cosgam > dcosgam) then
    heat = heat*(1.0d0/rsq)**H_1*(1.d0-uheat*(1.d0-mu)) 
  else 
    heat = heat*(0.5d0*(cosgam+dcosgam)/dcosgam/rsq)**H_1*(1.d0-uheat*(1.d0-mu))
  endif
endif

bright = I_0*ldfac*gfac+heat
if (omsini /= 0.0d0) then
  if (lambda == 0.0d0) then
    rv = omsini*s
  else
    cosl = cos(lambda)
    sinl = sin(lambda)
    if (sini /= 0.0d0) then
      omcosi = omsini/sini*cosi
    else
      omcosi = bad_dble
    endif
    rv = omsini*(cosl*s - sinl*t) 
  endif

  if (rvflag) then
    bright = rv*bright*(1.0d0 - kboost*rv/c_kms)
  else
    bright = bright*(1.0d0 - kboost*rv/c_kms)
  endif
else
  rv = 0
endif

if(verbose >= v_debug) then
  print '(a,11G13.4)','bright,s,t,p,xp,y,z,rv,inc,phi,dp = ',bright,s,t,p &
   ,xp,y,z,rv,inc ,dp
   ! phi,(xp/a)**2+(y/b)**2+(z/c)**2 - 1.0d0
endif

return

end function bright

!-------------------------------------------------------------------------------
double precision function eanom(m, e) 
!  Calculate the eccentric anomaly of a Keplerian orbit with
! eccentricity e, from the mean anomaly, m.
!
!  Solves Kepler''s equation using Newton-Raphson iteration using formula for
! initial estimate from Heintz DW, 'Double stars' (Reidel, 1978).
! 
!  Input:
!   m - Mean anomaly in radians.
!   e - Eccentrcity, 0 <= E < 1.
! 
!  Output:
!    Eccentric anomaly in the range 0 < eanom < 2*pi.
!    If e is out-of-range return bad_dble
!
implicit none
double precision,intent(in) :: m, e
integer, parameter  :: itmax = 9999
double precision, parameter :: etol=1.0d-9

! Local variables
double precision :: e0, e1, test
integer  :: it

if ( (e < 0.0d0).or.(e >= 1.0d0)) then
 print *, 'Invalid eccentricity value in function eanom'
 print *, e
 eanom = bad_dble
 return
endif

it = 0
e1 = mod(m,twopi) + e*sin(m) + e*e*sin(2.0d0*m)/2.0d0
test = 1.0d0
do while (test > etol)
 it = it + 1
 if (it .gt. itmax) then
  print *,'function eanom failed to converge'
  print *,m,e,e0,e1,test
  stop
 endif
 e0 = e1
 e1 = e0 + (m-(e0 - e*sin(e0)))/(1.0d0 - e*cos(e0))
 test = abs(e1 - e0)
end do
e1 = mod(e1, twopi)
if (e1 < 0.0d0) then
 e1 = e1 + twopi
endif 
eanom = e1
return
end function eanom

!-----------------------------------------------------------------------------

double precision function trueanom(m, e) 
!  Calculate the true anomaly of a Keplerian orbit with eccentricity e,
! from the mean anomaly, m.
!
! Uses: eanom
!
!  Input:
!   m - Mean anomaly in radians.
!   e - Eccentrcity, 0 <= e < 1.
!
! Output:
!   True anomaly in the range 0 to 2*PI.
!   If e is out-of-range return bad_dble
!  
implicit none
double precision,intent(in) :: m, e

! Local variables
double precision :: ee

if ( (e < 0.0d0).or.(e >= 1.0d0)) then
 print *, 'invalid eccentricity value in function trueanom'
 print *, e
 trueanom = bad_dble
 return
endif

ee = eanom(m,e)
trueanom = 2.0d0*atan(sqrt((1.0d0 + e)/(1.0d0 - e))*tan(ee/2.0d0))
return
end function trueanom

!-----------------------------------------------------------------------------

double precision function radvel(t, t0, p, v0, k, e, omrad) 
! Calculate radial velocity for a Keplerian orbit
!
! Uses: TRUEANOM
!
! Input:
!  T      - Time of observation
!  T0     - Time of periastron
!  P      - Orbital period
!  V0     - Systemic velocity
!  K      - Velocity semi-amplitude in the same units as V0
!  E      - Eccentricity of the orbit
!  OMRAD  - Longitude of periastron in radians.
!
!  Output:
!   Radial velocity in the same units as V0.
!
implicit none
double precision, intent(in) :: t, t0, p, v0, k, e, omrad

! Local variables
double precision :: m

m = twopi*mod((t-t0)/p,1.0d0)
if (e == 0.0d0) then
  radvel = v0 +k*cos(m+omrad)
  return
endif
if ( (e < 0.0d0).or.(e >= 1.0d0)) then
  print *, 'Invalid eccentricity value in function radvel'
  print *, e
  radvel = bad_dble
  return
endif

radvel = v0 + k*( e*cos(omrad) + cos(trueanom(m,e) + omrad))         
return
end function radvel

!------------------------------------------------------------------------------
double precision function t_ecl_to_peri(t_ecl, ecc, omega, incl, p_sid, verbose)
!
! Calculate the time of periastron passage immediately prior to a give time of
! eclipse. Equation numbers from Hilditch, "An Introduction to Close Binary
! Stars"
!
double precision, intent (in) :: t_ecl ! Time of eclipse
double precision, intent (in) :: ecc   ! Orbital eccentricity
double precision, intent (in) :: omega ! Longitude of periastron, radians
double precision, intent (in) :: incl  ! Orbital inclination, radians
double precision, intent (in) :: p_sid ! Siderial period
integer, intent (in) :: verbose
! Local variables
double precision :: theta, theta_0, delta_t, sin2i, efac, ee, eta, d
double precision, parameter :: tol = 1.0d-8
integer :: verbose1
integer, parameter :: npar = 4
double precision :: par(npar)

verbose1 = verbose_for_calls(verbose)
efac  = (1.0d0 - ecc**2)
sin2i = sin(incl)**2
! Value of theta for i=90 degrees
theta_0 = halfpi - omega ! True anomaly at superior conjunction
if (verbose >= v_debug) print *,'t_ecl_to_peri: theta_0 = ',theta_0
if (incl /= halfpi) then
 par = (/ efac, sin2i, omega, ecc /)
 d =  brent(theta_0-halfpi,theta_0,theta_0+halfpi, delta_func, npar, par, tol, &
            theta, verbose1)
else
  theta = theta_0
endif
if (verbose >= v_debug) print *,'t_ecl_to_peri: theta = ',theta

! (4.10)
if (theta == pi) then
  ee = pi
else
 ee = 2.0d0 * atan(sqrt((1.0d0-ecc)/(1.0d0+ecc)) * tan(theta/2.0d0))
endif
eta = ee - ecc*sin(ee)
delta_t = eta*p_sid/twopi
t_ecl_to_peri = t_ecl  - delta_t

end function t_ecl_to_peri

!------------------------------------------------------------------------------

double precision function delta_func(theta, npar, par, verbose)
implicit none
integer, intent(in)          :: npar, verbose
double precision, intent(in) :: theta, par(npar)
! Local variables
double precision :: efac, sin2i, omega, ecc

efac  = par(1)
sin2i = par(2)
omega = par(3)
ecc   = par(4)
delta_func = efac*sqrt(1.0d0 - sin2i*sin(theta+omega)**2)/(1.0d0+ecc*cos(theta))
if (verbose >= v_debug) print *,par,delta_func
end function delta_func

end module stellar

! This file is part of the ellc binary star model
! Copyright (C) 2016 Pierre Maxted
! 
! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

module ellc
!
! Binary star light curve model.
!
! HISTORY
! -------
! 30 Nov 2017
!  Added Correia (2014A&A...570L...5C) star shape model.
!
! 5 May 2017
!  Added option to send limb darkening law as an array of specific intensities 
!  on a uniform grid of mu values. 
!  
! 14 Sep 2016
!  Improved definitions and handling of coordinates - picked up some bugs
!  p.maxted@keele.ac.uk
!
! 21 Jul 2016
!  Corrected bug in rv() - remove calculation for iobs=0
!  Corrected bug in calculation of simplified reflection
!  p.maxted@keele.ac.uk
!
! 24 May 2016
!  Added function rv() for faster calculation of radial velocities when called
!  from python function ellc.rv() with option flux_weight=False.
!  Corrected bug with initialization of star sizes/shapes in eccentric orbits
!  p.maxted@keele.ac.uk
!
! May 2016
!  Changed definition of third light to something more sensible
!  Avoided stop if root polishing step fails in ell_ell_intersect - return
!  with fluxes/rv = bad_dble and set (new) flag bit b_ellc_fail
!  p.maxted@keele.ac.uk
!
! Feb 2016
! Corrected bug with uninitialised variables for partial eclipses
! Added simplified reflection effect
! p.maxted@keele.ac.uk
!
! Jan 2016
! First version 
! p.maxted@keele.ac.uk
!

use constants
use utils
use ellipse
use gauss_legendre
use stellar
use spots

implicit none
public

! Bit flags for return status flags.
integer, parameter :: b_ellc_eclipse        = 0 ! There is an eclipse
integer, parameter :: b_ellc_star1_eclipsed = 1 ! Star 1 is eclipsed by star 2
integer, parameter :: b_ellc_star2_eclipsed = 2 ! Star 2 is eclipsed by star 1
integer, parameter :: b_ellc_total          = 3 ! Eclipse is total
integer, parameter :: b_ellc_transit        = 4 ! Eclipse is a transit
integer, parameter :: b_ellc_double_partial = 5 ! Eclipse is "double-partial"
integer, parameter :: b_ellc_warn_spot_1    =11 ! Warning for spots on star 1
integer, parameter :: b_ellc_warn_spot_2    =12 ! Warning for spots on star 2
integer, parameter :: b_ellc_fail           =14 ! Calculation failed
integer, parameter :: b_ellc_warning        =15 ! Warnings were raised
integer, parameter :: b_ellc_error          =16 ! Invalid input

contains

function lc(n_obs,                & ! Number of observations
            input_times,          & ! Array of times/phases 
            binary_pars,          & ! Parameters of the binary system
            control_integers,     & ! Control integers
            spots_1, spots_2,     & ! Spot data
            n_mugrid_1, mugrid_1, & ! Limb darkening array, star 1
            n_mugrid_2, mugrid_2, & ! Limb darkening array, star 2
            verbose)              & ! Verbosity of printed output
            result(flux_rv_flag)
implicit none
integer, intent(in)   :: n_obs
!f2py integer, intent(hide), depend(input_times) :: n_obs = len(input_times)
double precision, intent(in)  :: input_times(n_obs)
!f2py integer, parameter :: n_par = 39
double precision, intent(in)  :: binary_pars(n_par)
!f2py integer, parameter :: n_ipar = 10
integer, intent(in)   :: control_integers(n_ipar)
double precision, intent(in) :: spots_1(:,:), spots_2(:,:)
!f2py integer, intent(hide), depend(mugrid_1) :: n_mugrid_1 = len(mugrid_1)
integer, intent(in)   :: n_mugrid_1
double precision, intent(in)  :: mugrid_1(n_mugrid_1)
!f2py integer, intent(hide), depend(mugrid_2) :: n_mugrid_2 = len(mugrid_2)
integer, intent(in)   :: n_mugrid_2
double precision, intent(in)  :: mugrid_2(n_mugrid_2)
integer, intent(in)   :: verbose
double precision :: flux_rv_flag(n_obs,6)
!
! INPUT:
! n_obs is number of observations.
! Input_times must be in days for light-time effect to be calculated correctly.
!
! Properties of the binary star are specified by the elements of
! binary_pars, as follows
!
! (1)  = T_0, apparent time of mid-eclipse for star 1 by star 2.
! (2)  = Anomalistic period (days or =1 for phased data).
! (3)  = Surface brightness ratio, S_2/S_1
! (4)  = Fractional radius of star 1, R_1/a
! (5)  = Fractional radius of star 2, R_2/a
! (6)  = Orbital inclination at time T_0 [degrees]
! (7)  = Third light contribution relative to apparent total flux at
!        time T_0 excluding eclipse effects.
! (8)  = Semi-major axis, a, in solar radii for calculation of 
!        light travel time, radial velocities and Doppler boosting.
!        (<= 0.0 to ignore)
! (9)  = sqrt(e).cos(omega) at time T_0
! (10) = sqrt(e).sin(omega) at time T_0
! (11) = Mass ratio m_2/m_1
! (12-15) = Limb darkening coefficients for star 1.
! (16-19) = Limb darkening coefficients for star 2
! (20) = Gravity darkening exponent for star 1 
! (21) = Gravity darkening exponent for star 2   
! (22) = Rate of change of inclination [degrees/anomalistic period]
! (23) = Apsidal motion rate  [degrees/siderial period]
! (24) = Asynchronous rotation factor for star 1, F_1
! (25) = Asynchronous rotation factor for star 2, F_2
! (26) = Doppler boosting factor, star 1 (=0.0 to ignore)
! (27) = Doppler boosting factor, star 2 (=0.0 to ignore)
! (28) = Heating+reflection coefficient of star 1
! (29) = Heating+reflection exponent, star 1.
! (30) = Heating+reflection linear limb darkening coefficient, star 1
! (31) = Heating+reflection coefficient of star 2
! (32) = Heating+reflection exponent, star 2.
! (33) = Heating+reflection linear limb darkening coefficient, star 2
! (34) = Sky-projected angle between orbital and rotation axes, star 1 [degrees]
! (35) = Sky-projected angle between orbital and rotation axes, star 2 [degrees]
! (36) = V_rot.sini for calculation of R-M effect for star 1 [km/s] - see notes
! (37) = V_rot.sini for calculation of R-M effect for star 2 [km/s] - see notes
! (38) = Fluid second Love number for radial displacement, h_f, star 1
! (39) = Fluid second Love number for radial displacement, h_f, star 1
!
! Calculation of the light curve is controlled by the elements of
! control_integers as follows
! (1)  = Grid size for numerical integration of fluxes, star 1
! (2)  = Grid size for numerical integration of fluxes, star 2
! (3)  = Number of spots on star 1 - see notes below
! (4)  = Number of spots on star 2 - see notes below
! (5)  = Limb darkening law for star 1 (see module stellar)
! (6)  = Limb darkening law for star 2 (see module stellar)
! (7)  = Model for shape of star 1 (see module stellar)
! (8)  = Model for shape of star 2 (see module stellar)
! (9)  = 0 to disable calculation of flux-weighted radial velocities
! (10) = Gravity darkening calculation - see notes below.
!
! Stellar radii
! -------------
!  The radius of a star is specified as the radius of a sphere with the same
!  volume as the ellipsoid that approximates the size and shape of the star
!  in the model (see module stellar). For stars defined by the Roche potential
!  only, the radius can be set =1 to select a star that fills its Roche lobe
!  (or its equivalent in the case of non-synchronous rotation).
!
! Output
! ------
!
! The results are returned in the array flux_rv_flag as follows.
! (1:n_obs,1) = Light curve
! (1:n_obs,2) = Flux of star 1
! (1:n_obs,3) = Flux of star 2
! (1:n_obs,4) = Radial velocity of star 1 [km/s] 
! (1:n_obs,5) = Radial velocity of star 2 [km/s] 
! (1:n_obs,6) = Flags
! 
! To test the bit flags b_ellc_... listed at the top of this module use
!  btest(int(flux_rv_flag(:,6)),<bit flag name>)
!
! Radial velocities are only calculated if semi-major axis is specified
! and period is not equal to 1. If control_integers(9) == 0 then these
! are centre-of-mass radial velocities, otherwise the flux-weighted radial
! velocities are calculated. 
! 
! For all times/phases where the input parameters are invalid the elements
! flux_rv_flag(:,1:5) are returned as bad_dble
!
! Light travel time
! -----------------
!  If the semi-major axis is > 0 then the effect of the light travel time 
!  across the orbit is included in the calculation of the star's positions. In
!  this case the parameter T_0 is the apparent time of primary eclipse, i.e.,
!  T_0 refers to the time of mid-eclipse (inferior conjunction)
!
! Heating and reflection
! ----------------------
!   Heating and reflection can be dealt with using either a detailed calculation
!  or a simplified analytical model.
!   For the detailed calculation, the brightness of each point on the stellar
!  surface that receives an irradiating flux is increased by an amount
!  F_0*H_0*(1/d_c**2)**H_1*(1-u_H*(1.d0-mu)), where
!   F_0 = flux from companion
!   d_c = distance from point on surface to companion
!   mu  = cos(viewing angle)
!  
!  The sharp edge of the irradiated region produces numerical noise in the
!  resulting lightcurve. This can be avoided using a simplified treatment of
!  reflection in which the flux from each star is modulated by an additional
!  term
!    H_0*F_0*r_c**2 * [(0.5+0.5*(sini*cos(theta))**2) + sini*cos(theta)],
!    where
!    F_0 = flux from companion
!    r_c = companion radius/separation
!    i   = inclination
!    theta = phase angle
!  To select simplified reflection set H_1 <= 0
!  Reflected light is eclipsed in proportion to the eclipsed fraction of the
!  light from each star.
!  Doppler boosting is not applied to reflected light.
!  sin^i factor not varied for di/dt.
!
!  To remove any calculation of reflection/heating set H_0 <= 0.
!  
! Rotation
! --------
!  The asynchronous rotation factors F_1 and F_2 are used to calculate the
! shapes of the stars (unless spherical stars are specified).
!  If V_rot.sini is 0 then F_1 or F_2 is used to calculate the projected 
! equatorial rotation velocity of star 1 or star 2, respectively, for the
! calculation of the flux-weighted radial velocity. Otherwise, the
! flux-weighted radial velocity of the star is calculated using the specified 
! value of V_rot.sini. 
!  Note that F_1 and F_2 are relative to the actual synchronous rotation rate
! (rotation period = orbital period) not pseudo-synchronous rotation rate.
!
! Star spots
! ----------
! spots_1(:,i) are the parameters for spot i on star 1.
! spots_2(:,i) are the parameters for spot i on star 2.
! The number of spots on each stars are given by control_integers(3:4).
! This can be less than the acual sizes of the arrays spots_1 and spots_2.
!
! See module file spots.f90 for the parameter definitions of a single spot
!  The effect of the spot on the light curve is calculated using the algorithm
! by Eker (1994ApJ...420..373E, 1994ApJ...430..438E) for circular spots on a
! spherical star with quadratic limb darkening. If the limb-darkening law used
! for the main calculation is not linear or quadratic then the coefficients of
! the limb-darkening law used for the calculation of the effects of the spots
! are set so that the intensity distribution matches at mu = 0, 0.5 and 1.
!
! ** N.B. ** The effect of each spot on the light curve is additive so
! overlapping spots can result in non-physical negative fluxes for some
! regions of the star.
!
! Limb darkening
! --------------
!   Limb darkening can be described either using one of the parametric forms
!   described in the module stellar, or as a tabulated grid of specific 
!   intensities. In the latter case, the limb darkening coefficients in 
!   binary_pars are not used. Instead, the specific intensity is determined by
!   linear interpolation between the values in the arrays mugrid_1 and 
!   mugrid_2. These are assumed to contain specific intensies on a uniform grid
!   of mu values from 0 (first element) to 1 (last element).
!   The tabulated limb darkening option is selected by setting the appropriate
!   value of control_integers to the value of ld_mugrid specified in the 
!   module constants. 
!   N.B. the arrays of specific intensies are assumed to be normalised, e.g., 
!   mugrid_1(n_mugrid_1) = 1, but this is not checked. 
!
! Volume calculation
! ------------------
!  In eccentric orbits, the volume of the star is assumed to be constant. In
!  general, the volume is calculated from the volume of the approximating
!  ellipsoid. In the case of synchronous rotation, the volume of the star can be
!  calculated using equation (2.18) from Kopal "Dynamics of Close Binary 
!  Systems" (Springer, 1978) by selecting the star model starshape_roche_v
!
! 
! Local variables
double precision :: radius1, radius2, sep, frot1, frot2,rlimit1,rlimit2
double precision :: qmass1,qmass2,flux01,flux02,incl_0,hf1,hf2,spar1,spar2
double precision :: ecc, omega_0
double precision :: abcd1(4),abcd2(4)
double precision, allocatable :: phi_rot_1(:), phi_rot_2(:)
double precision, allocatable ::  df_1(:,:), df_2(:,:)
double precision :: sbratio_0,anorm1,anorm2,eclipsed_area
!f2py integer, parameter :: n_ell_par = 14
double precision :: ellipse_1(n_ell_par),ellipse_2(n_ell_par)
double precision :: circle_1(n_ell_par),circle_2(n_ell_par)
integer, parameter :: nfpar=32
double precision, allocatable :: fpar1(:), fpar2(:)
integer :: nfpar1, nfpar2
double precision :: efac, phi_1, phi_2, spot_flux_1, spot_flux_2
double precision :: spot_ecl_flux_1, spot_ecl_flux_2
double precision :: spot_ecl_rv_1, spot_ecl_rv_2
double precision :: tperi0,p_anom,p_anom_s,incl,time,time_0,omdot
double precision :: mm,ee,r,r_1,r_2,cosi,sini,vsini1,vsini2,sini_0
double precision :: refl_1, refl_2, rfac_1, rfac_2, heat,heat2, l_3
double precision :: true_anomaly,cosnu,sinnu, dltte,sbfac_1,sbfac_2
double precision :: omega_1,true_anomaly_1,cosnu_1,sinnu_1,sinom1,cosom1
double precision :: omega_2,true_anomaly_2,cosnu_2,sinnu_2,sinom2,cosom2
double precision :: u1,v1,w1,u2,v2,w2,qfac1, qfac2,didt, wt,ecl_rv_1,ecl_rv_2
double precision :: uapp1,vapp1,uapp2,vapp2,a,spot_rv_1,spot_rv_2
double precision :: flux_1,flux_2,flux_3,rv1,rv2,vorb1,vorb2,rvflux_1,rvflux_2
double precision :: t1,t2,alite1,alite2,ecl_flux_1,ecl_flux_2,area_flags(2)
double precision :: avflux,fnorm, df, frac(2)
double precision :: ellipse_t(n_ell_par), xy_tng(2,2),ellipse_s(n_ell_par)
double precision :: lat_i, lon_i, lat_j, lon_j, gam_i, gam_j, fac_i, df1, df2
double precision :: qldc_1(2), qldc_2(2), tr(2,3), p_sid, phirot,r_spot
double precision :: ecl_area_tol
double precision :: u_s, v_s, w_s, alpha_s, beta_s, gamma_s ! Spot coords/size
logical :: dorv,dolite,dorvflux,large,sphere_1,sphere_2,exact_grav
logical :: ell_ell_fail
integer :: imodel1,imodel2, i_spot_calc, n_spot_calc,ldlaw_1,ldlaw_2
integer :: n_spot_1,n_spot_2,i_spot, j_spot, ifail, ii, verbose1, iiswitch
integer :: ngx1,ngx2,iobs,return_flags, return_flags_init, overlap, eclipse_type
integer, allocatable :: ii_1(:,:), ii_2(:,:)
double precision, parameter :: c_kms = iau_c*1.0d-3 ! Speed of light in km/s
! Fractional tolerance for radius calculations in function starshape()
double precision, parameter :: rtol = 1.0d-6
! Limits on beta_s for calculation of occulted spot area (radians).
double precision, parameter :: beta_s_lim = 1.0d-2
! Fraction limit on areas to avoid trying to calculate integrals on very small
! ellipse intersections
double precision, parameter :: atol = 1.0d-5

! Start

verbose1 = verbose_for_calls(verbose)
return_flags_init = 0 
frac(1:2) = 0
rv1 = not_set_dble
rv2 = not_set_dble
refl_1 = 0
refl_2 = 0
rfac_1 = 0
rfac_2 = 0

if (verbose >= v_user) then
  print *,'Start ellc:lc'
  print *,'N_obs  = ',n_obs
  print *,'t_obs(1)  = ',input_times(1)
  print *,'t_obs(N_obs)  = ',input_times(n_obs)
endif

! Some useful variables
time_0 = binary_pars(1)
p_anom = binary_pars(2)
p_anom_s = p_anom*86400.0d0
ecc = binary_pars(9)**2 + binary_pars(10)**2 
efac = sqrt((1.0d0+ecc)/(1.0d0-ecc))
if (ecc == 0.0d0) then
  omega_0 = 0.0d0
else
  omega_0 = atan2(binary_pars(10),binary_pars(9))
endif
incl_0 = binary_pars(6)*dtor
if (verbose >= v_user) then
  print *,'ellc: time_0 = ',time_0
  print *,'ellc: p_anom = ',p_anom
  print *,'ellc: e = ',real(ecc),'; omega_0 = ',omega_0,' radians'
endif
sini_0 = sin(incl_0) 
a = binary_pars(8)
radius1 = binary_pars(4)
radius2 = binary_pars(5) 
l_3 = binary_pars(7)
qmass1 = binary_pars(11) ! Mass of companion to star 1 w.r.t. m_1
qmass2 = 1.0d0/qmass1    ! Mass of companion to star 2 w.r.t. m_2
qfac2 = 1.0d0/(1.0d0+qmass1)
qfac1 = qmass1*qfac2
omdot = binary_pars(23)*dtor
p_sid = p_anom*(1.0d0 - omdot/twopi)  ! Siderial period
if ((omdot /= 0.0d0).and.(verbose >= v_user)) then
  print *,'ellc: omdot = ',omdot,' radians/(siderial period)'
  print *,'ellc: p_sid = ',p_sid
endif

imodel1 = control_integers(7)
imodel2 = control_integers(8)
sphere_1 =  (imodel1 == starshape_sphere)
sphere_2 =  (imodel2 == starshape_sphere)
if (imodel1 == starshape_love) then
  frot1 = 1
  hf1 = binary_pars(38)
  if ((hf1 <= 2/3.).or.(hf1 > 5)) then
    if (verbose > v_silent) then
      print *,'End ELLC - invalid value for h_f,1'
      print *,'h_f,1 = ',hf1
    endif
    return
  endif
  spar1 = hf1
  if (verbose >= v_user) then
    print *,'h_f,1 =',hf1
  endif
else
  frot1 = binary_pars(24)
  spar1 = frot1
  if (verbose >= v_user) then
    print *,'F_rot,1 =',frot1
  endif
endif

if (imodel2 == starshape_love) then
  frot2 = 1
  hf2 = binary_pars(39)
  if ((hf2 <= 2/3.).or.(hf2 > 5)) then
    if (verbose > v_silent) then
      print *,'End ELLC - invalid value for h_f,2'
      print *,'h_f,2 = ',hf2
    endif
    return
  endif
  spar2 = hf2
  if (verbose >= v_user) then
    print *,'h_f,2 =',hf2
  endif
else
  frot2 = binary_pars(25)
  spar2 = frot2
  if (verbose >= v_user) then
    print *,'F_rot,2 =',frot2
  endif
endif

if (verbose >= v_user) then
  print *,'Star 1, (H_0, H_1, u_H) = ', real(binary_pars(28:30))
  print *,'Star 2, (H_0, H_1, u_H) = ', real(binary_pars(31:33))
endif
ngx1 = control_integers(1)
ngx2 = control_integers(2)
if (verbose >= v_user) then
  print *,'Star 1: n_grid, shape = ',ngx1,starshape_name(imodel1)
  print *,'Star 2: n_grid, shape = ',ngx2,starshape_name(imodel2)
endif
n_spot_1 = control_integers(3)
n_spot_2 = control_integers(4)
ldlaw_1 = control_integers(5)
if (ldlaw_1 ==  ld_mugrid) then
  nfpar1 = nfpar + n_mugrid_1
  allocate(fpar1(nfpar1))
  ldlaw_1 = -n_mugrid_1
  fpar1(nfpar+1:nfpar1) = mugrid_1
  if (verbose >= v_user) then
    print *,'n_mugrid_1 = ',n_mugrid_1
    print *,'mugrid_1 = ',mugrid_1(1),' .. ',mugrid_1(n_mugrid_1)
  endif
else
  nfpar1 = nfpar
  allocate(fpar1(nfpar))
endif

ldlaw_2 = control_integers(6)
if (ldlaw_2 ==  ld_mugrid) then
  nfpar2 = nfpar + n_mugrid_2
  allocate(fpar2(nfpar2))
  ldlaw_2 = -n_mugrid_2
  fpar2(nfpar+1:nfpar2) = mugrid_2
  if (verbose >= v_user) then
    print *,'n_mugrid_2 = ',n_mugrid_2
    print *,'mugrid_2 = ',mugrid_2(1),' .. ',mugrid_2(n_mugrid_2)
  endif
else
  nfpar2 = nfpar
  allocate(fpar2(nfpar))
endif

didt = binary_pars(22)*dtor
! vorb1 = K1/sini, vorb2=K2/sini
vorb1 = 0
vorb2 = 0
alite1 = 0
alite2 = 0
dorv = .false.
dolite = .false.
! Semi-major axis in units of light-days
if (binary_pars(8) >  0.0d0) then
  alite1 = binary_pars(8)*qfac1 * solar_radius/iau_c/8.64d4
  alite2 = binary_pars(8)*qfac2 * solar_radius/iau_c/8.64d4
  ! Correction to T_0 for light travel time - see Borkovits et al., 
  !   2015MNRAS.448..946B, equation (25)
  dltte = alite2*sini_0*(qmass1-1.0d0)/(qmass1+1.0d0) & 
        * (1-ecc**2)/(1+ecc*sin(omega_0))
  time_0 = time_0 - dltte
  if (verbose >= v_user) then
    print *,'Light travel time correction to T_0 = ', real(dltte)
  endif


  dolite = .true.
! To test if a variable is set to 1, test against epsilon(0.) to avoid
! issues with user initialising using single-precision values.
  if (abs(p_anom-1.0d0) <  epsilon(0.)) then
    if (verbose >= v_warn) then
      print *,' WARNING: Semi-major axis given but period=1 (phased data?).'
      print *,' Radial velocity and Doppler boosting will NOT by calculated.'
    endif
    return_flags_init = ibset(return_flags_init,b_ellc_warning)
  else
    dorv = .true.
    vorb1 = a*qfac1/(solar_asini_kms_d*p_anom*sqrt(1-ecc**2))
    vorb2 = qmass2*vorb1

    if (verbose >= v_user) then
      print *,'K_1 = ',real(vorb1*sini_0),' km/s.'
      print *,'K_2 = ',real(vorb2*sini_0),' km/s.'
    endif
  endif
endif

! Check radii against roche lobe limits.
rlimit1 = roche_l1(qmass1,frot1)*(1.0d0-ecc)
if (radius1 == 1) then
  if (ecc > 0) then
    return_flags_init = ibset(return_flags_init,b_ellc_warning)
    if (verbose >= v_warn) then
      print *,'ellc: WARNING Star 1 set at limiting radius in eccentric binary'
      print *,'Radius will vary from = ',rlimit1*(1-ecc),' to ',rlimit1*(1+ecc)
    endif
  else
    if (verbose >= v_user) then
      print *,'Star 1 radius set at limit = ',rlimit1
    endif
  endif
else
  if (radius1 > rlimit1) then
    flux_rv_flag(1:n_obs,1:5) = bad_dble
    return_flags_init = ibset(return_flags_init,b_ellc_error)
    flux_rv_flag(1:n_obs,6) = return_flags_init
    if (verbose > v_silent) then
      print *,'End ELLC - star 1 exceeds limiting radius'
      print *,'radius1 = ',radius1
      print *,'rlimit1 = ',rlimit1
      print *,'q = m_2/m_1 = ',qmass1
      print *,'F_1 = ',frot1
      print *,'e = ',ecc
    endif
    return
  else
    if (verbose >= v_user) then
      print *,'Star 1 limiting radius= ',real(rlimit1)
    endif
  endif
endif
rlimit2 = roche_l1(qmass2,frot2)*(1.0d0-ecc)
if (radius2 == 1) then
  if (ecc > 0) then
    return_flags_init = ibset(return_flags_init,b_ellc_warning)
    if (verbose >= v_warn) then
      print *,'ellc: WARNING Star 2 set at limiting radius in eccentric binary'
      print *,'Radius will vary from = ',rlimit2*(1-ecc),' to ',rlimit2*(1+ecc)
    endif
  else
    if (verbose >= v_user) then
      print *,'Star 2 radius set at limit = ',real(rlimit2)
    endif
  endif
else
  if (radius2 > rlimit2) then
    flux_rv_flag(1:n_obs,1:5) = bad_dble
    return_flags_init = ibset(return_flags_init,b_ellc_error)
    flux_rv_flag(1:n_obs,6) = return_flags_init
    if (verbose > v_silent) then
      print *,'End ELLC - star 2 exceeds limiting radius'
      print *,'radius2 = ',radius2
      print *,'rlimit2 = ',rlimit2
      print *,'q = m_1/m_2 = ',qmass2
      print *,'F_2 = ',frot2
      print *,'e = ',ecc
    endif
    return
  else
    if (verbose >= v_user) then
      print *,'Star 2 limiting radius= ',real(rlimit2)
    endif
  endif
endif

dorvflux = (control_integers(9) /= 0).and.dorv

exact_grav = (control_integers(10) /= 0)

if (((imodel1 == starshape_roche_v).and.(frot1/=1.0d0)) .or. &
    ((imodel2 == starshape_roche_v).and.(frot2/=1.0d0)) ) then
  flux_rv_flag(1:n_obs,1:5) = bad_dble
  return_flags_init = ibset(return_flags_init,b_ellc_error)
  flux_rv_flag(1:n_obs,6) = return_flags_init
  if (verbose > v_silent) then
    print *,'End ELLC - roche_vol not enabled for non-synchronous rotation'
    print *,'F_rot,1 = ',frot1
    print *,'Shape_1 = ',starshape_name(imodel1)
    print *,'F_rot,2 = ',frot2
    print *,'Shape_2 = ',starshape_name(imodel2)
  endif
  return
endif

! Star spots
if (n_spot_1 > 0) then
  if (verbose >= v_user) then
    print *,'n_spot_1 = ',n_spot_1
  endif
  if (n_spot_1 > size(spots_1,2)) then
    flux_rv_flag(1:n_obs,1:5) = bad_dble
    return_flags_init = ibset(return_flags_init,b_ellc_error)
    flux_rv_flag(1:n_obs,6) = return_flags_init
    if (verbose > v_silent) then
      print *,'End ELLC - size(spots_1,2) < n_spot_1'
      print *,'size(spots_2),nspot_1 = ',size(spots_1,2),n_spot_1
    endif
    return
  endif
  if (size(spots_1,1) /= n_spot_par) then
    flux_rv_flag(1:n_obs,1:5) = bad_dble
    return_flags_init = ibset(return_flags_init,b_ellc_error)
    flux_rv_flag(1:n_obs,6) = return_flags_init
    if (verbose > v_silent) then
      print *,'End ELLC - spots_1 array wrong size'
      print *,'size(spots_1) = ',size(spots_1,1),size(spots_1,2)
    endif
    return
  endif

  if (ldlaw_1 < -1) then
    qldc_1(:) =  ld_quad_match(ldlaw_1, mugrid_1)
  else
    qldc_1(:) =  ld_quad_match(ldlaw_1, binary_pars(12:15))
  endif
  if (verbose >= v_user) then
    print *,'qldc_1 = ',qldc_1
  endif
  do i_spot = 2, n_spot_1
    lat_i = spots_1(i_spot_lat,i_spot)*dtor
    lon_i = spots_1(i_spot_lon,i_spot)*dtor
    gam_i = spots_1(i_spot_gam,i_spot)*dtor
    do j_spot = 1,i_spot-1
      lat_j = spots_1(i_spot_lat,j_spot)*dtor
      lon_j = spots_1(i_spot_lon,j_spot)*dtor
      gam_j = spots_1(i_spot_gam,j_spot)*dtor
      if(angular_distance(lon_i, lat_i, lon_j, lat_j) < (gam_i+gam_j)) then
        return_flags_init = ibset(return_flags_init,b_ellc_warning)
        if (verbose >= v_warn) then
          print *,'ellc: WARNING spots on star 1 overlap: ',i_spot,j_spot
        endif
      endif
    end do
  end do
endif

if (n_spot_2 > 0) then
  if (verbose >= v_user) then
    print *,'n_spot_2 = ',n_spot_2
  endif
  if (n_spot_2 > size(spots_2,2)) then
    flux_rv_flag(1:n_obs,1:5) = bad_dble
    return_flags_init = ibset(return_flags_init,b_ellc_error)
    flux_rv_flag(1:n_obs,6) = return_flags_init
    if (verbose > v_silent) then
      print *,'End ELLC - size(spots_2,2) < n_spot_2'
      print *,'size(spots_2),nspot_2 = ',size(spots_2,2),n_spot_2
    endif
    return
  endif
  if (size(spots_2,1) /= n_spot_par) then
    flux_rv_flag(1:n_obs,1:5) = bad_dble
    return_flags_init = ibset(return_flags_init,b_ellc_error)
    flux_rv_flag(1:n_obs,6) = return_flags_init
    if (verbose > v_silent) then
      print *,'End ELLC - input spots_2 array wrong size'
      print *,'size(spots_2) = ',size(spots_2,1),size(spots_2,2)
    endif
    return
  endif
  if (ldlaw_2 < -1) then
    qldc_2(:) =  ld_quad_match(ldlaw_2, mugrid_2)
  else
    qldc_2(:) =  ld_quad_match(ldlaw_2, binary_pars(16:19))
  endif
  if (verbose >= v_user) then
    print *,'qldc_2 = ',qldc_2
  endif
  do i_spot = 2, n_spot_2
    lat_i = spots_2(i_spot_lat,i_spot)*dtor
    lon_i = spots_2(i_spot_lon,i_spot)*dtor
    gam_i = spots_2(i_spot_gam,i_spot)*dtor
    do j_spot = 1,i_spot-1
      lat_j = spots_2(i_spot_lat,j_spot)*dtor
      lon_j = spots_2(i_spot_lon,j_spot)*dtor
      gam_j = spots_2(i_spot_gam,j_spot)*dtor
      if(angular_distance(lon_i, lat_i, lon_j, lat_j) < (gam_i+gam_j)) then
        return_flags_init = ibset(return_flags_init,b_ellc_warning)
        if (verbose >= v_warn) then
          print *,'ellc: WARNING spots on star 2 overlap: ',i_spot,j_spot
        endif
      endif
    end do
  end do
endif

if ((n_spot_1+n_spot_2) > 0) then 

  if (verbose >= v_debug) print *,'ellc: n_spot_1,2 = ',n_spot_1,n_spot_2
  allocate(phi_rot_1(n_obs))
  allocate(phi_rot_2(n_obs))
  allocate(df_1(n_obs, n_spot_1))
  allocate(df_2(n_obs, n_spot_2))
  allocate(ii_1(n_obs, n_spot_1))
  allocate(ii_2(n_obs, n_spot_2))

  if (didt /= 0 ) then
    return_flags_init = ibset(return_flags_init,b_ellc_warning)
    if (verbose >= v_warn) then
      print *,'ellc: WARNING di/dt not implemented for spots '
    endif
  endif

  do i_spot = 1, n_spot_1
    lat_i = spots_1(i_spot_lat,i_spot)*dtor
    lon_i = spots_1(i_spot_lon,i_spot)*dtor
    gam_i = spots_1(i_spot_gam,i_spot)*dtor
    fac_i = spots_1(i_spot_fac,i_spot)
    if (verbose >= v_user) then
      print '(a,I4,3f10.4)',' ellc: spot on star 1',i_spot,lat_i,lon_i,gam_i
    endif
    phi_rot_1(:) = twopi*(input_times(:)-time_0)/p_anom*frot1
    call eker(lon_i,lat_i,incl_0,gam_i,fac_i,qldc_1(1),qldc_1(2),phi_rot_1, &
              n_obs,df_1(:,i_spot),ii_1(:,i_spot), ifail)
    if (ifail /= 0) then
      if (verbose > v_silent) then
        print *,'ellc: Error calling eker for spot on star 1, ifail = ',ifail
      endif
      flux_rv_flag(1:n_obs,1:5) = bad_dble
      return_flags_init = ibset(return_flags_init,b_ellc_error)
      flux_rv_flag(1:n_obs,6) = return_flags_init
      return
    endif
  end do

  do i_spot = 1, n_spot_2
    lat_i = spots_2(i_spot_lat,i_spot)*dtor
    lon_i = spots_2(i_spot_lon,i_spot)*dtor + pi
    gam_i = spots_2(i_spot_gam,i_spot)*dtor
    fac_i = spots_2(i_spot_fac,i_spot)
    if (verbose >= v_user) then
      print '(a,I4,3f10.4)',' ellc: spot on star 2',i_spot,lat_i,lon_i,gam_i
    endif
    phi_rot_2(:) = twopi*(input_times(:)-time_0)/p_anom*frot2
    call eker(lon_i,lat_i,incl_0,gam_i,fac_i,qldc_2(1),qldc_2(2),phi_rot_2, &
              n_obs,df_2(:,i_spot),ii_2(:,i_spot), ifail)
    if (ifail /= 0) then
      if (verbose > v_silent) then
        print *,'ellc: Error calling eker for spot on star 2, ifail = ',ifail
      endif
      flux_rv_flag(1:n_obs,1:5) = bad_dble
      return_flags_init = ibset(return_flags_init,b_ellc_error)
      flux_rv_flag(1:n_obs,6) = return_flags_init
      return
    endif
  end do

endif

! Time of periastron passage prior to time_0 via eccentric anomaly
tperi0 = t_ecl_to_peri(time_0, ecc, omega_0, incl_0, p_sid, verbose)
if (verbose >= v_user) print *,'Reference time of periastron = ', real(tperi0)

! Calculate star shapes at time T_0.
if (verbose.ge.v_user) print *,'Star shapes at time/phase = ', real(time_0)
mm = twopi*mod(1.0d0+mod((time_0-tperi0)/p_anom,1.0d0),1.0d0)
ee = eanom(mm,ecc)
r = 1.0d0 - ecc*cos(ee)
abcd1 = starshape(radius1, r, spar1, ecc, qmass1, imodel1, rtol, verbose1)
if(abcd1(1) == bad_dble) then
 flux_rv_flag(1:n_obs,1:5) = bad_dble
 return_flags_init = ibset(return_flags_init,b_ellc_error)
 flux_rv_flag(1:n_obs,6) = return_flags_init
 if (verbose > v_silent) print *,'End ELLC - error calling starshape'
 return
endif
if (verbose >= v_user) print '(A,4F9.5)',' starshape: A1,B1,C1,D1 = ',abcd1

abcd2 = starshape(radius2, r, spar2, ecc, qmass2, imodel2, rtol, verbose1)
if(abcd2(1) == bad_dble) then
 flux_rv_flag(1:n_obs,1:5) = bad_dble
 return_flags_init = ibset(return_flags_init,b_ellc_error)
 flux_rv_flag(1:n_obs,6) = return_flags_init
 if (verbose > v_silent) print *,'End ELLC - error calling starshape'
 return
endif
if (verbose >= v_user) print '(A,4F9.5)',' starshape: A2,B2,C2,D2 = ',abcd2

! Rotation
if (dorv) then
  if (binary_pars(36) == 0.0d0) then
    vsini1 = frot1*twopi*abcd1(2)*a*solar_radius/1d3/(p_anom*8.64d4)*sini_0
  else
    vsini1 = binary_pars(36)
  endif 
  if (binary_pars(37) == 0.0d0) then
    vsini2 = frot2*twopi*abcd2(2)*a*solar_radius/1d3/(p_anom*8.64d4)*sini_0
  else
    vsini2 = binary_pars(37)
  endif 
  if (verbose >= v_user) then
    print *,'V_rot,1.sini = ',real(vsini1),' km/s.'
    print *,'V_rot,2.sini = ',real(vsini2),' km/s.'
  endif
else
  vsini1 = 0.0d0
  vsini2 = 0.0d0
endif

! Project ellipsoids onto sky for an observer viewing the stars face-on.
! For spherical stars, projecting the sphere causes numerical issues because
! the orientation of the axes is undefined, so calculate this case directly and
! save the result for later use.
if (sphere_1) then
  ellipse_1 = ell_init_from_par([radius1,radius1,0.0d0,0.0d0,0.0d0])
  circle_1(:) = ellipse_1(:)
else
  ellipse_1 =  ell_project_ellipsoid(abcd1(1:3),phi=0.0d0,incl=halfpi)
endif
if (sphere_2) then
  ellipse_2 = ell_init_from_par([radius2,radius2,0.0d0,0.0d0,0.0d0])
  circle_2(:) = ellipse_2(:)
else
  ellipse_2 =  ell_project_ellipsoid(abcd2(1:3),phi=0.0d0,incl=halfpi)
endif
if (verbose >= v_debug) then
  print *,' Ellipses for initialisation [a_p, b_p, x_c, y_c, phi]'
  print *,'ellipse_1 = ',real(ellipse_1(i_ell_ellpar))
  print *,'ellipse_2 = ',real(ellipse_2(i_ell_ellpar))
endif

! Setup parameters to be passed to bright() - ignoring heating for this step
fpar1(1) = 1.0d0
fpar1(2:5) = abcd1(1:4)
fpar1(6) = halfpi ! incl
fpar1(7) = 0.0d0 ! phi
fpar1(8) = r
fpar1(9) = ldlaw_1
fpar1(10:13) = binary_pars(12:15)  ! Limb darkening coeffs
if (exact_grav) then
  fpar1(14) = qmass1
  fpar1(15) = droche(qmass1,x=0.0d0,y=0.0d0,z=abcd1(3),d=r,f=frot1)
  fpar1(16) = frot1
  fpar1(27) = roche(abcd1(1)+abcd1(4),0.0d0,0.0d0,q=qmass1,d=r,f=frot1)
else
  fpar1(14:16) = gmodel_coeffs(abcd1, r, frot1, qmass1,  verbose1)
  fpar1(27) = 0 ! .not.exact_grav
endif
fpar1(17) = binary_pars(20) ! Gravity darkening coefficient, star 1
fpar1(18:22) =0.0d0 ! Heating/reflection model parameters
fpar1(23) = binary_pars(34)*dtor ! lambda_1
fpar1(24) = vsini1 ! V_rot,sini
fpar1(25) = binary_pars(26)  ! kboost
fpar1(26) = 0.0d0    ! rvflag
fpar1(28:31) =0.0d0 ! Coordinate transformation
fpar1(32) = 0  ! Disable coordinate transformation

! Integrating unitfunc (=1) gives the area of an ellipse calcuated by
! numerical integration. This can be compared to the real area of an 
! ellipse to get a correction factor (anorm1, anorm2). This is a function
! of the integration grid size and shape only, so these factors only need
! to be calculated once.
anorm1 = ellgauss(ellipse_1(i_ell_a_p),ellipse_1(i_ell_b_p),ngx1,unitfunc, &
                  nfpar1,fpar1,verbose1)
flux01 = ellgauss(ellipse_1(i_ell_a_p),ellipse_1(i_ell_b_p),ngx1,bright, &
                  nfpar1,fpar1,verbose1)
sbfac_1 = flux01/anorm1
anorm1 = anorm1/ellipse_1(i_ell_area)
flux01 = flux01/anorm1
if (verbose >= v_user) then
  print *,'anorm1 = ',real(anorm1)
  print *,'flux_0,1 = ',real(flux01)
  print *,'S_0,1 = ',real(sbfac_1)
endif

fpar2(1) = 1.0d0
fpar2(2:5) = abcd2(1:4)
fpar2(6) = halfpi! incl
fpar2(7) = 0.0d0 ! phi
fpar2(8) = r
fpar2(9) = ldlaw_2
fpar2(10:13) = binary_pars(16:19)  ! Limb darkening coeffs
if (exact_grav) then
  fpar2(14) = qmass2
  fpar2(15) = droche(qmass2,x=0.0d0,y=0.0d0,z=abcd2(3),d=r,f=frot2)
  fpar2(16) = frot2
  fpar2(27) = roche(abcd2(1)+abcd2(4),0.0d0,0.0d0, q=qmass2,d=r,f=frot2)
else
  fpar2(14:16) = gmodel_coeffs(abcd2, r, frot2, qmass2,  verbose1)
  fpar2(27) = 0 ! .not.exact_grav
endif
fpar2(17) = binary_pars(21) ! Gravity darkening coefficient, star 2
fpar2(18:22) =0.0d0 ! Heating/reflection model parameters
fpar2(23) = binary_pars(35)*dtor ! lambda_2
fpar2(24) = vsini2 ! V_rot,sini
fpar2(25) = binary_pars(27)  ! kboost
fpar2(26) =0.0d0    ! rvflag
fpar2(28:31) =0.0d0 ! Coordinate transformation
fpar2(32) = 0  ! Disable coordinate transformation

anorm2 = ellgauss(ellipse_2(i_ell_a_p),ellipse_2(i_ell_b_p),ngx2,unitfunc, &
                  nfpar2,fpar2,verbose1)
flux02 = ellgauss(ellipse_2(i_ell_a_p),ellipse_2(i_ell_b_p),ngx2,bright, &
                  nfpar2,fpar2,verbose1)
sbfac_2 = flux02/anorm2
anorm2 = anorm2/ellipse_2(i_ell_area)
flux02 = flux02/anorm2 
if (verbose >= v_user) then
  print *,'anorm2 = ',real(anorm2)
  print *,'flux_0,2 = ',real(flux02)
  print *,'S_0,2 = ',real(sbfac_2)
endif

! Surface brightness ratio at the centre of the stellar discs such that
! the average surface brightness on the hemisphere of the stars facing the
! companion is equal to the desired input value 
sbratio_0 = binary_pars(3) * sbfac_1/sbfac_2 
if (verbose >= v_user) then
  print *,'sbratio_0 = ',sbratio_0
endif
flux02 = flux02*sbratio_0
fpar2(1) = sbratio_0

! Add reflection effect parameters to fpar1/fpar2 if detailed reflection is
! being used.
if (binary_pars(29) > 0.0d0) then
  fpar1(19:21) = binary_pars(28:30)
  fpar1(18) = flux02
  fpar1(22) = radius2
elseif (binary_pars(28) > 0.0d0) then
  rfac_1 = flux02*binary_pars(28)*radius1**2
endif
if (binary_pars(32) > 0.0d0) then
  fpar2(19:21) = binary_pars(31:33)
  fpar2(18) = flux01
  fpar2(22) = radius1
elseif (binary_pars(31) > 0.0d0) then
  rfac_2 = flux01*binary_pars(31)*radius2**2 
endif

if (verbose >= v_user) print *,'Starting main calculation loop'

! Start main loop

do iobs=0,n_obs

  return_flags = return_flags_init 

  ! Note that we start at iobs=0 and use this zero-th iteration of the loop
  ! to calculate normalisation factor.
  if (iobs == 0) then
    time = time_0
  else
    time = input_times(iobs)
  endif

  if (verbose >= v_debug) then
    if (iobs > 0) then 
      print *,'time',input_times(iobs)
    else
      print *,'time_0',time_0
    endif
  endif

  ! Calculate positions of stars in their orbits 
  mm = twopi*mod(1.0d0+mod((time-tperi0)/p_anom,1.0d0),1.0d0)
  ee = eanom(mm,ecc)
  r = 1.0d0 - ecc*cos(ee)
  true_anomaly = 2.0d0*atan(efac*tan(ee/2.0d0))
  cosnu = cos(true_anomaly) 
  sinnu = sin(true_anomaly) 
  ! Calculate apparent positions of stars' centres-of-mass on the sky.
  incl = incl_0 + (time-time_0)*didt
  cosi = cos(incl)
  sini = sin(incl)
  omega_1 = mod(omega_0 + (time-time_0)*omdot/p_sid, twopi)
  cosom1 = cos(omega_1) 
  sinom1 = sin(omega_1) 
  omega_2 = mod(omega_1+pi,twopi)
  cosom2 = -cosom1
  sinom2 = -sinom1
  w1 = -r*sini*(sinnu*cosom1+cosnu*sinom1)*qfac1
  w2 = -r*sini*(sinnu*cosom2+cosnu*sinom2)*qfac2
  ! Light travel time correction
  if (dolite) then
    t1 = time + alite1*w1
    if (verbose >= v_debug) print '(A,E12.4)',' LTTE star 1 = ',alite1*w1
    mm = twopi*mod((t1-tperi0)/p_anom,1.0d0)
    ee = eanom(mm,ecc)
    r_1 = 1.0d0 - ecc*cos(ee)
    true_anomaly_1 = 2.0d0*atan(efac*tan(ee/2.0d0))
    cosnu_1 = cos(true_anomaly_1) 
    sinnu_1 = sin(true_anomaly_1) 
    t2 = time + alite2*w2
    if (verbose >= v_debug) print '(A,E12.4)',' LTTE star 2 = ',alite2*w2
    mm = twopi*mod((t2-tperi0)/p_anom,1.0d0)
    ee = eanom(mm,ecc)
    r_2 = 1.0d0 - ecc*cos(ee)
    true_anomaly_2 = 2.0d0*atan(efac*tan(ee/2.0d0))
    cosnu_2 = cos(true_anomaly_2) 
    sinnu_2 = sin(true_anomaly_2) 
  else
    r_1 = r
    true_anomaly_1 = true_anomaly
    cosnu_1 = cosnu
    sinnu_1 = sinnu 
    r_2 = r
    true_anomaly_2 = true_anomaly
    cosnu_2 = cosnu
    sinnu_2 = sinnu 
  endif
  ! Centre-of-mass positions on sky
  u1 = r_1*(cosnu_1*cosom1-sinnu_1*sinom1)*qfac1
  v1 = r_1*cosi*(sinnu_1*cosom1+cosnu_1*sinom1)*qfac1
  u2 = r_2*(cosnu_2*cosom2-sinnu_2*sinom2)*qfac2
  v2 = r_2*cosi*(sinnu_2*cosom2+cosnu_2*sinom2)*qfac2
  ! Centre-of-mass radial velocities
  if (dorv) then
    rv1 = vorb1*sini*(cos(true_anomaly_1+omega_1)+ecc*cosom1)
    rv2 = vorb2*sini*(cos(true_anomaly_2+omega_2)+ecc*cosom2)
  endif

  if (ecc > 0.0d0) then ! Re-calculate star shapes

    abcd1 = starshape(radius1, r_1, spar1, ecc, qmass1, imodel1, rtol, verbose1)
    if (verbose >= v_debug) print '(A,4F9.5)',' starshape: A1,B1,C1,D1 = ',abcd1
    if(abcd1(1) == bad_dble) then
      flux_rv_flag(iobs,1:5) = bad_dble
      return_flags = ibset(return_flags,b_ellc_error)
      flux_rv_flag(iobs,6) = return_flags
      if (verbose > v_silent) print *, 'End ELLC - error calling starshape'
      cycle
    endif
    fpar1(2:5) = abcd1(1:4)
    if (exact_grav) then
      fpar1(15) = droche(qmass1,x=0.0d0,y=0.0d0,z=abcd1(3),d=r,f=frot1)
      fpar1(27) = roche(abcd1(1)+abcd1(4),0.0d0,0.0d0, q=qmass1,d=r,f=frot1)
    else
      fpar1(14:16) = gmodel_coeffs(abcd1, r, frot1, qmass1,  verbose1)
    endif

    abcd2 = starshape(radius2, r_2, spar2, ecc, qmass2, imodel2, rtol, verbose1)
    if (verbose >= v_debug) print '(A,4F9.5)',' starshape: A2,B2,C2,D2 = ',abcd2
    if(abcd2(1) == bad_dble) then
      flux_rv_flag(iobs,1:5) = bad_dble
      return_flags = ibset(return_flags,b_ellc_error)
      flux_rv_flag(iobs,6) = return_flags
      if (verbose > v_silent) print *, 'End ELLC - error calling starshape'
      cycle
    endif
    fpar2(2:5) = abcd2(1:4)
    if (exact_grav) then
      fpar2(15) = droche(qmass2,x=0.0d0,y=0.0d0,z=abcd2(3),d=r,f=frot2)
      fpar2(27) = roche(abcd2(1)+abcd2(4),0.0d0,0.0d0, q=qmass2,d=r,f=frot2)
    else
      fpar2(14:16) = gmodel_coeffs(abcd2, r, frot2, qmass2,  verbose1)
    endif

  endif

  ! Apparent positions of centres of ellipsoids
  sep = r_1*qfac1-abcd1(4)+r_2*qfac2-abcd2(4)
  uapp1 = u1*(r_1-abcd1(4))/r_1
  vapp1 = v1*(r_1-abcd1(4))/r_1
  uapp2 = u2*(r_2-abcd2(4))/r_2
  vapp2 = v2*(r_2-abcd2(4))/r_2
  phi_1 = mod(twopi+true_anomaly_1+omega_1-halfpi,twopi)
  phi_2 = mod(twopi+true_anomaly_2+omega_2-halfpi,twopi)

  ! Project ellipsoids onto the sky (no need to re-project spheres)
  if (.not.sphere_1) then
    ellipse_1 =  ell_project_ellipsoid(abcd1(1:3),phi_1,incl)
  endif
  if (.not.sphere_2) then
    ellipse_2 =  ell_project_ellipsoid(abcd2(1:3),phi_2,incl)
  endif

  ! Translate ellipses to apparent positions of stars on the sky
  if (sphere_1) then
    ellipse_1 = ell_move(uapp1, vapp1, circle_1)
  else 
    ellipse_1 = ell_move(uapp1, vapp1, ellipse_1)
  endif
  if (sphere_2) then
    ellipse_2 = ell_move(uapp2, vapp2, circle_2)
  else
    ellipse_2 = ell_move(uapp2, vapp2, ellipse_2)
  endif

  if (verbose >= v_debug) then
    print *,'ellpar1',ellipse_1(i_ell_ellpar)
    print *,'ellpar2',ellipse_2(i_ell_ellpar)
    print *,'area1',ellipse_1(i_ell_area)
    print *,'area2',ellipse_2(i_ell_area)
  endif
  ! Minimum area for integration
  ecl_area_tol = atol*min(ellipse_1(i_ell_area),ellipse_2(i_ell_area))

  fpar1(6) = incl
  fpar1(7) = phi_1
  fpar1(8) = r
  fpar1(32) = 0 ! Disable coordinate transformation
  flux_1 = ellgauss(ellipse_1(i_ell_a_p),ellipse_1(i_ell_b_p),ngx1,bright, &
                   nfpar1,fpar1,verbose1) / anorm1
  if (dorvflux) then
    fpar1(26) = 1  ! rvflag
    rvflux_1 = ellgauss(ellipse_1(i_ell_a_p),ellipse_1(i_ell_b_p),ngx1, &
                        bright,nfpar1,fpar1,verbose1) / anorm1
    fpar1(26) =0  ! rvflag
  else
    rvflux_1 =0.0d0 
  endif

  fpar2(6) = incl
  fpar2(7) = phi_2
  fpar2(8) = r
  fpar2(32) = 0 ! Disable coordinate transformation
  flux_2 = ellgauss(ellipse_2(i_ell_a_p),ellipse_2(i_ell_b_p),ngx2,bright, &
                   nfpar2,fpar2,verbose1) / anorm2
  if (dorvflux) then
    fpar2(26) = 1  ! rvflag
    rvflux_2 = ellgauss(ellipse_2(i_ell_a_p),ellipse_2(i_ell_b_p),ngx2, &
                        bright,nfpar2,fpar2,verbose1) / anorm1
    fpar2(26) =0  ! rvflag
  else
    rvflux_2 =0.0d0 
  endif

  ! Test for eclipses
  if (iobs > 0) then

    area_flags = ell_ell_overlap(ellipse_1, ellipse_2, verbose1)
    eclipsed_area = area_flags(1)
    overlap = int(area_flags(2))
    if (btest(overlap,b_ell_error)) then
      if (verbose >= v_warn) then
        print *,'ellc: calculation failed for observations no.',iobs
      endif
      flux_rv_flag(iobs,1:5) = bad_dble
      flux_rv_flag(iobs,6) = b_ellc_fail
      cycle
    endif
    if (btest(overlap,b_ell_warn_inaccurate)) then
      return_flags = ibset(return_flags,b_ellc_warning)
      if (verbose >= v_warn) then
        print *,'ellc: warning from ell_ell_overlap, obs. no.',iobs
      endif
    endif

    if (verbose >= v_debug) then
      print *,'ellc: overlap area = ',eclipsed_area
      print *,'ellc: overlap type = ',overlap
    endif

    if (eclipsed_area < ecl_area_tol) then
      if (verbose >= v_debug) then
        print *,'ellc: Eclipsed area less then tolerance',ecl_area_tol
        print *,'ellc: Setting eclipsed_area to 0 '
      endif
      eclipsed_area = 0
      overlap = ibset(0,b_ell_no_overlap)
    endif

    ecl_flux_1 = 0
    ecl_flux_2 = 0
    ecl_rv_1 = 0
    ecl_rv_2 = 0
    eclipse_type = 0
    if (btest(overlap,b_ell_no_overlap)) then
      continue
    else
      eclipse_type = ibset(eclipse_type,b_ellc_eclipse)
      if (w1 > w2) then 
        eclipse_type = ibset(eclipse_type,b_ellc_star2_eclipsed)
      else
        eclipse_type = ibset(eclipse_type,b_ellc_star1_eclipsed)
      endif

      if (btest(overlap,b_ell_1_inside_2)) then
        if (w1 > w2) then 
          eclipse_type = ibset(eclipse_type,b_ellc_transit)
        else
          eclipse_type = ibset(eclipse_type,b_ellc_total)
        endif
      else if (btest(overlap,b_ell_2_inside_1)) then
        if (w1 > w2) then 
          eclipse_type = ibset(eclipse_type,b_ellc_total)
        else
          eclipse_type = ibset(eclipse_type,b_ellc_transit)
        endif
      else if (btest(overlap,b_ell_identical)) then
        eclipse_type = ibset(eclipse_type,b_ellc_total)
        if (verbose >= v_debug) then
          print *,'ellc: b_ell_identical'
        endif
      else if (btest(overlap,b_ell_four_intersects)) then
        eclipse_type = ibset(eclipse_type,b_ellc_double_partial)
      endif

    endif

    return_flags = ior(return_flags,eclipse_type) 

    ! Calculation of flux loss due to each eclipse type
    if (btest(eclipse_type, b_ellc_eclipse)) then

      if (btest(eclipse_type, b_ellc_total)) then

        continue ! This case will be done after calculation of spot modulation

      else if(btest(eclipse_type, b_ellc_transit)) then

        if(btest(eclipse_type,b_ellc_star1_eclipsed)) then
          ! Integrate surface brightness of star 1 over area of star 2
          fpar1(28) = ellipse_2(i_ell_x_c)-ellipse_1(i_ell_x_c) 
          fpar1(29) = ellipse_2(i_ell_y_c)-ellipse_1(i_ell_y_c) 
          fpar1(30) = cos(ellipse_1(i_ell_phi)-ellipse_2(i_ell_phi))
          fpar1(31) = sin(ellipse_1(i_ell_phi)-ellipse_2(i_ell_phi))
          fpar1(32) = 1 ! Enable coordinate transformation
          ecl_flux_1=ellgauss(ellipse_2(i_ell_a_p), ellipse_2(i_ell_b_p),  &
          ngx1, bright, nfpar1, fpar1, verbose1)/anorm1
          if (dorvflux) then
            fpar1(26) = 1.0d0  ! rvflag
            ecl_rv_1 = ellgauss(ellipse_2(i_ell_a_p), ellipse_2(i_ell_b_p),  &
            ngx1,bright, nfpar1, fpar1, verbose1)/anorm1
            fpar1(26) =0.0d0  ! rvflag
          endif
        else
          ! Integrate surface brightness of star 2 over area of star 1
          fpar2(28) = ellipse_1(i_ell_x_c)-ellipse_2(i_ell_x_c) 
          fpar2(29) = ellipse_1(i_ell_y_c)-ellipse_2(i_ell_y_c)
          fpar2(30) = cos(ellipse_2(i_ell_phi)-ellipse_1(i_ell_phi))
          fpar2(31) = sin(ellipse_2(i_ell_phi)-ellipse_1(i_ell_phi))
          fpar2(32) = 1 ! Enable coordinate transformation
          ecl_flux_2=ellgauss(ellipse_1(i_ell_a_p), ellipse_1(i_ell_b_p),  &
          ngx2,bright, nfpar2, fpar2, verbose1)/anorm2
          if (dorvflux) then
            fpar2(26) = 1.0d0  ! rvflag
            ecl_rv_2 = ellgauss(ellipse_1(i_ell_a_p), ellipse_1(i_ell_b_p),  &
            ngx2,bright, nfpar2, fpar2, verbose1)/anorm2
            fpar2(26) =0.0d0  ! rvflag
          endif
        endif

      else if (btest(eclipse_type,b_ellc_double_partial)) then

        if(btest(eclipse_type, b_ellc_star1_eclipsed)) then
          avflux = double_partial(ellipse_1, ellipse_2, ngx1, fpar1, nfpar1, & 
           verbose=verbose1) 
          ecl_flux_1 = flux_1 - (ellipse_1(i_ell_area)-eclipsed_area)*avflux
          if (dorvflux) then
            fpar1(26) = 1.0d0  ! rvflag
            avflux = double_partial(ellipse_1, ellipse_2, ngx1, fpar1, & 
             nfpar1, verbose=verbose1) 
            ecl_rv_1 = rvflux_1 - (ellipse_1(i_ell_area)-eclipsed_area)*avflux
            fpar1(26) =0.0d0  ! rvflag
          endif

        else 
          avflux = double_partial(ellipse_2, ellipse_1, ngx2, fpar2, nfpar2, & 
           verbose=verbose1) 
          ecl_flux_2 = flux_2 - (ellipse_2(i_ell_area)-eclipsed_area)*avflux 
          if (dorvflux) then
            fpar2(26) = 1.0d0  ! rvflag
            avflux = double_partial(ellipse_2, ellipse_1, ngx2, fpar2, & 
             nfpar2, verbose=verbose1) 
            ecl_rv_2 = rvflux_2 - (ellipse_2(i_ell_area)-eclipsed_area)*avflux
            fpar2(26) =0.0d0  ! rvflag
          endif
        endif

      else   ! Partial eclipses.

        if(btest(eclipse_type, b_ellc_star1_eclipsed)) then

          if (eclipsed_area < (0.5d0*ellipse_1(i_ell_area))) then

            if (verbose >= v_debug) then
              print *,'ellc: b_ellc_star1_eclipsed, integrate_eclipsed=.true.'
            endif
            ecl_flux_1 = partial(ellipse_1, ellipse_2, ngx1, fpar1, nfpar1, & 
            integrate_eclipsed=.true.,verbose=verbose1) *eclipsed_area
            if (dorvflux) then
              fpar1(26) = 1.0d0  ! rvflag
              ecl_rv_1 =  partial(ellipse_1, ellipse_2, ngx1, fpar1, nfpar1, & 
              integrate_eclipsed=.true.,verbose=verbose1) *eclipsed_area
              fpar1(26) =0.0d0  ! rvflag
            endif

          else 

            if (verbose >= v_debug) then
              print *,'ellc: b_ellc_star1_eclipsed, integrate_eclipsed=.false.'
            endif
            avflux = partial(ellipse_1, ellipse_2, ngx1, fpar1, nfpar1, & 
            integrate_eclipsed=.false.,verbose=verbose1)
            ecl_flux_1 = flux_1 - (ellipse_1(i_ell_area)-eclipsed_area)*avflux
            if (dorvflux) then
              fpar1(26) = 1.0d0  ! rvflag
              avflux = partial(ellipse_1, ellipse_2, ngx1, fpar1, nfpar1, & 
              integrate_eclipsed=.false.,verbose=verbose1)
              ecl_rv_1 = rvflux_1 - (ellipse_1(i_ell_area)-eclipsed_area)*avflux
              fpar1(26) =0.0d0  ! rvflag
            endif

          endif

        else ! Star 2 is eclipsed

          if (eclipsed_area < (0.5d0*ellipse_2(i_ell_area))) then
            if (verbose >= v_debug) then
              print *,'ellc: b_ellc_star2_eclipsed, integrate_eclipsed=.true.'
            endif
            avflux = partial(ellipse_2, ellipse_1, ngx2, fpar2, nfpar2, & 
            integrate_eclipsed=.true.,verbose=verbose1)
            ecl_flux_2 =  eclipsed_area*avflux
            if (dorvflux) then
              fpar2(26) = 1.0d0  ! rvflag
              avflux = partial(ellipse_2, ellipse_1, ngx2, fpar2, nfpar2, & 
              integrate_eclipsed=.true.,verbose=verbose1)
              ecl_rv_2 =  eclipsed_area*avflux
              fpar2(26) =0.0d0  ! rvflag
            endif
          else 
            if (verbose >= v_debug) then
              print *,'ellc: b_ellc_star2_eclipsed, integrate_eclipsed=.false.'
            endif
            avflux = partial(ellipse_2, ellipse_1, ngx2, fpar2, nfpar2, & 
            integrate_eclipsed=.false.,verbose=verbose1)
            ecl_flux_2 = flux_2 - (ellipse_2(i_ell_area)-eclipsed_area) &
            * avflux
            if (dorvflux) then
              fpar2(26) = 1.0d0  ! rvflag
              avflux = partial(ellipse_2, ellipse_1, ngx2, fpar2, nfpar2, & 
              integrate_eclipsed=.false.,verbose=verbose1)
              ecl_rv_2 = rvflux_2 - (ellipse_2(i_ell_area)-eclipsed_area) &
              * avflux
              fpar2(26) =0.0d0  ! rvflag
            endif
          endif

        endif

      endif 

    endif ! End calculation of eclipsed flux

    ! Star spots
    ell_ell_fail = .false.
    spot_flux_1 = 0
    spot_ecl_flux_1 = 0
    spot_rv_1 = 0
    spot_ecl_rv_1 = 0
    do i_spot = 1, n_spot_1
      ii = ii_1(iobs,i_spot)
      df = df_1(iobs,i_spot)
      spot_flux_1 = spot_flux_1 + (df - 1.0d0)*flux_1
      if ((ii > 0).and.btest(eclipse_type, b_ellc_star1_eclipsed) &
           .and.(.not.btest(eclipse_type, b_ellc_total))) then
        ! Spots on star 1 may be eclipsed
        phirot = phi_rot_1(iobs)
        lat_i = spots_1(i_spot_lat,i_spot)*dtor
        lon_i = spots_1(i_spot_lon,i_spot)*dtor
        u_s = sin(phirot - lon_i)*cos(lat_i)
        v_s = sin(lat_i)*sin(incl_0)-cos(incl_0)*cos(phirot - lon_i)*cos(lat_i)
        w_s = cos(phirot - lon_i)*cos(lat_i)*sin(incl_0)+sin(lat_i)*cos(incl_0)
        alpha_s = atan2(v_s,u_s)
        beta_s  = asin(w_s)
        gamma_s = spots_1(i_spot_gam,i_spot)*dtor
        if (verbose >= v_debug) then
          print *,'Star 1, spot',i_spot,' phi_rot = ', phirot
          print *,'Star 1, spot',i_spot,' u, v, w = ', u_s,v_s,w_s
          print *,'Star 1, spot',i_spot,' alpha, beta, gamma, ii = ', &
            alpha_s,beta_s,gamma_s,ii
          print *,'Star 1, spot',i_spot,' lat_i,lon_i,df = ',&
            lat_i,lon_i,df
        endif
        ! If beta_s is small then the calculation of the algorithm for the 
        ! occulted spot area is unreliable. In this case, run the algorithm
        ! twice for values of beta_s either side of the 0 and interpolate to the
        ! actual value of beta_s.
        if (abs(beta_s) < beta_s_lim) then
          n_spot_calc = 2
        else
          n_spot_calc = 1
        endif
        if (verbose >= v_debug) print *,'n_spot_calc=',n_spot_calc
        do i_spot_calc = 1, n_spot_calc
          if (n_spot_calc == 1) then
            call project_spot(alpha_s, beta_s, gamma_s, ellipse_s, xy_tng)
            ! Could use ii to determine if spot is on the limb, (iiswitch=ii) 
            ! but this sometimes fails because project_spot() finds no tangent
            ! points, so calculate iiswitch here based on xy_tng and beta_s.
            if (xy_tng(1,1) == not_set_dble) then
              if (beta_s < 0) then
                iiswitch = 0
              else
                iiswitch = 3
              endif
            else
              if (beta_s < 0) then
                iiswitch = 1
              else
                iiswitch = 2
              endif
            endif

          else

            if (i_spot_calc == 1) then
              call project_spot(alpha_s,beta_s_lim,gamma_s,ellipse_s,xy_tng)
              if (beta_s_lim < gamma_s) then
                iiswitch = 2
              else
                iiswitch = 3
              endif
            else
              if (beta_s_lim > gamma_s) then
                iiswitch = 0
              else
                call project_spot(alpha_s,-beta_s_lim, gamma_s,ellipse_s,xy_tng)
                iiswitch = 1
              endif
            endif
            if (verbose >= v_debug) then
              print *,'i_spot_calc,beta_s_lim,gamma_s,iiswitch = ', &
                i_spot_calc,beta_s_lim,gamma_s,iiswitch
            endif
          endif
          ! Affine transformation that translates projected ellipse for star 1
          ! to the origin and scales it by the radius of the ellipsoid at the
          ! centre of the spot. Using an approximation here that the line of
          ! sight is parallel to the line between the centres-of-mass for the
          ! two stars - not exactly true for eccentric orbits with i<90degrees,
          ! but offset is usually small.
          r_spot = sqrt( &
             (abcd1(1)*cos(lon_i)*cos(lat_i))**2 + &
             (abcd1(2)*sin(lon_i)*cos(lat_i))**2 + &
             (abcd1(3)*sin(lat_i))**2 )
          tr(1,1) =  1.0d0/r_spot
          tr(1,2) =  0.0d0
          tr(2,1) =  0.0d0
          tr(2,2) =  1.0d0/r_spot
          tr(1,3) = -ellipse_1(i_ell_x_c)/ellipse_1(i_ell_a_p)
          tr(2,3) = -ellipse_1(i_ell_y_c)/ellipse_1(i_ell_a_p)
          ! Apply this transformation to ellipse_2
          ellipse_t = ell_affine(tr, ellipse_2)
          select case (iiswitch)
          case (0)
            !  This is the case where we are interpolating between
            ! beta = +/-beta_s_lim, and the spot radius gamma_s < beta_s_lim
            ! so that the spot is not visible for beta = -beta_s_lim.
            !  Test whether the last point of the spot that was visible as it
            ! rotated off the limb was eclipsed or not.
            call project_spot(alpha_s,-gamma_s, gamma_s,ellipse_s,xy_tng)
            if (ell_point_is_inside(xy_tng(1:2,1),ellipse_t)) then
              frac(i_spot_calc) = 0
            else
              frac(i_spot_calc) = 1
            endif
          case (1)
            large=.false.
            frac(i_spot_calc) = spot_limb_eclipse(ellipse_t, ellipse_s, &
            xy_tng,large,verbose1)
            if (frac(i_spot_calc) == bad_dble) then
              ell_ell_fail = .true.
             exit
           endif
          case (2)
            large=.true.
            frac(i_spot_calc) = spot_limb_eclipse(ellipse_t, ellipse_s, &
            xy_tng,large,verbose1)
            if (frac(i_spot_calc) == bad_dble) then
              ell_ell_fail = .true.
             exit
           endif
          case (3)
            area_flags = ell_ell_overlap(ellipse_t, ellipse_s, verbose1)
            if (btest(overlap,b_ell_error)) then
              if (verbose >= v_warn) then
                print *,'ellc: calculation failed for observations no.',iobs
              endif
              ell_ell_fail = .true.
              exit
            endif
            if (btest(overlap,b_ell_warn_inaccurate)) then
              return_flags = ibset(return_flags,b_ellc_warning)
              if (verbose >= v_warn) then
                print *,'ellc: ell_ell_overlap warning , spot 1,',i_spot_calc
              endif
            endif
            frac(i_spot_calc) = area_flags(1)/ellipse_s(i_ell_area) 
          end select
        end do
        if (n_spot_calc == 1) then
          wt = 1
        else
          if (iiswitch == 0) then
            wt = (beta_s+gamma_s)/(beta_s_lim+gamma_s)
          else
            wt = 0.5d0 + 0.5d0*beta_s/beta_s_lim
          endif
        endif
        if (verbose >= v_debug) then
          print *,'iiswitch,frac,wt',iiswitch,frac,wt
        endif
        df1 =  (df-1.0d0)*flux_1*(wt*frac(1) + (1.0d0-wt)*frac(2))
        spot_ecl_flux_1 = spot_ecl_flux_1 + df1
        if (dorvflux) then
          spot_ecl_rv_1 = spot_ecl_rv_1  + df1*u_s*vsini1
        endif
      endif

      if (dorvflux) then
        phirot = phi_rot_1(iobs)
        lat_i = spots_1(i_spot_lat,i_spot)*dtor
        lon_i = spots_1(i_spot_lon,i_spot)*dtor
        u_s = sin(phirot - lon_i)*cos(lat_i)
        spot_rv_1 = spot_rv_1  + (df - 1.0d0)*u_s*vsini1
      endif

      if (verbose >= v_debug) then
        print *,'i_spot,spot_flux_1,ii,df,df1=',&
          i_spot,spot_flux_1,ii,df ,df1
      endif

    end do

 ! ell_ell_intersect failed in the loop
    if (ell_ell_fail) then
      flux_rv_flag(iobs,1:5) = bad_dble
      flux_rv_flag(iobs,6) = b_ellc_fail
      cycle
    endif


    spot_flux_2 = 0
    spot_ecl_flux_2 = 0 
    spot_rv_2 = 0
    spot_ecl_rv_2 = 0
    do i_spot = 1, n_spot_2
      ii = ii_2(iobs,i_spot)
      df = df_2(iobs,i_spot)
      spot_flux_2 = spot_flux_2 + (df - 1.0d0)*flux_2
      if ((ii > 0).and.btest(eclipse_type, b_ellc_star2_eclipsed) &
           .and.(.not.btest(eclipse_type, b_ellc_total))) then
        ! Spots on star 2 may be eclipsed
        phirot = phi_rot_2(iobs)
        lat_i = spots_2(i_spot_lat,i_spot)*dtor
        lon_i = spots_2(i_spot_lon,i_spot)*dtor + pi
        u_s = sin(phirot - lon_i)*cos(lat_i)
        v_s = sin(lat_i)*sin(incl_0)-cos(incl_0)*cos(phirot - lon_i)*cos(lat_i)
        w_s = cos(phirot - lon_i)*cos(lat_i)*sin(incl_0)+sin(lat_i)*cos(incl_0)
        alpha_s = atan2(v_s,u_s)
        beta_s  = asin(w_s)
        gamma_s = spots_2(i_spot_gam,i_spot)*dtor
        if (verbose >= v_debug) then
          print *,'Star 2, spot',i_spot,' phi_rot = ', phirot
          print *,'Star 2, spot',i_spot,' u, v, w = ', u_s,v_s,w_s
          print *,'Star 2, spot',i_spot,' alpha, beta, gamma, ii = ', &
            alpha_s,beta_s,gamma_s,ii
        endif
        ! If beta_s is small then the calculation of the algorithm for the 
        ! occulted spot area is unreliable. In this case, run the algorithm
        ! twice for values of beta_s either side of the 0 and interpolate to the
        ! actual value of beta_s.
        if (abs(beta_s) < beta_s_lim) then
          n_spot_calc = 2
        else
          n_spot_calc = 1
        endif
        do i_spot_calc = 1, n_spot_calc

          if (n_spot_calc == 1) then
            call project_spot(alpha_s, beta_s, gamma_s, ellipse_s, xy_tng)
            ! Could use ii to determine if spot is on the limb, (iiswitch=ii) 
            ! but this sometimes fails because project_spot() finds no tangent
            ! points, so calculate iiswitch here based on xy_tng and beta_s.
            if (xy_tng(1,1) == not_set_dble) then
              if (beta_s < 0) then
                iiswitch = 0
              else
                iiswitch = 3
              endif
            else
              if (beta_s < 0) then
                iiswitch = 1
              else
                iiswitch = 2
              endif
            endif

          else

            if (i_spot_calc == 1) then
              call project_spot(alpha_s,beta_s_lim,gamma_s,ellipse_s,xy_tng)
              if (beta_s_lim < gamma_s) then
                iiswitch = 2
              else
                iiswitch = 3
              endif
            else
              if (beta_s_lim > gamma_s) then
                iiswitch = 0
              else
                call project_spot(alpha_s,-beta_s_lim, gamma_s,ellipse_s,xy_tng)
                iiswitch = 1
              endif
            endif
            if (verbose >= v_debug) then
              print *,'i_spot_calc,beta_s_lim,gamma_s,iiswitch = ', &
                i_spot_calc,beta_s_lim,gamma_s,iiswitch
            endif
          endif
          ! Affine transformation that translates projected ellipse for star 2
          ! to the origin and scales it by the radius of the ellipsoid at the
          ! centre of the spot. Using an approximation here that the line of
          ! sight is parallel to the line between the centres-of-mass for the
          ! two stars - not exactly true for eccentric orbits with i<90degrees,
          ! but offset is usually small.
          r_spot = sqrt( &
             (abcd2(1)*cos(lon_i)*cos(lat_i))**2 + &
             (abcd2(2)*sin(lon_i)*cos(lat_i))**2 + &
             (abcd2(3)*sin(lat_i))**2 )
          tr(1,1) =  1.0d0/r_spot
          tr(1,2) =  0.0d0
          tr(2,1) =  0.0d0
          tr(2,2) =  1.0d0/r_spot
          tr(1,3) = -ellipse_2(i_ell_x_c)/ellipse_2(i_ell_a_p)
          tr(2,3) = -ellipse_2(i_ell_y_c)/ellipse_2(i_ell_a_p)
          ! Apply this transformation to ellipse_1
          ellipse_t = ell_affine(tr, ellipse_1)
          select case (iiswitch)
          case (0)
            !  This is the case where we are interpolating between
            ! beta = +/-beta_s_lim, and the spot radius gamma_s < beta_s_lim
            ! so that the spot is not visible for beta = -beta_s_lim.
            !  Test whether the last point of the spot that was visible as it
            ! rotated off the limb was eclipsed or not.
            call project_spot(alpha_s,-gamma_s, gamma_s,ellipse_s,xy_tng)
            if (ell_point_is_inside(xy_tng(1:2,1),ellipse_t)) then
              frac(i_spot_calc) = 0
            else
              frac(i_spot_calc) = 1
            endif
          case (1)
            large=.false.
            frac(i_spot_calc) = spot_limb_eclipse(ellipse_t, ellipse_s, &
            xy_tng,large,verbose1)
            if (frac(i_spot_calc) == bad_dble) then
              ell_ell_fail = .true.
             exit
           endif
          case (2)
            large=.true.
            frac(i_spot_calc) = spot_limb_eclipse(ellipse_t, ellipse_s, &
            xy_tng,large,verbose1)
            if (frac(i_spot_calc) == bad_dble) then
              ell_ell_fail = .true.
             exit
           endif
          case (3)
            area_flags = ell_ell_overlap(ellipse_s, ellipse_t, verbose1)
            if (btest(overlap,b_ell_error)) then
              if (verbose >= v_warn) then
                print *,'ellc: calculation failed for observations no.',iobs
              endif
              ell_ell_fail = .true.
              exit
            endif
            if (btest(overlap,b_ell_warn_inaccurate)) then
              return_flags = ibset(return_flags,b_ellc_warning)
              if (verbose >= v_warn) then
                print *,'ellc: ell_ell_overlap warning , spot 2,',i_spot_calc
              endif
            endif
            frac(i_spot_calc) = area_flags(1)/ellipse_s(i_ell_area) 
          end select
        end do
        if (n_spot_calc == 1) then
          wt = 1
        else
          if (iiswitch == 0) then
            wt = (beta_s+gamma_s)/(beta_s_lim+gamma_s)
          else
            wt = 0.5d0 + 0.5d0*beta_s/beta_s_lim
          endif
        endif
        if (verbose >= v_debug) then
          print *,'iiswitch,frac,wt',iiswitch,frac,wt
        endif
        df2 =  (df-1.0d0)*flux_2*(wt*frac(1) + (1.0d0-wt)*frac(2))
        spot_ecl_flux_2 = spot_ecl_flux_2 + df2
        if (dorvflux) then
          spot_ecl_rv_2 = spot_ecl_rv_2  + df2*u_s*vsini2
        endif
      endif

      if (dorvflux) then
        phirot = phi_rot_2(iobs)
        lat_i = spots_2(i_spot_lat,i_spot)*dtor
        lon_i = spots_2(i_spot_lon,i_spot)*dtor
        u_s = sin(phirot - lon_i)*cos(lat_i)
        spot_rv_2 = spot_rv_2  + (df - 1.0d0)*u_s*vsini2
      endif

      if (verbose >= v_debug) then
        print *,'i_spot,spot_flux_2,ii,df=',i_spot,spot_flux_2,ii,df 
      endif

    end do

    if (ell_ell_fail) then
      flux_rv_flag(iobs,1:5) = bad_dble
      flux_rv_flag(iobs,6) = b_ellc_fail
      cycle
    endif

    ! Have delayed calculation of ecl_flux_1,ecl_flux_2 for the total eclipse
    ! case until here so that the flux modulation due to spots is properly
    ! accounted for.
    if (btest(eclipse_type, b_ellc_total)) then
      if(btest(eclipse_type, b_ellc_star1_eclipsed)) then
        ecl_flux_1 = flux_1
        ecl_rv_1 = rvflux_1
        spot_ecl_flux_1 = spot_flux_1
      else
        ecl_flux_2 = flux_2
        ecl_rv_2 = rvflux_2
        spot_ecl_flux_2 = spot_flux_2
      endif
    endif

    if (verbose >= v_debug) then
      print *,'spot_flux_1,spot_ecl_flux_1,spot_rv_1 =', &
        spot_flux_1,spot_ecl_flux_1,spot_rv_1
      print *,'spot_flux_2,spot_ecl_flux_2,spot_rv_2 =', &
        spot_flux_2,spot_ecl_flux_2,spot_rv_2
    endif
    
    ! Ensure correction for eclipsed spots does not exceed total flux 
    ! lost in eclipse.
    if (spot_ecl_flux_1 < -ecl_flux_1) spot_ecl_flux_1 = -ecl_flux_1
    if (spot_ecl_flux_2 < -ecl_flux_2) spot_ecl_flux_2 = -ecl_flux_2


    ! Add effect of spots to light/rv curves
    flux_1 = flux_1 + spot_flux_1 - spot_ecl_flux_1
    flux_2 = flux_2 + spot_flux_2 - spot_ecl_flux_2

    rvflux_1 = rvflux_1 + spot_rv_1 - spot_ecl_rv_1
    rvflux_2 = rvflux_2 + spot_rv_2 - spot_ecl_rv_2
    
    ! Simple reflection
    if ((binary_pars(29) == 0.0d0).or.(binary_pars(32) == 0.0d0)) then
      heat=sini*cos(phi_1)
      heat2=0.5d0 + 0.5d0*heat**2
      if (binary_pars(29) == 0.0d0) then
        refl_1 = rfac_1*(heat2+heat)/r**2
        if (flux_1 > 0) refl_1 = refl_1 * (1.0d0 - ecl_flux_1/flux_1)
      endif
      if (binary_pars(32) == 0.0d0) then
        refl_2 = rfac_2*(heat2-heat)/r**2
        if (flux_2 > 0) refl_2 = refl_2 * (1.0d0 - ecl_flux_2/flux_2)
      endif
    endif

    ! Subtract eclipsed flux from total flux for each star
    if (verbose >= v_debug) then
      print *,'flux_1,rv1,ecl_flux_1', flux_1,rv1,ecl_flux_1
      print *,'flux_2,rv2,ecl_flux_2', flux_2,rv2,ecl_flux_2
    endif
    flux_1 = flux_1 - ecl_flux_1
    flux_2 = flux_2 - ecl_flux_2

    ! Flux-weighted radial velocities 
    if (dorvflux) then
      if (flux_1 /= 0.0d0) then
        rv1 = rv1 + (rvflux_1 - ecl_rv_1)/flux_1 
      else
        rv1 =0
      endif
      if (flux_2 /= 0.0d0) then
        rv2 = rv2 + (rvflux_2 - ecl_rv_2)/flux_2 
      else
        rv2 =0
      endif
    endif

    ! Doppler boosting
    flux_1 = flux_1*(1.0d0 - binary_pars(26)*rv1/c_kms)
    flux_2 = flux_2*(1.0d0 - binary_pars(27)*rv2/c_kms)

    if (verbose >= v_debug) then
      print *,'flux_1,rv1,ecl_rv_1,refl_1', flux_1,rv1,ecl_rv_1,refl_1
      print *,'flux_2,rv2,ecl_rv_2,refl_2', flux_2,rv2,ecl_rv_2,refl_2
    endif

    flux_rv_flag(iobs,1) = (flux_1+flux_2+flux_3+refl_1+refl_2)/fnorm
    flux_rv_flag(iobs,2) = flux_1+refl_1
    flux_rv_flag(iobs,3) = flux_2+refl_2
    flux_rv_flag(iobs,4) = rv1
    flux_rv_flag(iobs,5) = rv2
    flux_rv_flag(iobs,6) = return_flags

  else  ! iobs=0, calculation of normalized flux

    ! Simple reflection
    if ((binary_pars(29) == 0.0d0).or.(binary_pars(32) == 0.0d0)) then
      heat=sini*cos(phi_1)/r**2
      heat2=0.5d0 + 0.5d0*heat**2
      if (binary_pars(29) == 0.0d0) then
        refl_1 = rfac_1*(heat2+heat)
      endif
      if (binary_pars(32) == 0.0d0) then
        refl_2 = rfac_2*(heat2-heat)
      endif
    endif

    fnorm = flux_1 + flux_2 + refl_1 + refl_2
    flux_3 = l_3 * fnorm
    fnorm = flux_1 + flux_2 + flux_3 + refl_1 + refl_2
    if (verbose >= v_debug) then
      print *,'f_norm = ', fnorm
    endif
  endif

end do  ! End of main loop


deallocate(fpar1)
deallocate(fpar2)
if ((n_spot_1+n_spot_2) > 0) then 
  deallocate(phi_rot_1)
  deallocate(phi_rot_2)
  deallocate(df_1)
  deallocate(df_2)
  deallocate(ii_1)
  deallocate(ii_2)
endif

if (verbose >= v_user) print *, 'End ellc:lc'
return

end function lc

!------------------------------------------------------------------------------

function rv(n_obs,               &  ! Number of observations
            input_times,         &  ! Array of times/phases 
            binary_pars,         &  ! Parameters of the binary system
            verbose)             &  ! Verbosity of printed output
            result(rv_result)
implicit none
integer, intent(in)   :: n_obs
!f2py integer, intent(hide), depend(input_times) :: n_obs = len(input_times)
double precision, intent(in)  :: input_times(n_obs)
!f2py integer, parameter :: n_par = 39
double precision, intent(in)  :: binary_pars(n_par)
integer, intent(in)   :: verbose
double precision :: rv_result(n_obs,2)

!Local variables
integer :: iobs
double precision :: time_0,p_anom,p_anom_s,ecc,efac,omega_0,incl_0
double precision :: sini_0, a,qmass1,qmass2,qfac1,qfac2,omdot,p_sid,didt
double precision :: alite1,alite2,dltte,sini,cosi,cosnu,sinnu,time,tperi0
double precision :: vorb1, vorb2, w1, w2,sinom1, sinom2
double precision :: true_anomaly, true_anomaly_1, true_anomaly_2
double precision :: ee,mm,incl,r,rv1,rv2, omega_1, omega_2,r_1,r_2,t1,t2
double precision :: sinnu_1, sinnu_2, cosnu_1, cosnu_2, cosom1, cosom2

if (verbose >= v_user) then
  print *,'Start ellc:lc'
  print *,'N_obs  = ',n_obs
  print *,'t_obs(1)  = ',input_times(1)
  print *,'t_obs(N_obs)  = ',input_times(n_obs)
endif


! Some useful variables
time_0 = binary_pars(1)
p_anom = binary_pars(2)
p_anom_s = p_anom*86400.0d0
ecc = binary_pars(9)**2 + binary_pars(10)**2 
if (ecc >= 1) then
  rv_result(1:n_obs,1:2) = bad_dble
  return
endif

efac = sqrt((1.0d0+ecc)/(1.0d0-ecc))
if (ecc == 0.0d0) then
  omega_0 = 0.0d0
else
  omega_0 = atan2(binary_pars(10),binary_pars(9))
endif
incl_0 = binary_pars(6)*dtor
if (verbose >= v_user) then
  print *,'ellc: time_0 = ',time_0
  print *,'ellc: p_anom = ',p_anom
  print *,'ellc: e = ',real(ecc),'; omega_0 = ',omega_0,' radians'
endif
sini_0 = sin(incl_0) 
a = binary_pars(8)
qmass1 = binary_pars(11) ! Mass of companion to star 1 w.r.t. m_1
qmass2 = 1.0d0/qmass1    ! Mass of companion to star 2 w.r.t. m_2
qfac2 = 1.0d0/(1.0d0+qmass1)
qfac1 = qmass1*qfac2
omdot = binary_pars(23)*dtor
p_sid = p_anom*(1.0d0 - omdot/twopi)  ! Siderial period
if ((omdot /= 0.0d0).and.(verbose >= v_user)) then
  print *,'ellc: omdot = ',omdot,' radians/(siderial period)'
  print *,'ellc: p_sid = ',p_sid
endif
didt = binary_pars(22)*dtor
alite1 = binary_pars(8)*qfac1 * solar_radius/iau_c/8.64d4
alite2 = binary_pars(8)*qfac2 * solar_radius/iau_c/8.64d4
! Correction to T_0 for light travel time - see Borkovits et al., 
!   2015MNRAS.448..946B, equation (25)
dltte = alite2*sini_0*(qmass1-1.0d0)/(qmass1+1.0d0) & 
        * (1-ecc**2)/(1+ecc*sin(omega_0))
time_0 = time_0 - dltte
if (verbose >= v_user) then
  print *,'Light travel time correction to T_0 = ', real(dltte)
endif
vorb1 = a*qfac1/(solar_asini_kms_d*p_anom*sqrt(1-ecc**2))
vorb2 = qmass2*vorb1
if (verbose >= v_user) then
  print *,'K_1 = ',real(vorb1*sini_0),' km/s.'
  print *,'K_2 = ',real(vorb2*sini_0),' km/s.'
endif


! Time of periastron passage prior to time_0 via eccentric anomaly
tperi0 = t_ecl_to_peri(time_0, ecc, omega_0, incl_0, p_sid, verbose)
if (verbose >= v_user) print *,'Reference time of periastron = ', real(tperi0)

do iobs=1,n_obs

  time = input_times(iobs)
  ! Calculate positions of stars in their orbits 
  mm = twopi*mod(1.0d0+mod((time-tperi0)/p_anom,1.0d0),1.0d0)
  ee = eanom(mm,ecc)
  r = 1.0d0 - ecc*cos(ee)
  true_anomaly = 2.0d0*atan(efac*tan(ee/2.0d0))
  cosnu = cos(true_anomaly) 
  sinnu = sin(true_anomaly) 
  ! Calculate apparent positions of stars' centres-of-mass on the sky.
  incl = incl_0 + (time-time_0)*didt
  cosi = cos(incl)
  sini = sin(incl)
  omega_1 = mod(omega_0 + (time-time_0)*omdot/p_sid, twopi)
  cosom1 = cos(omega_1) 
  sinom1 = sin(omega_1) 
  omega_2 = mod(omega_1+pi,twopi)
  cosom2 = -cosom1
  sinom2 = -sinom1
  w1 = -r*sini*(sinnu*cosom1+cosnu*sinom1)*qfac1
  w2 = -r*sini*(sinnu*cosom2+cosnu*sinom2)*qfac2
  ! Light travel time correction
  t1 = time + alite1*w1
  mm = twopi*mod((t1-tperi0)/p_anom,1.0d0)
  ee = eanom(mm,ecc)
  r_1 = 1.0d0 - ecc*cos(ee)
  true_anomaly_1 = 2.0d0*atan(efac*tan(ee/2.0d0))
  cosnu_1 = cos(true_anomaly_1) 
  sinnu_1 = sin(true_anomaly_1) 
  t2 = time + alite2*w2
  mm = twopi*mod((t2-tperi0)/p_anom,1.0d0)
  ee = eanom(mm,ecc)
  r_2 = 1.0d0 - ecc*cos(ee)
  true_anomaly_2 = 2.0d0*atan(efac*tan(ee/2.0d0))
  cosnu_2 = cos(true_anomaly_2) 
  sinnu_2 = sin(true_anomaly_2) 
  rv1 = vorb1*sini*(cos(true_anomaly_1+omega_1)+ecc*cosom1)
  rv2 = vorb2*sini*(cos(true_anomaly_2+omega_2)+ecc*cosom2)
  rv_result(iobs,1:2) = [rv1, rv2]

  if (verbose >= v_debug) then
    print *,'time, rv1, rv2',time,rv1,rv2
  endif

end do


if (verbose >= v_user) print *, 'End ellc:rv'
return

end function rv
!------------------------------------------------------------------------------

double precision function partial(ellipse_a, ellipse_b, ngx, fpar, nfpar, &
                           integrate_eclipsed, verbose)
! Returns the average surface brightness of ellipse_a either in the region
! covered by ellipse_b or in the area not covered by ellipse_b, depending on the
! value of the switch integrate_eclipsed. The area of this region is calculated
! numerically so that the errors in the eclipse/non-eclipsed area and total flux
! partially cancel out.
implicit none
integer, intent(in) :: ngx, nfpar, verbose
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse_a(n_ell_par), ellipse_b(n_ell_par)
double precision, intent(inout) :: fpar(nfpar)
!f2py intent(in,out) :: fpar
logical, intent(in) :: integrate_eclipsed
! integrate_eclipsed
!  .true.  => integrate eclipsed area of ellipse_a 
!  .false. => integrate visible area and ellipse_a

! Local variables
double precision :: um,vm
double precision :: qline(4)
double precision :: dudf,dvdf,dudg,dvdg
double precision :: fa(2),fb(2),uv(2)
double precision :: flima, flimb
double precision :: part1,part2,part3
double precision :: area1,area2,area3,earea,eflux
double precision :: uv_intersect(2,4)
integer, parameter :: nelimpar=16
double precision :: elimpar(nelimpar)
integer  :: flags, ngf, verbose1
integer,parameter :: ngmin = 4 ! Minimum size of integration grid

verbose1 = verbose_for_calls(verbose)

! Find intersection points of ellipses.

call ell_ell_intersect(ellipse_a, ellipse_b, verbose1, flags, uv_intersect)
if (.not.btest(flags, b_ell_two_intersects)) then
 print *,'partial: n_intersect /=  2'
 print *, ellipse_a
 print *, ellipse_b
 print *, flags
 stop
endif
     
if (verbose >= v_debug) then
  print *,'partial: u_intersect = ', uv_intersect(1,1:2)
  print *,'partial: v_intersect = ', uv_intersect(2,1:2)
endif
! Mid-point of intersection line
! This is the origin of the (f,g) coordinate system.
! The variable "f" runs perpendicular to the line of intersection.
! The variable "g" runs along the line of intersection.
um = 0.5d0* (uv_intersect(1,1)+uv_intersect(1,2))
vm = 0.5d0* (uv_intersect(2,1)+uv_intersect(2,2))
if (verbose >= v_debug) print *,'partial: (um,vm) = ',um,vm 
dudg = uv_intersect(1,2) - uv_intersect(1,1)
dvdg = uv_intersect(2,2) - uv_intersect(2,1)
dvdf = -dudg
dudf = dvdg
! Parametric equation of line along the "f" axis in (u,v) coordinates.
qline(1) = um
qline(2) = vm
qline(3) = dudf
qline(4) = dvdf

! Intersection of "f" axis with each ellipse.
fa = ell_line_intersect(ellipse_a, qline)
if (fa(1) == -huge(0.d0))  then
  print *,'Error calling ell_line_intersect(ellipse_a, qline)'
  print *,ellipse_a
  print *,qline
  stop
endif
fb = ell_line_intersect(ellipse_b, qline)
if (fb(1) == -huge(0.d0))  then
  print *,'Error calling ell_line_intersect(ellipse_b, qline)'
  print *,ellipse_b
  print *,qline
  stop
endif
! Identify which values of f are for points interior/exterior to the other
! ellipse and use these to identify  the value of f required to set the 
! upper limit for integration in the (u,v) plane. 
uv(:) = [um + dudf*fa(1) ,  vm + dvdf*fa(1) ]
if (ell_point_is_inside(uv,ellipse_b)) then
  if (integrate_eclipsed) then
    flima = fa(1)
  else
    flima = fa(2)
  endif
else
  if (integrate_eclipsed) then
    flima = fa(2)
  else
    flima = fa(1)
  endif
endif
uv(:) = [um + dudf*fb(1) ,  vm + dvdf*fb(1)]
if (ell_point_is_inside(uv,ellipse_a)) then
  flimb = fb(1)
else
  flimb = fb(2)
endif

! This is the transformation matrix from the (f,g) coordinate system to 
! the (s,t) coordinate system within bright.
fpar(28) = um-ellipse_a(i_ell_x_c)
fpar(29) = vm-ellipse_a(i_ell_y_c)
fpar(30) = dudf
fpar(31) = dudg
fpar(32) = 1  ! Enable coordinate transformation

elimpar(1) = um
elimpar(2) = vm
elimpar(3) = dudg
elimpar(4) = dvdg
elimpar(5:10) =  ellipse_a(i_ell_qcoeff)
elimpar(11:16) =  ellipse_b(i_ell_qcoeff)

if (integrate_eclipsed) then
  ngf = min(max(ngmin, &
        nint(0.5d0*ngx*hypot(dudf*flima,dvdf*flima)/ellipse_a(i_ell_a_p))),ngx)
  if (verbose >= v_debug) then
    print *,'partial: ',1,flima,ngf
    print *,'partial: ',1,elimpar
  endif
  part1 = gauss2d(ngf,bright,0.0d0,flima,glimnega,glimposa, &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  area1 = gauss2d(ngf,unitfunc,0.0d0,flima,glimnega,glimposa, &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  if (area1 < 0) then
    part1 = -part1
    area1 = -area1
  endif

  ngf = min(max(ngmin, &
        nint(0.5d0*ngx*hypot(dudf*flimb,dvdf*flimb)/ellipse_a(i_ell_a_p))),ngx)
  if (verbose >= v_debug) then
    print *,'partial: ',2,flimb,ngf
    print *,'partial: ',2,elimpar
  endif
  part2 = gauss2d(ngf,bright,0.0d0,flimb,glimnegb,glimposb,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  area2 = gauss2d(ngf,unitfunc,0.0d0,flimb,glimnegb,glimposb,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  if (area2 < 0) then
    part2 = -part2
    area2 = -area2
  endif

  eflux = (part1 + part2)
  earea = (area1 + area2)

else

  ngf = min(max(ngmin, &
        nint(0.5d0*ngx*hypot(dudf*flimb,dvdf*flimb)/ellipse_a(i_ell_a_p))),ngx)
  if (verbose >= v_debug) then
    print *,'partial: ',3,flimb,ngf
    print *,'partial: ',3,elimpar
  endif
  part1 = gauss2d(ngf,bright,0.0d0,flimb,glimnegb,glimnega, &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  area1 = gauss2d(ngf,unitfunc,0.0d0,flimb,glimnegb,glimnega, &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  if (area1 < 0) then
    part1 = -part1
    area1 = -area1
  endif


  ngf = min(max(ngmin, &
        nint(0.5d0*ngx*hypot(dudf*flimb,dvdf*flimb)/ellipse_a(i_ell_a_p))),ngx)
  if (verbose >= v_debug) then
    print *,'partial: ',4,flimb,ngf
    print *,'partial: ',4,elimpar
  endif
  part2 = gauss2d(ngf,bright,0.0d0,flimb,glimposb,glimposa,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  area2 = gauss2d(ngf,unitfunc,0.0d0,flimb,glimposb,glimposa,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  if (area2 < 0) then
    part2 = -part2
    area2 = -area2
  endif

  ngf = min(max(ngmin, &
        nint(0.5d0*ngx*hypot(dudf*(flimb-flima),dvdf*(flimb-flima)) &
        /ellipse_a(i_ell_a_p))),ngx)
  if (verbose >= v_debug) then
    print *,'partial: ',5,flima,flimb,ngf
    print *,'partial: ',5,elimpar
  endif
  part3 = gauss2d(ngf,bright,flimb,flima,glimnega,glimposa,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  area3 = gauss2d(ngf,unitfunc,flimb,flima,glimnega,glimposa,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  if (area3 < 0) then
    part3 = -part3
    area3 = -area3
  endif

  eflux = (part1 + part2 + part3)
  earea = (area1 + area2 + area3)
endif 

if (verbose >= v_debug) then
  print *,'partial: eflux, earea = ',real(eflux),real(earea)
endif
if (earea /= 0.d0) then
  partial = eflux/earea
else
  partial = 0.d0
endif

end function partial

!------------------------------------------------------------------------------

double precision function double_partial(ellipse_a, ellipse_b, ngx, fpar, &
                                         nfpar, verbose)
! Returns the average surface brightness of ellipse_a in the two regions not
! covered by ellipse_b in the case where the ellipses intersect at four points.
implicit none
integer, intent(in) :: ngx, nfpar, verbose
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse_a(n_ell_par), ellipse_b(n_ell_par)
double precision, intent(inout) :: fpar(nfpar)
!f2py intent(in,out) :: fpar

! Local variables
double precision :: um,vm
double precision :: dudf,dvdf,dudg,dvdg
double precision :: fa(2),fb(2),uv(2)
double precision :: xyqc(2), qline(4), tq(4),t_a, t_b
double precision :: flima, flimb
double precision :: earea,eflux,area1,flux1
double precision :: uv_intersect(2,4)
integer, parameter :: nelimpar=16
double precision :: elimpar(nelimpar)
integer  :: flags, verbose1, k(4), i1(2),i2(2),j, j1, j2, ngf
integer,parameter :: ngmin = 4 ! Minimum number of integration points

verbose1 = verbose_for_calls(verbose)

! Find intersection points of ellipses.

call ell_ell_intersect(ellipse_a, ellipse_b, verbose1, flags, uv_intersect)
if (.not.btest(flags, b_ell_four_intersects)) then
 print *,'partial: n_intersect /=  4'
 print *, ellipse_a
 print *, ellipse_b
 print *, flags
 stop
endif

if (verbose >= v_debug) then
  print *,'partial: u_intersect = ', uv_intersect(1,1:4)
  print *,'partial: v_intersect = ', uv_intersect(2,1:4)
endif

! Deal with intersection points in clockwise order, sorted by the angle to the
! x-axis measured from their centroid.
xyqc = sum(uv_intersect,dim=2)/4.d0
tq = atan2(uv_intersect(2,1:4)-xyqc(2),uv_intersect(1,1:4)-xyqc(1))
call heapsort(tq,k)

! To find the two pairs of intersection points that define the limits of the two
! integration regions, test which ellipse it intersected first by a line from
! the centroid of the quadrilateral through the midpoint of the first two
! intersection points in the angle-ordered list created above.
qline(1:2) = xyqc
qline(3) = 0.5d0*(uv_intersect(1,k(1))+uv_intersect(1,k(2))) - xyqc(1)
qline(4) = 0.5d0*(uv_intersect(2,k(1))+uv_intersect(2,k(2))) - xyqc(2)
t_a = maxval(ell_line_intersect(ellipse_a, qline))
t_b = maxval(ell_line_intersect(ellipse_b, qline))
if (t_a < t_b) then
  i1 = [k(2),k(1)]
  i2 = [k(3),k(4)]
else
  i1 = [k(1),k(3)]
  i2 = [k(2),k(4)]
endif

earea = 0
eflux = 0

do j=1,2
  j1 = i1(j)
  j2 = i2(j)
  ! Mid-point of intersection line
  ! This is the origin of the (f,g) coordinate system.
  ! The variable "f" runs perpendicular to the line of intersection.
  ! The variable "g" runs along the line of intersection.
  um = 0.5d0* (uv_intersect(1,j1)+uv_intersect(1,j2))
  vm = 0.5d0* (uv_intersect(2,j1)+uv_intersect(2,j2))
  if (verbose >= v_debug) print *,'partial: (um,vm) = ',um,vm 
  dudg = uv_intersect(1,j2) - uv_intersect(1,j1)
  dvdg = uv_intersect(2,j2) - uv_intersect(2,j1)
  dvdf = -dudg
  dudf = dvdg
  ! Parametric equation of line along the "f" axis in (u,v) coordinates.
  qline(1) = um
  qline(2) = vm
  qline(3) = dudf
  qline(4) = dvdf

  ! Intersection of "f" axis with each ellipse.
  fa = ell_line_intersect(ellipse_a, qline)
  if (fa(1) == -huge(0.d0))  then
    print *,'Error calling ell_line_intersect(ellipse_a, qline)'
    print *,ellipse_a
    print *,qline
    stop
  endif
  fb = ell_line_intersect(ellipse_b, qline)
  if (fb(1) == -huge(0.d0))  then
    print *,'Error calling ell_line_intersect(ellipse_b, qline)'
    print *,ellipse_b
    print *,qline
    stop
  endif
  uv(:) = [um + dudf*fa(1) ,  vm + dvdf*fa(1) ]
  if (abs(fa(1)) < abs(fa(2))) then
    flima = fa(1)
  else
    flima = fa(2)
  endif
  uv(:) = [um + dudf*fb(1) ,  vm + dvdf*fb(1)]
  if (abs(fb(1)) < abs(fb(2))) then
    flimb = fb(1)
  else
    flimb = fb(2)
  endif
  ! This is the transformation matrix from the (f,g) coordinate system to 
  ! the (s,t) coordinate system within bright.
  fpar(28) = um-ellipse_a(i_ell_x_c)
  fpar(29) = vm-ellipse_a(i_ell_y_c)
  fpar(30) = dudf
  fpar(31) = dudg
  fpar(32) = 1   ! Enable coordinate transformation

  elimpar(1) = um
  elimpar(2) = vm
  elimpar(3) = dudg
  elimpar(4) = dvdg
  elimpar(5:10) =  ellipse_a(i_ell_qcoeff)
  elimpar(11:16) =  ellipse_b(i_ell_qcoeff)

  ngf = min(max(ngmin, &
        nint(0.5d0*ngx*hypot(dudf*flimb,dvdf*flimb)/ellipse_a(i_ell_a_p))),ngx)
  flux1 = gauss2d(ngx,bright,0.0d0,flimb,glimnegb,glimnega, &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  area1 = gauss2d(ngx,unitfunc,0.0d0,flimb,glimnegb,glimnega, &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  if (area1 < 0) then
    flux1 = -flux1
    area1 = -area1
  endif
  eflux = eflux + flux1
  earea = earea + area1

  ngf = min(max(ngmin, &
        nint(0.5d0*ngx*hypot(dudf*flimb,dvdf*flimb)/ellipse_a(i_ell_a_p))),ngx)
  flux1 = gauss2d(ngx,bright,0.0d0,flimb,glimposb,glimposa,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  area1 = gauss2d(ngx,unitfunc,0.0d0,flimb,glimposb,glimposa,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  if (area1 < 0) then
    flux1 = -flux1
    area1 = -area1
  endif
  eflux = eflux + flux1
  earea = earea + area1

  ngf = min(max(ngmin, &
        nint(0.5d0*ngx*hypot(dudf*(flimb-flima),dvdf*(flimb-flima)) &
        /ellipse_a(i_ell_a_p))),ngx)
  flux1 = gauss2d(ngx,bright,flimb,flima,glimnega,glimposa,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  area1 = gauss2d(ngx,unitfunc,flimb,flima,glimnega,glimposa,  &
          nelimpar,elimpar,nfpar,fpar,nymin=ngmin,nymax=ngx,verbose=verbose1)
  if (area1 < 0) then
    flux1 = -flux1
    area1 = -area1
  endif
  eflux = eflux + flux1
  earea = earea + area1

end do
if (earea /= 0.d0) then
  double_partial = eflux/earea
else
  double_partial = 0.d0
endif

end function double_partial

!------------------------------------------------------------------------------

double precision function glimnega(f, nelimpar, elimpar)
implicit none
double precision, intent(in) :: f
integer, intent(in)  :: nelimpar
double precision, intent(in) :: elimpar(nelimpar)
! Local variables
double precision :: g(2),dudg,dvdg,qline(4)
!f2py integer, parameter :: n_ell_par = 14
double precision :: dummy_ellipse(n_ell_par)
dudg = elimpar(3)
dvdg = elimpar(4)
qline(1) = elimpar(1) + dvdg*f
qline(2) = elimpar(2) - dudg*f
qline(3) = dudg
qline(4) = dvdg
dummy_ellipse(i_ell_qcoeff) = elimpar(5:10)
g(1:2) = ell_line_intersect(dummy_ellipse, qline)
if (g(1) == -huge(0.0d0) ) then
  print *,'glimnega: error finding limit'
  print *, real(qline)
  print *, f, elimpar
  glimnega  = bad_dble
  return
endif
if (g(1) < 0.0d0) then
  glimnega = g(1)
else
  glimnega = g(2)
endif
end function glimnega

!------------------------------------------------------------------------------

double precision function glimposa(f, nelimpar, elimpar)
implicit none
double precision, intent(in) :: f
integer, intent(in)  :: nelimpar
double precision, intent(in) :: elimpar(nelimpar)
! Local variables
double precision :: g(2),dudg,dvdg,qline(4)
!f2py integer, parameter :: n_ell_par = 14
double precision :: dummy_ellipse(n_ell_par)
dudg = elimpar(3)
dvdg = elimpar(4)
qline(1) = elimpar(1) + dvdg*f
qline(2) = elimpar(2) - dudg*f
qline(3) = dudg
qline(4) = dvdg
dummy_ellipse(i_ell_qcoeff) = elimpar(5:10)
g(1:2) = ell_line_intersect(dummy_ellipse, qline)
if (g(1) == -huge(0.0d0) ) then
  print *,'glimposa: error finding limit'
  print *, real(qline)
  print *, f, elimpar
  glimposa  = bad_dble
  return
endif
if (g(1) > 0.0d0) then
  glimposa = g(1)
else
  glimposa = g(2)
endif
end function glimposa

!------------------------------------------------------------------------------

double precision function glimnegb(f, nelimpar, elimpar)
implicit none
double precision, intent(in) :: f
integer, intent(in)  :: nelimpar
double precision, intent(in) :: elimpar(nelimpar)
! Local variables
double precision :: g(2),dudg,dvdg,qline(4)
!f2py integer, parameter :: n_ell_par = 14
double precision :: dummy_ellipse(n_ell_par)
dudg = elimpar(3)
dvdg = elimpar(4)
qline(1) = elimpar(1) + dvdg*f
qline(2) = elimpar(2) - dudg*f
qline(3) = dudg
qline(4) = dvdg
dummy_ellipse(i_ell_qcoeff) = elimpar(11:16)
g(1:2) = ell_line_intersect(dummy_ellipse, qline)
if (g(1) == -huge(0.0d0) ) then
  print *,'glimnegb: error finding limit'
  print *, real(qline)
  print *, f, elimpar
  glimnegb  = bad_dble
  return
endif
if (g(1) < 0.0d0) then
  glimnegb = g(1)
else
  glimnegb = g(2)
endif
end function glimnegb

!------------------------------------------------------------------------------

double precision function glimposb(f, nelimpar, elimpar)
implicit none
double precision, intent(in) :: f
integer, intent(in)  :: nelimpar
double precision, intent(in) :: elimpar(nelimpar)
! Local variables
double precision :: g(2),dudg,dvdg,qline(4)
!f2py integer, parameter :: n_ell_par = 14
double precision :: dummy_ellipse(n_ell_par)
dudg = elimpar(3)
dvdg = elimpar(4)
qline(1) = elimpar(1) + dvdg*f
qline(2) = elimpar(2) - dudg*f
qline(3) = dudg
qline(4) = dvdg
dummy_ellipse(i_ell_qcoeff) = elimpar(11:16)
g(1:2) = ell_line_intersect(dummy_ellipse, qline)
if (g(1) == -huge(0.0d0) ) then
  print *,'glimposb: error finding limit'
  print *, real(qline)
  print *, f, elimpar
  glimposb  = bad_dble
  return
endif
if (g(1) > 0.0d0) then
  glimposb = g(1)
else
  glimposb = g(2)
endif
end function glimposb

end module ellc

! This file is part of the ellc binary star model
! Copyright (C) 2016 Pierre Maxted
! 
! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

module spots
! Module for dealing with star spots in ellc
!
! HISTORY
! -------
! Jan 2016
! First version 
! p.maxted@keele.ac.uk
!

use constants
use utils     
use ellipse

implicit none

contains

subroutine eker(l,b,i,r,a,u1,u2,phi,nphi,df,ii,ifail)
implicit none
integer,intent(in)  :: nphi
double precision, intent(in) :: l,b,i,phi(nphi),r,a,u1,u2
double precision, intent(out) :: df(nphi)
integer,intent(out) :: ii(nphi), ifail
!
! Analytic light curve for a rotating star with a single circular spot 
!
! Implementation of formulae from Eker, Z., 1994ApJ...420..373E with 
! correction for equation for K_3 from erratum 1994ApJ...430..438E.
!
! Input values
!  l        = longitude of spot centre (radians)
!  b        = latitude of spot centre (radians)
!  i        = inclination of rotation axis (radians)
!  r        = angular radius of spot (radians)
!  a        = Spot contrast ratio (a=Is/Ip).
!  u1       = linear limb darkening coefficient.
!  u2       = quadratic limb darkening coefficient.
!  phi(nphi) = array of rotation phase values in radians, i.e. twopi*(t-t_0)/P
!  nphi      = number of phase values
!
! N.B. Eker uses a limb darkening law of the form I_0[1 - u_1.mu + u_2.mu^2], 
! i.e., u_2 is the negative of the normal quadratic limb darkening coefficient.
!
! Output values
!  df(nphi)  = light curve
!  ii(nphi)  = spot position flag
!  ifail    = status flag
!
! Return values in the array df are (Fp + Fs)/F where
!  Fp is the flux from the unspotted photosphere
!  Fs is the flux from the spot
!  F is the flux from the star without a spot.
! 
! Spot position flag ii() is as follows
!   0 = spot not visible
!   1 = Spot is on the limb and less than half the spot is visible
!   2 = Spot is on the limb and more than half the spot is visible.
!   3 = Spot is completely visible
!
! Return value of ifail is the sum of the following flags.
!   0 => all ok
!   1 => r >= pi/2
!   2 => a < 0.0
!   4 => nphi < 1
!

! Local variables
integer :: iphi
double precision :: cosisinb,sinicosb
double precision :: sinr2,sinr3,sinr4,sin2r
double precision :: cosr,cos2r,cosr3,cosr4
! qn = I_n/pi, ql = I_l/pi, qq = I_q/pi
double precision :: qn,ql,qq
double precision :: th0,Cl,Cq,K1,K2,K3,K4
double precision :: t13b1,t13b2,t13c1,t13c2
double precision :: costh0,sinth0,sinth02,tanth0
double precision :: phi0,r0,sinphi0,cosphi0,sinr0,cosr0,sin2r0,cos2r0
double precision :: f0,fn,fl,fq

ifail = 0 
if (r >= halfpi) ifail = ifail + 1
if (a < 0.0d0)  ifail = ifail + 2
if (nphi < 1) ifail = ifail + 4
if (ifail /= 0) return

! Take constant terms in the calculation out of the do loop

cosisinb = cos(i)*sin(b)
sinicosb = sin(i)*cos(b)
cosr = cos(r)
cosr3 = cosr**3
cosr4 = cosr**4
sin2r = sin(2.0d0*r)
cos2r = cos(2.0d0*r)
sinr2 = 1.0d0 - cosr**2
sinr3  = sin(r)**3
sinr4  = sinr2**2
f0 = (a-1.0d0)/(1.0d0-u1/3.0d0+u2/6.0d0)
fn = (1.0d0-u1+u2)*f0
fl = (u1-2.0d0*u2)*f0
fq = u2*f0
t13b1 = 2.0d0*(1.0d0-cosr3)/3.0d0
t13b2 = cosr*sinr2
t13c1 = 0.5d0*(1.0d0-cosr4)
t13c2 = 0.75d0*sinr4

do iphi=1,nphi

! (20)
  costh0 = cosisinb+sinicosb*cos(phi(iphi)-l)
  th0 = acos(costh0)
  sinth02 = 1.0d0 - costh0**2
  sinth0 = sqrt(sinth02)
  tanth0 = sinth0/costh0

  if (th0 >= (halfpi+r)) then ! Spot is completely around the back side

    df(iphi) = 1.0d0
    ii(iphi) = 0 

  else ! Spot is visible or partially visible

    ii(iphi) = 3
    if ((u1 == 0.0d0).and.(u2 == 0.0d0)) then
      qn = sinr2*costh0
      ql = 0.0d0
      qq = 0.0d0  
    else if (u2 == 0.0d0) then
      qn = sinr2*costh0
      ql = t13b1 - t13b2*sinth02
      qq = 0.0d0  
    else
      qn = sinr2*costh0
      ql = t13b1 - t13b2*sinth02
      qq = t13c1*costh0**3 + t13c2*costh0*sinth02
    endif

    if (th0 > halfpi) then
    ! Spot is on the limb and less than half the spot is visible...

      ii(iphi) = 1
      cosphi0 = -1.0d0/(tanth0*tan(r))
      phi0 = acos(cosphi0)
      sinphi0 = sin(phi0)
      qn = (phi0*qn - asin(cosr/sinth0) - 0.5d0*sinth0*sinphi0*sin2r)/pi + 0.5d0
      if ((u1 /= 0.0d0).or.(u2 /= 0.0d0)) then
        r0 = abs(th0-halfpi)
        sinr0 = sin(r0)
        cosr0 = cos(r0)
        sin2r0 = sin(2.0d0*r0)
        cos2r0 = cos(2.0d0*r0)
        ! (19a)
        ql = (phi0/3.0d0*(cosr3-cosr0**3)* (1.0d0-3.0d0*costh0**2) -  &
             (phi0 + sinphi0*cosphi0)*(cosr - cosr0)*sinth02 +        &
             4.0d0/3.0d0*sinphi0*(sinr3-sinr0**3)*sinth0*costh0 +     &
             sinphi0*cosphi0/3.0d0*(cosr3 - cosr0**3)*sinth02)/pi
        if (u2 /= 0.0d0) then
          K1 = 0.25d0*phi0*(cosr0**4-cosr4)
          K2 = -0.125d0*sinphi0*(r0 - r + 0.5d0*(sin2r*cos2r-sin2r0*cos2r0))
          K3 = 0.125d0*(phi0+sinphi0*cosphi0)*(sinr4-sinr0**4)
          K4 = (sinphi0-sinphi0**3/3.0d0)*(0.375d0*(r-r0) +   &
               0.0625d0*(sin2r*(cos2r-4.0d0)-sin2r0*(cos2r0-4.0d0)))
          qq = (2.0d0*costh0**3*K1 +     &
                6.0d0*costh0*sinth0* (costh0*K2 + sinth0*K3) +   &
                2.0d0*sinth0**3*K4 )/pi
        endif
      endif

      ! Spot is on the limb and more than half the spot is visible...
    else if (th0 > (halfpi-r)) then

      ii(iphi) = 2
      cosphi0 = -1.0d0/(tanth0*tan(r))
      phi0 = acos(cosphi0)
      sinphi0 = sin(phi0)
      qn = (phi0*qn - asin(cosr/sinth0) - 0.5d0*sinth0*sinphi0*sin2r)/pi + 0.5d0
      if ((u1 /= 0.0d0).or.(u2 /= 0.0d0)) then
        r0 = abs(th0-halfpi)
        sinr0 = sin(r0)
        cosr0 = cos(r0)
        sin2r0 = sin(2.0d0*r0)
        cos2r0 = cos(2.0d0*r0)
        ! (18a)
        Cl = (pi-phi0)/3.0d0*(cosr3-cosr0**3)*(1.0d0-3.0d0*costh0**2) -  &
             (pi-phi0-sinphi0*cosphi0)*(cosr-cosr0)*sinth02 -   &
             4.0d0/3.0d0*sinphi0*(sinr3-sinr0**3)*sinth0*costh0 -   &
             sinphi0*cosphi0*(cosr3-cosr0**3)*sinth02/3.0d0
        ql = ql - Cl/pi
        if (u2 /= 0.0d0) then
          K1 = 0.25d0*(pi-phi0)*(cosr0**4-cosr4)
          K2 = 0.125d0*sinphi0*(r0 - r + 0.5d0*(sin2r*cos2r-sin2r0*cos2r0))
          K3 = 0.125d0*(pi-phi0+sinphi0*cosphi0)*(sinr4-sinr0**4)
          K4 = -(sinphi0-sinphi0**3/3.0d0)*(0.375d0*(r-r0) + &
                 0.0625d0*(sin2r*(cos2r-4.0d0)-sin2r0*(cos2r0-4.0d0)))
          ! (18b)
          Cq = 2.0d0*costh0**3*K1 + 6.0d0*costh0*sinth0* &
               (costh0*K2 + sinth0*K3) + 2.0d0*sinth0**3*K4
          qq = qq - Cq/pi
        endif
      endif
    endif
    ! (12c) (which reduces to (12b) and (12a) if u1=0 and/or u2=0)
    df(iphi) = 1.0d0 + fn*qn + fl*ql + fq*qq
  endif

enddo

end subroutine eker

!------------------------------------------------------------------------------

double precision function spot_limb_eclipse(ellipse, ellipse_s, xy_tng, &
                                            large, verbose)
! Fraction of a spot on the limb of a star that is eclipsed by an ellipse.
!
! Returns bad_dble is algorithm fails
! All input angles are in radians
!
implicit none
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse(n_ell_par) ! Occulting ellipse 
double precision, intent(in) :: ellipse_s(n_ell_par) ! Ellipse for spot
! (x,y) positions of tangent points between projected spot and circle
double precision, intent(in) :: xy_tng(2,2) 
logical, intent(in) :: large                       ! See below ...
integer, intent(in) :: verbose

! A circular spot on the limb in projection is seen as an ellipse that is
! interior to the circle and tangent to it at two points.
!
! large  = .true. to take the larger lens-shaped area between the tangent
!          ellipse and the circle.
!        = .false. to take the smaller crescent-shaped area between the
!          tangent ellipse and circle.
!
! Local variables
double precision :: area_flags_c(2), area_flags_s(2) 
double precision :: area_c, area_s, area_e
double precision :: xy_on_c_mid_tng(2),test_c_mid_tng,xyc_e(2),xyc_s(2)
double precision :: ell_tng_arc_area, t_tng(2)
double precision :: crescent_area,lens_area
double precision :: test_e,test_c,test_1,test_2,test_s,test_m,t_s_e(4),t_s_s(4)
double precision :: xy_int_c(2,4), xy_int_s(2,4), t_c_e(4), t_c_c(4)
double precision :: ell_arc_area, circ_arc_area, ell_arc_area_s, area_t
double precision :: xy_off(2,4), xy_on(2,4), t_on(4), t_off(4),xy_off_c(2,4)
double precision :: t_on_e(4), t_off_e(4),t_on_s(4), t_off_s(4), d_k(3)
double precision :: t_on_c_e(4), t_off_c_e(4),t_on_c_c(4), t_off_c_c(4)
double precision :: t_m, xy_m(2), xy_m_c(2), xy_on_c(2,4)
logical :: lcswitch=.false.
integer :: flag_c, flag_s, k(3)
integer :: n_onside,n_offside,i,i_on_1,i_on_2,j_on,k_in,j_off,i_on,i_off
integer :: n_on_s,n_off_s,n_on_c,n_off_c,i_c_1,i_c_2,i_s_1,i_s_2
integer :: verbose1

! Parameters
double precision, parameter :: t_eps = 1.0d-6 ! Limit for test values

verbose1 = verbose_for_calls(verbose)
spot_limb_eclipse = bad_dble

xyc_s(1:2) = (/ellipse_s(i_ell_x_c), ellipse_s(i_ell_y_c)/)

if (verbose >= v_debug) then
  print *,'spot_limb_eclipse: xy_tng,1 = ',xy_tng(1:2,1)
  print *,'                   xy_tng,2 = ',xy_tng(1:2,2)
endif

area_flags_c = ell_ucircle_overlap(ellipse,verbose1,xy_int_c,t_c_e,t_c_c)
area_c = area_flags_c(1)
flag_c = int(area_flags_c(2))
area_flags_s = ell_ell_overlap(ellipse,ellipse_s,verbose1,xy_int_s,t_s_e,t_s_s)
area_s = area_flags_s(1)
flag_s = int(area_flags_s(2))
if (verbose >= v_debug)  then
  print *,'spot_limb_eclipse: flag_c, flag_s = ',flag_c, flag_s
endif

! Ellipse does not overlap circle - 
if (btest(flag_c, b_ell_no_overlap)) then
  spot_limb_eclipse = 0.0d0
  if (verbose >= v_debug) print *,'spot_limb_eclipse: 0, ',spot_limb_eclipse
  return
endif

! Ellipse completely covers the circle
if (btest(flag_c, b_ell_circle_inside_ellipse)) then
  spot_limb_eclipse = 1.0d0
  if (verbose >= v_debug) print *,'spot_limb_eclipse: 1, ',spot_limb_eclipse
  return
endif


! Value of test_c_mid_tng is used to test on which side of the line-of-tangents
! various points lie.
t_m = atan2(xy_tng(2,1)+xy_tng(2,2),xy_tng(1,1)+xy_tng(1,2))
xy_on_c_mid_tng(1:2) = (/cos(t_m), sin(t_m)/)
test_c_mid_tng = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                               xy_on_c_mid_tng,signed=.true.)

! If ellipse is completely inside the circle and does not overlap the 
! tangent ellipse, we can do a quick check here whether the result is 0.
! This depends on which side of the line between the tangent points ellipse 1
! lies. To test this, calculate the (signed) areas of the triangles formed
! by the tangent points and i. the mid-point between the tangents on the circle
! ii. the centre of the occulting ellipse. If they have different signs then 
! the occulting ellipse cannot cover any part of the required region, so the
! result is 0.
xyc_e = (/ ellipse(i_ell_x_c), ellipse(i_ell_y_c) /)
if (btest(flag_c, b_ell_ellipse_inside_circle).and. &
    btest(flag_s, b_ell_no_overlap) ) then
  test_c = triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xyc_e,signed=.true.)
  if ((test_c > 0.0d0).neqv.(test_c_mid_tng > 0.0d0)) then
    spot_limb_eclipse = 0.0d0
    if (verbose >= v_debug) print *,'spot_limb_eclipse: 2, ',spot_limb_eclipse
    return
  endif
endif

! If ellipse is completely inside the tangent ellipse and large is false,
! the results is also 0.
if ((.not.large).and.(btest(flag_s,b_ell_1_inside_2))) then
  spot_limb_eclipse = 0.0d0
  if (verbose >= v_debug) print *,'spot_limb_eclipse: 3, ',spot_limb_eclipse
  return
endif

! Area of smaller elliptical arc for the tangent ellipse defined by the tangent 
! points
t_tng(1) = ell_xy_to_t(xy_tng(1:2,1), ellipse_s)
t_tng(2) = ell_xy_to_t(xy_tng(1:2,2), ellipse_s)
ell_tng_arc_area = ell_sector_area(t_tng(1), t_tng(2), ellipse_s) & 
                 - triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xyc_s)

! Area of the crescent between tangent ellipse and the circle
crescent_area = arc_area(xy_tng(1:2,1),xy_tng(1:2,2)) - ell_tng_arc_area

! Area of the lens-shaped area between tangent ellipse and the circle
lens_area = crescent_area + ellipse_s(i_ell_area)

! If the occulting ellipse is completely inside the circle and does not overlap
! the  tangent ellipse, we already checked for the case where the result is 0,
! so the occulting ellipse must lie in the crescent shaped region between the 
! tangent ellipse and the circle. 
if (btest(flag_c, b_ell_ellipse_inside_circle).and. &
    btest(flag_s, b_ell_no_overlap) ) then
  if (large) then
    spot_limb_eclipse = ellipse(i_ell_area)/lens_area
    if (verbose >= v_debug) print *,'spot_limb_eclipse: 4, ',spot_limb_eclipse
    return
  else
    spot_limb_eclipse = ellipse(i_ell_area)/crescent_area
    if (verbose >= v_debug) print *,'spot_limb_eclipse: 5, ',spot_limb_eclipse
    return
  endif
endif

! If the occulting ellipse is completely inside the tangent ellipse. We
! already dealt with the case large is .false., here is the result if it is 
! .true.. 
if (btest(flag_s,b_ell_1_inside_2)) then
  spot_limb_eclipse = ellipse(i_ell_area)/lens_area
  if (verbose >= v_debug) print *,'spot_limb_eclipse: 6, ',spot_limb_eclipse
  return
endif

! Tangent ellipse is completely inside ellipse 1 
if (btest(flag_s, b_ell_2_inside_1)) then

  ! If there are two intersection points between the circle and the occulting
  ! ellipse then result depends on which side of the line connecting the 
  ! tangent points they lie. Only need to check one of the intersection points 
  ! because we know here that tangent ellipse is completely inside the occulting
  ! ellipse so they must both be on the same side of this line.
  if (btest(flag_c, b_ell_two_intersects)) then
    test_1 = triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xy_int_c(1:2,1), &
                           signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
      ! Area of the smaller circular arc defined by the intersection points of 
      ! the occulting ellipse and the circle
      circ_arc_area =  arc_area(xy_int_c(1:2,1),xy_int_c(1:2,2))
      ! Area of the smaller elliptical arc on the occulting ellipse defined by 
      ! the intersection points 
      ell_arc_area = ell_sector_area(t_c_e(1),t_c_e(2),ellipse) - &
                     triangle_area(xyc_e, xy_int_c(1:2,1),xy_int_c(1:2,2))
      if (large) then
        spot_limb_eclipse = 1.0d0 - (circ_arc_area-ell_arc_area)/lens_area
        if (verbose >= v_debug) print *,'spot_limb_eclipse: 7, ', &
          spot_limb_eclipse
        return
      else
        spot_limb_eclipse = 1.0d0 - (circ_arc_area-ell_arc_area)/crescent_area
        if (verbose >= v_debug) print *,'spot_limb_eclipse: 8, ', &
          spot_limb_eclipse
        return
      endif

    else

      ! Region of interest is completely covered by the occulting ellipse
      spot_limb_eclipse = 1.0d0
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 9',spot_limb_eclipse
      return

    endif
  endif
  ! Still dealing here with the case of the tangent ellipse completely inside
  ! the occulting ellipse.
  !
  ! We have dealt with the case of two intersections between the occulting
  ! ellipse and the circle, and the case of the circle inside the occulting
  ! ellipse, so the remaining possibility is that there are four 
  ! intersections. 
  !
  ! Count the number of circle/ellipse intersection points that are on the
  ! same  side of the line between the tangent points as the mid-point on the 
  ! circle between the tangent points. Store the first/only two for later use.
  n_onside = 0
  do i=1,4
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_c(1:2,i),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
      select case (n_onside)
      case (0)
        n_onside = 1
        i_on_1 = i 
      case (1)
        n_onside = 2
        i_on_2 = i
      case default
        n_onside = n_onside + 1
      end select
    endif
  enddo 

  select case (n_onside)

  case(0)
    spot_limb_eclipse = 1.0d0
    if (verbose >= v_debug) print *,'spot_limb_eclipse: 10',spot_limb_eclipse
    return

  case(2)
    ! Area of elliptical arc on occulting ellipse between the two
    ! intersection points on the same side of line-of-tangents as mid-point
    ! on circle between tangent points.
    ell_arc_area = ell_sector_area(t_c_e(i_on_1),t_c_e(i_on_2),ellipse) - &
              triangle_area(xyc_e, xy_int_c(1:2,i_on_1),xy_int_c(1:2,i_on_2))
    ! Area of circular arc between the same two intersection points.
    circ_arc_area =  arc_area(xy_int_c(1:2,i_on_1),xy_int_c(1:2,i_on_2))
    if (large) then
      spot_limb_eclipse = 1.0d0- (circ_arc_area-ell_arc_area)/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 11', spot_limb_eclipse
      return
    else
      spot_limb_eclipse = 1.0d0- (circ_arc_area-ell_arc_area)/crescent_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 12', spot_limb_eclipse
      return
    endif

  case(4)
    if (large) then
      spot_limb_eclipse = 1.0d0 - (pi-area_c)/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 13', spot_limb_eclipse
      return
    else
      spot_limb_eclipse = 1.0d0 - (pi-area_c)/crescent_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 14', spot_limb_eclipse
      return
    endif

  case default
    if (verbose >= v_debug) then
      print *,'spot_limb_eclipse: n_onside = ',n_onside
      print *,ellipse
      print *,ellipse_s
    endif
    spot_limb_eclipse = bad_dble
    return

  end select

endif

! Occulting ellipse has four intersections with the circle and two with the
! tangent ellipse
if (btest(flag_c, b_ell_four_intersects).and. &
    btest(flag_s, b_ell_two_intersects) ) then

  ! Determine on which side of the line-of-tangents the ellipse-circle
  ! intersections occur. 
  ! n_onside = no. of points on SAME side as mid-point on circle between
  ! ellipse-circle tangent points, positions xy_on(1:2,1:n_onside)
  ! n_offside = no. of points on OPPOSITE side as mid-point on circle between
  ! ellipse-circle tangent points, positions xy_off(1:2,1:n_offside)
  n_onside = 0
  n_offside = 0
  do i=1,4
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_c(1:2,i),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
      n_onside =  n_onside + 1
      xy_on(1:2,n_onside) = xy_int_c(1:2,i)
      t_on(n_onside) = t_c_e(i)
    else
      n_offside = n_offside + 1
      xy_off(1:2,n_offside) = xy_int_c(1:2,i)
      t_off(n_offside) = t_c_e(i)
    endif
  enddo 

  select case (n_onside)

  case(0)
    if (large) then
      spot_limb_eclipse = area_s/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 17', spot_limb_eclipse
      return
    else
      spot_limb_eclipse = 0.0d0
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 18', spot_limb_eclipse
      return
    endif

  case(1)
    ! Ellipse-ellipse intersection points lie on different sides of the 
    ! line-of-tangents. Find which one is on the same side as the mid-point on
    ! the circle between the tangent points ("on-side").
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_s(1:2,1),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
      j_on =  1
    else
      j_on =  2
    endif
    ! Which tangent point is inside the occulting ellipse?
    if (ell_point_is_inside(xy_tng(1:2,1),ellipse)) then
      k_in = 1
    else
      k_in = 2
    endif
    ! Calculate the area of the three-sided shape defined by the two elliptical
    ! arcs and the circular arc between by the tangent point, the ellipse-
    ! ellipse intersection point and the ellipse-circle intersection point.
    circ_arc_area =  arc_area(xy_on(1:2,1),xy_tng(1:2,k_in))
    ell_arc_area = ell_sector_area(t_on(1),t_s_e(j_on),ellipse) - &
                   triangle_area(xy_on(1:2,1), xy_int_s(1:2,j_on), xyc_e)
    ell_arc_area_s = ell_sector_area(t_tng(k_in),t_s_s(j_on),ellipse_s) - &
                     triangle_area(xy_tng(1:2,k_in), xy_int_s(1:2,j_on), xyc_s)
    area_t = ell_arc_area + circ_arc_area - ell_arc_area_s &
           + triangle_area(xy_on(1:2,1),xy_tng(1:2,k_in),xy_int_s(1:2,j_on))
    if (large) then
      spot_limb_eclipse = (area_s + area_t)/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 19', spot_limb_eclipse
      return
    else
      spot_limb_eclipse = area_t/crescent_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 20', spot_limb_eclipse
      return
    endif

  case(2)
    ! Area of the circular arc defined by the two intersection points of
    ! the occulting ellipse and the circle that are on the same side of the
    ! line-of-tangents as the mid-point on the circle between the tangent points
    !
    circ_arc_area =  arc_area(xy_on(1:2,1),xy_on(1:2,2))
    ! Area of elliptical arc for occulting ellipse defined by the same 
    ! intersection points
    ell_arc_area = ell_sector_area(t_on(1),t_on(2),ellipse) - &
                   triangle_area(xy_on(1:2,1), xy_on(1:2,2), xyc_e)

    ! Two possibilities here, either the ellipse-ellipse intersection points are
    ! on the same side of the line-of-tangents as the mid-point on the circle
    ! between the tangent points, or both are on the opposite side. Only need to
    ! test one of the intersection points.
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_s(1:2,1),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then

      if (large) then
        spot_limb_eclipse = 1.0d0 - (circ_arc_area - ell_arc_area)/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 21', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse = 1.0d0 -  &
        (circ_arc_area-ell_arc_area - (ellipse_s(i_ell_area)-area_s)) &
        /crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 22', spot_limb_eclipse
        endif
        return
      endif

    else

      if (large) then
        spot_limb_eclipse = 1.0d0 - &
        (circ_arc_area - ell_arc_area+ellipse_s(i_ell_area)-area_s)/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 23', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse = 1.0d0 -  (circ_arc_area-ell_arc_area) &
        /crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 24', spot_limb_eclipse
        endif
        return
      endif

    endif

  case (3)
    ! Find which ellipse-ellipse intersection point is on the opposite side of 
    ! the line-of-tangents to the mid-point on the circle between the tangent
    ! points.
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_s(1:2,1),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).neqv.(test_1 > 0.0d0)) then
      j_off =  1
    else
      j_off =  2
    endif
    ! Which tangent point is inside the occulting ellipse?
    if (ell_point_is_inside(xy_tng(1:2,1),ellipse)) then
      k_in = 1
    else
      k_in = 2
    endif
    ! Calculate the area of the three-sided shape defined by the two elliptical
    ! arcs and the circular arc between by the tangent point inside the
    ! occulting ellipse, the ellipse-ellipse intersection point on the
    ! opposite side to the line-of-tangents to the mid-point on the circle 
    ! between the tangent points, and the ellipse-circle intersection point on 
    ! the same side of the line-of-tangents.

   ! Find the mid-point on the circle between the tangent points inside the
   ! occulting ellipse and the ellipse-circle intersection point on the opposite
   ! side to the line-of-tangents to the mid-point on the circle between the
   ! tangent points.
   t_m = midangle(atan2(xy_tng(2,k_in),xy_tng(1,k_in)), &
                  atan2(xy_off(2,1),xy_off(1,1)))
   xy_m_c = (/cos(t_m), sin(t_m)/)
   ! Test on which side of the line-of-tangents this point lies and use this
   ! to determine whether to calculate the larger or smaller of the two possible
   ! circular arc areas defined by the intersection/tangent points.
    test_c = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_m_c,signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_c > 0.0d0)) then
      circ_arc_area =  pi - arc_area(xy_off(1:2,1),xy_tng(1:2,k_in))
      lcswitch = .true.
    else
      circ_arc_area =  arc_area(xy_off(1:2,1),xy_tng(1:2,k_in))
      lcswitch = .false.
    endif

    ! Area of elliptical arc for occulting ellipse. Here again we need to test
    ! the mid-point between the intersection points to determine whether to use
    ! the larger or the smaller area.
    xy_m = ell_t_to_xy(midangle(t_off(1),t_s_e(j_off)),ellipse)
    test_e = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_m,signed=.true.)
    if (((test_e > 0.0d0).eqv.(test_c > 0.0d0)).neqv.lcswitch) then
      ell_arc_area = ell_sector_area(t_off(1),t_s_e(j_off),ellipse) - &
                     triangle_area(xy_off(1:2,1), xy_int_s(1:2,j_off), xyc_e)
    else
      ell_arc_area = ellipse(i_ell_area) &
                   - ell_sector_area(t_off(1),t_s_e(j_off),ellipse) &
                   + triangle_area(xy_off(1:2,1), xy_int_s(1:2,j_off), xyc_e)
    endif

    ! Area of elliptical arc for tangent ellipse - same test with mid-point
    xy_m = ell_t_to_xy(midangle(t_tng(k_in),t_s_s(j_off)),ellipse_s)
    test_s = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_m,signed=.true.)
    if (((test_s > 0.0d0).eqv.(test_c > 0.0d0)).neqv.lcswitch) then
      ell_arc_area_s = ell_sector_area(t_tng(k_in),t_s_s(j_off),ellipse_s)  &
                     - triangle_area(xy_tng(1:2,k_in),xy_int_s(1:2,j_off),xyc_s)
    else
      ell_arc_area_s = ellipse_s(i_ell_area)  &
                     - ell_sector_area(t_tng(k_in),t_s_s(j_off),ellipse_s)  &
                     + triangle_area(xy_tng(1:2,k_in),xy_int_s(1:2,j_off),xyc_s)
    endif
    area_t = ell_arc_area + circ_arc_area - ell_arc_area_s &
           + triangle_area(xy_off(1:2,1),xy_tng(1:2,k_in),xy_int_s(1:2,j_off))
    if (large) then
      spot_limb_eclipse = (area_c - area_t)/lens_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 25', spot_limb_eclipse
      endif
      return
    else
      spot_limb_eclipse = (area_c-area_s-area_t)/crescent_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 26', spot_limb_eclipse
      endif
      return
    endif

  case (4)
  ! Two possible orientations of the occulting ellipse and the tangent ellipse 
  ! here that can be distinguished by whether the point on the circle opposite
  ! the mid-point between the tangents (anti-mid-point?) is inside or outside
  ! the occulting ellipse.
    
  if (ell_point_is_inside(-xy_m_c, ellipse)) then
    if (large) then
      spot_limb_eclipse = 1.0d0  &
      - (pi - area_c - ellipse_s(i_ell_area)- area_s)/lens_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 27', spot_limb_eclipse
      endif
      return
    else
      spot_limb_eclipse = 1.0d0 - (pi - area_c - ellipse_s(i_ell_area)- area_s)&
      / crescent_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 28', spot_limb_eclipse
      endif
      return
    endif
  else
    if (large) then
      spot_limb_eclipse = area_c/lens_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 29', spot_limb_eclipse
      endif
      return
    else
      spot_limb_eclipse = (area_c-area_s)/crescent_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 30', spot_limb_eclipse
      endif
      return
    endif
  endif

  end select
endif

! Occulting ellipse intersects circle at two points but has no overlap with
! tangent  ellipse.
if (btest(flag_c, b_ell_two_intersects).and. &
    btest(flag_s, b_ell_no_overlap) ) then

  ! Test if ellipse-circle intersection points are on the same side of the 
  ! line of tangents as the mid-point on the circle between the tangent points.
  ! (Only need to test one of the points)
  test_1 = triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xy_int_c(1:2,1), &
                         signed=.true.)
  if ((test_c_mid_tng > 0.0d0).neqv.(test_1 > 0.0d0)) then
    spot_limb_eclipse = 0.0d0
    if (verbose >= v_debug) print *,'spot_limb_eclipse: 31', spot_limb_eclipse
    return
  endif

  if (large) then
    spot_limb_eclipse = area_c/lens_area
    if (verbose >= v_debug) then
      print *,'spot_limb_eclipse: 32', spot_limb_eclipse
    endif
    return
  else
    spot_limb_eclipse = area_c/crescent_area
    if (verbose >= v_debug) then
      print *,'spot_limb_eclipse: 33', spot_limb_eclipse
    endif
    return
  endif
endif


! Occulting ellipse intersects circle at two points and tangent ellipse at two
! points.

if (btest(flag_c, b_ell_two_intersects).and. &
    btest(flag_s, b_ell_two_intersects) ) then

  ! Values to determine on which side of the line-of-tangents each
  ! ellipse-ellipse intersection occurs. 
  test_1 = triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xy_int_s(1:2,1), &
                         signed=.true.)
  test_2 = triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xy_int_s(1:2,2), &
                         signed=.true.)
                         
  ! Both ellipse-ellipse intersections on same side of line-of-tangents as 
  ! mid-point on circle between tangent points 
  if ( ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) .and. &
       ((test_c_mid_tng > 0.0d0).eqv.(test_2 > 0.0d0)) ) then

    xy_m = ell_t_to_xy(midangle(t_c_e(1),t_c_e(2)),ellipse)
    if  (hypot(xy_m(1),xy_m(2)) < 1.0d0) then

      if (large) then
        spot_limb_eclipse = area_c/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 34', spot_limb_eclipse
         !!do i_on=1,2
         !!  write (34,*) xy_int_s(1:2,i_on)
         !!end do
         !!write (35,*) xy_tng(1:2,1)
         !!write (35,*) xy_tng(1:2,2)
         !!do i_on=1,10001
         !!  t_m = 2*pi*i_on/10001.0d0
         !!  write (36,*) cos(t_m),sin(t_m),&
         !!    ell_t_to_xy(t_m,ellipse_s), &
         !!    ell_t_to_xy(t_m,ellipse)
         !!end do
        endif
        return
      else
        spot_limb_eclipse = (area_c-area_s)/crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 35', spot_limb_eclipse
        endif
        return
      endif
    else
      if (large) then
        spot_limb_eclipse = 1.0D0 - (ellipse_s(i_ell_area)-area_s) &
                          / lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 36', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse = 1.0d0 - &
           (area_c - area_s) / crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 37', spot_limb_eclipse
        endif
        return
      endif
    endif

  endif

  ! Both ellipse-ellipse intersection points on the opposite side to mid-point
  ! on circle between ellipse-circle tangent point
  if ( ((test_c_mid_tng > 0.0d0).neqv.(test_1 > 0.0d0)) .and. &
       ((test_c_mid_tng > 0.0d0).neqv.(test_2 > 0.0d0)) ) then

    if (ell_point_is_inside(xy_on_c_mid_tng, ellipse)) then
      if (large) then
        spot_limb_eclipse = 1.0D0 - (ellipse_s(i_ell_area)-area_s) &
                          / lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 38', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse = 1.0d0
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 39', spot_limb_eclipse
        endif
        return
      endif
    else
      if (large) then
        spot_limb_eclipse = area_s/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 40', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse = 0.0d0
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 41', spot_limb_eclipse
        endif
        return
      endif
    endif

  endif

  ! Remaining case for two intersections of occulting ellipse with circle and
  ! tangent ellipse is ellipse-ellipse intersections on opposite side of the
  ! line-of-tangents.
  !
    
  ! Which ellipse-circle intersection point is "on-side"?
  test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                         xy_int_c(1:2,1),signed=.true.)
  if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
    i_on =  1
  else
    i_on =  2
  endif

  ! Which ellipse-ellipse intersection point is "on-side"?
  test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                         xy_int_s(1:2,1),signed=.true.)
  if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
    j_on =  1
  else
    j_on =  2
  endif

  ! Which tangent point is inside the occulting ellipse?
  if (ell_point_is_inside(xy_tng(1:2,1),ellipse)) then
    k_in = 1
  else
    k_in = 2
  endif

  circ_arc_area =  arc_area(xy_int_c(1:2,i_on),xy_tng(1:2,k_in))
  ell_arc_area = ell_sector_area(t_c_e(i_on),t_s_e(j_on),ellipse) - &
                 triangle_area(xy_int_c(1:2,i_on), xy_int_s(1:2,j_on), xyc_e)
  ell_arc_area_s = ell_sector_area(t_tng(k_in),t_s_s(j_on),ellipse_s) - &
                   triangle_area(xy_tng(1:2,k_in), xy_int_s(1:2,j_on), xyc_s)
  area_t = ell_arc_area + circ_arc_area - ell_arc_area_s &
    + triangle_area(xy_int_c(1:2,i_on),xy_tng(1:2,k_in),xy_int_s(1:2,j_on))

  if (large) then
    spot_limb_eclipse = (area_s + area_t)/lens_area
    if (verbose >= v_debug) print *,'spot_limb_eclipse: 42', spot_limb_eclipse
    return
  else
    spot_limb_eclipse = area_t/crescent_area
    if (verbose >= v_debug) print *,'spot_limb_eclipse: 43', spot_limb_eclipse
    return
  endif

endif

! Occulting ellipse intersects tangent ellipse at two points and is completely
! inside the circle
if (btest(flag_c, b_ell_ellipse_inside_circle).and. &
    btest(flag_s, b_ell_two_intersects) ) then

  ! Determine to which side of line-of-tangents occulting ellipse lies
  test_e = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                         xyc_e,signed=.true.)
  if ((test_c_mid_tng > 0.0d0).eqv.(test_e > 0.0d0)) then
    if (large) then
      spot_limb_eclipse = ellipse(i_ell_area)/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 44', spot_limb_eclipse
      return
    else
      spot_limb_eclipse = (ellipse(i_ell_area)-area_s)/crescent_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 45', spot_limb_eclipse
      return
    endif
  else
    if (large) then
      spot_limb_eclipse = area_s/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 46', spot_limb_eclipse
      return
    else
      spot_limb_eclipse = 0.0D0
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 47', spot_limb_eclipse
      return
    endif
  endif
endif

! Occulting ellipse intersects the tangent ellipse at four points and is
! completely inside circle
if (btest(flag_c, b_ell_ellipse_inside_circle).and. &
    btest(flag_s, b_ell_four_intersects) ) then
  ! Count the number of circle/ellipse intersection points that are on the
  ! same  side of the line between the tangent points as the mid-point on the 
  ! circle between the tangent points. Store the first/only two for later use.
  n_onside = 0
  do i=1,4
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_s(1:2,i),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
      select case (n_onside)
      case (0)
        n_onside = 1
        i_on_1 = i 
      case (1)
        n_onside = 2
        i_on_2 = i
      case default
        n_onside = n_onside + 1
      end select
    endif
  enddo 
  select case (n_onside)

  case (0)
    if (large) then
      spot_limb_eclipse = ellipse(i_ell_area)/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 48', spot_limb_eclipse
      return
    else
      spot_limb_eclipse = (ellipse(i_ell_area) - area_s )/crescent_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 49', spot_limb_eclipse
      return
    endif

  case (2)
    ! Calculate area of the region between the two ellipses on the same side of
    ! the line-of-tangents as the mid-point on the circle between the tangent
    ! points.
    ell_arc_area = ell_sector_area(t_s_e(i_on_1),t_s_e(i_on_2),ellipse) - &
      triangle_area(xy_int_s(1:2,i_on_1), xy_int_s(1:2,i_on_2), xyc_e)
    ell_arc_area_s = ell_sector_area(t_s_s(i_on_1),t_s_s(i_on_2),ellipse_s) - &
      triangle_area(xy_int_s(1:2,i_on_1), xy_int_s(1:2,i_on_2), xyc_s)
    area_t = ell_arc_area - ell_arc_area_s
    if (large) then
      spot_limb_eclipse = (area_s + area_t)/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 50', spot_limb_eclipse
      return
    else
      spot_limb_eclipse =  area_t/crescent_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 51', spot_limb_eclipse
      return
    endif

  case (4)
    if (large) then
      spot_limb_eclipse = area_s/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 52', spot_limb_eclipse
      return
    else
      spot_limb_eclipse =  0.0d0
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 53', spot_limb_eclipse
      return
    endif

  end select

endif

! Occulting ellipse intersects the tangent ellipse at four points and the
! circle at two points.
if (btest(flag_c, b_ell_two_intersects).and. &
    btest(flag_s, b_ell_four_intersects) ) then

  ! Determine on which side of the line-of-tangents the ellipse-ellipse
  ! intersections occur. 
  ! n_onside = no. of points on SAME side as mid-point on circle between
  ! ellipse-circle tangent points, positions xy_on(1:2,1:n_onside)
  ! n_offside = no. of points on OPPOSITE side as mid-point on circle between
  ! ellipse-circle tangent points, positions xy_off(1:2,1:n_offside)
  n_onside = 0
  n_offside = 0
  do i=1,4
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_s(1:2,i),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
      n_onside =  n_onside + 1
      xy_on(1:2,n_onside) = xy_int_s(1:2,i)
      t_on_e(n_onside) = t_s_e(i)
      t_on_s(n_onside) = t_s_s(i)
    else
      n_offside = n_offside + 1
      xy_off(1:2,n_offside) = xy_int_s(1:2,i)
      t_off_e(n_offside) = t_s_e(i)
      t_off_s(n_offside) = t_s_s(i)
    endif
  enddo 

  select case (n_offside)

  case (0)
    ! Two possible orientations of the occulting ellipse and the tangent 
    ! ellipse possible here that can be distinguished by whether the point on
    ! the circle opposite the mid-point between the tangents (anti-mid-point?) 
    ! is inside or outside ellipse 1.
    if (ell_point_is_inside(-xy_m_c, ellipse)) then

      if (large) then
        spot_limb_eclipse = 1.0d0 - (pi - area_c)/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 55', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse =  1.0d0 - &
          (pi-area_c-ellipse_s(i_ell_area)+area_s)/crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 56', spot_limb_eclipse
        endif
        return
      endif

    else

      if (large) then
        spot_limb_eclipse = area_c/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 57', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse =  (area_c-area_s)/crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 58', spot_limb_eclipse
        endif
        return
      endif

    endif

  case (1)
    ! Which ellipse-circle intersection point is "off-side"?
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_c(1:2,1),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).neqv.(test_1 > 0.0d0)) then
      i_off =  1
    else
      i_off =  2
    endif

    ! Which tangent point is inside the occulting ellipse?
    if (ell_point_is_inside(xy_tng(1:2,1),ellipse)) then
      k_in = 1
    else
      k_in = 2
    endif

    ! Find the mid-point on the circle between xy_int_c(1:2,i_off) and 
    ! xy_tng(1:2,k_in) then check whether this is inside or outside the
    ! occulting ellipse.
    t_m = midangle(atan2(xy_tng(2,k_in),xy_tng(1,k_in)), &
                   atan2(xy_int_c(2,i_off),xy_int_c(1,i_off)))
    xy_m_c = (/cos(t_m), sin(t_m)/)
    if (ell_point_is_inside(xy_m_c, ellipse)) then
      circ_arc_area =  arc_area(xy_int_c(1:2,i_off),xy_tng(1:2,k_in))
      lcswitch = .false.
    else
      circ_arc_area =  pi - arc_area(xy_int_c(1:2,i_off),xy_tng(1:2,k_in))
      lcswitch = .true.
    endif
    ! Area of elliptical arc for occulting ellipse depends on whether mid-point
    ! between xy_int_c(1:2,i_off) and xy_off(1:2,1) is on the same side of the
    ! line between these points as the tangent point inside the occulting
    ! ellipse.
    xy_m = ell_t_to_xy(midangle(t_off_e(1), t_c_e(i_off)) ,ellipse)
    test_m = triangle_area(xy_int_c(1:2,i_off), xy_off(1:2,1), &
      xy_m, signed=.true.)
    test_e = triangle_area(xy_int_c(1:2,i_off), xy_off(1:2,1), &
      xy_tng(1:2,k_in), signed=.true.)
    ! These test values may be unreliable if they are very small so..
    if (min(abs(test_m),abs(test_e)) < t_eps) then
      ell_arc_area = 0.0d0
    else
      if ((test_m > 0.0d0).neqv.(test_e > 0.0d0)) then
        ell_arc_area = ell_sector_area(t_off_e(1), t_c_e(i_off) ,ellipse) &
          - triangle_area(xy_off(1:2,1),xy_int_c(1:2,i_off),xyc_e)
      else
        ell_arc_area = ellipse(i_ell_area)   &
          -  ell_sector_area(t_off_e(1), t_c_e(i_off) ,ellipse) &
          + triangle_area(xy_off(1:2,1),xy_int_c(1:2,i_off),xyc_e)
      endif
    endif
    ! Area of elliptical arc for tangent ellipse depends on whether the
    ! mid-point between xy_tng(1:2,k_in) and xy_off(1:2,1) is on the same side
    ! or opposite side of the line between these points as xy_m_c
    xy_m = ell_t_to_xy(midangle(t_tng(k_in), t_off_s(1)), ellipse_s)
    test_m = triangle_area(xy_tng(1:2,k_in), xy_off(1:2,1), xy_m, &
      signed=.true.)
    test_c = triangle_area(xy_tng(1:2,k_in), xy_off(1:2,1), xy_m_c, &
      signed=.true.)
    if (((test_m > 0.0D0).eqv.(test_c > 0.0D0)).neqv.lcswitch) then
      ell_arc_area_s = ell_sector_area(t_tng(k_in), t_off_s(1), ellipse_s)  & 
        - triangle_area(xy_tng(1:2,k_in), xy_off(1:2,1), xyc_s)
    else
      ell_arc_area_s = ellipse_s(i_ell_area) &
        - ell_sector_area(t_tng(k_in), t_off_s(1), ellipse_s)  & 
        + triangle_area(xy_tng(1:2,k_in), xy_off(1:2,1), xyc_s)
    endif
    area_t = ell_arc_area + circ_arc_area - ell_arc_area_s & 
      + triangle_area(xy_tng(1:2,k_in),xy_off(1:2,1),xy_int_c(1:2,i_off))
    if (large) then
      spot_limb_eclipse = (area_c-area_t)/lens_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 59', spot_limb_eclipse
      endif
      return
    else
      spot_limb_eclipse =  (area_c-area_t-area_s)/crescent_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 60', spot_limb_eclipse
      endif
      return
    endif
    
  case (2)
    ! Determine whether ellipse-circle intersection points are on the same side
    ! of the line-of-tangents as the mid-point on the circle between the two
    ! tangent points. (Only need to test one of the points).
    test_1 = triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xy_int_c(1:2,1), &
                           signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
      ! The ellipse-circle intersection points are on the same side ...
      !  Area of the ellipse arc defined by the two ellipse-ellipse intersection
      ! points on the opposite side of the line of tangents to the midpoint on
      ! the circle between the two tangent points ("offside").
      !  This arc may be either the larger or the smaller of the two arcs
      ! defined by the intersection points - determine which one to use by
      ! testing whether the mid-point between the intersection points is on
      ! the same or the opposite side of the line-of-tangents at the midpoint on
      ! circle between the two tangent points.
      xy_m = ell_t_to_xy(midangle(t_off_e(1), t_off_e(2)), ellipse)
      test_m = triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xy_m, signed=.true.)
      if ((test_m > 0.0D0).eqv.(test_c_mid_tng > 0.0D0)) then
        ell_arc_area = ellipse(i_ell_area) &
        - ell_sector_area(t_off_e(1), t_off_e(2), ellipse)  & 
        + triangle_area(xy_off(1:2,1), xy_off(1:2,2), xyc_e)
      else
        ell_arc_area = ell_sector_area(t_off_e(1), t_off_e(2), ellipse)  & 
        - triangle_area(xy_off(1:2,1), xy_off(1:2,2), xyc_e)
      endif
      ! Area of the smaller elliptical arc of the tangent ellipse between the
      ! same two ellipse-ellipse intersection points.
      ell_arc_area_s = ell_sector_area(t_off_s(1), t_off_s(2), ellipse_s)  &
        - triangle_area(xy_off(1:2,1), xy_off(1:2,2), xyc_s)
      if (large) then
        spot_limb_eclipse = (area_c - ell_arc_area + ell_arc_area_s)/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 61', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse = (area_c - ell_arc_area + ell_arc_area_s - area_s) &
                            / crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 62', spot_limb_eclipse
        endif
        return
      endif
    else
      ! Area of the ellipse arc defined by the two ellipse-ellipse intersection
      ! points on the same side of the line of tangents to the midpoint on the
      ! circle between the two tangent points. Of the two possible ellipse arcs,
      ! use the one that also lies on the same side of the line of tangents as
      ! the midpoint on the circle between the two tangent points.
      
      xy_m = ell_t_to_xy(midangle(t_on_e(1), t_on_e(2)), ellipse)
      test_m = triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xy_m, signed=.true.)
      if ((test_m > 0.0D0).eqv.(test_c_mid_tng > 0.0D0)) then
        ell_arc_area = ell_sector_area(t_on_e(1), t_on_e(2), ellipse)  & 
        - triangle_area(xy_on(1:2,1), xy_on(1:2,2), xyc_e)
      else
        ell_arc_area = ellipse(i_ell_area) &
        - ell_sector_area(t_on_e(1), t_on_e(2), ellipse)  & 
        + triangle_area(xy_on(1:2,1), xy_on(1:2,2), xyc_e)
      endif
      ! Area of the smaller elliptical arc of the tangent ellipse between the
      ! same two ellipse-ellipse intersection points.
      ell_arc_area_s = ell_sector_area(t_on_s(1), t_on_s(2), ellipse_s)  &
        - triangle_area(xy_on(1:2,1), xy_on(1:2,2), xyc_s)
      if (large) then
        spot_limb_eclipse = (area_s + ell_arc_area - ell_arc_area_s)/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 63', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse = (ell_arc_area- ell_arc_area_s) / crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 64', spot_limb_eclipse
        endif
        return
      endif
       
    endif

  case (3)
    ! Which ellipse-circle intersection point is "on-side"?
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_c(1:2,1),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
      i_on =  1
    else
      i_on =  2
    endif

    ! Which tangent point is inside the occulting ellipse?
    if (ell_point_is_inside(xy_tng(1:2,1),ellipse)) then
      k_in = 1
    else
      k_in = 2
    endif

    circ_arc_area =  arc_area(xy_int_c(1:2,i_on),xy_tng(1:2,k_in))
    ell_arc_area = ell_sector_area(t_c_e(i_on),t_on_e(1),ellipse) - &
                   triangle_area(xy_int_c(1:2,i_on), xy_on(1:2,1), xyc_e)
    ell_arc_area_s = ell_sector_area(t_tng(k_in),t_on_s(1),ellipse_s) - &
                     triangle_area(xy_tng(1:2,k_in), xy_on(1:2,1), xyc_s)
    area_t = ell_arc_area + circ_arc_area - ell_arc_area_s &
      + triangle_area(xy_int_c(1:2,i_on),xy_tng(1:2,k_in),xy_on(1:2,1))

    if (large) then
      spot_limb_eclipse = (area_s + area_t)/lens_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 65', spot_limb_eclipse
      return
    else
      spot_limb_eclipse = area_t/crescent_area
      if (verbose >= v_debug) print *,'spot_limb_eclipse: 66', spot_limb_eclipse
      return
    endif

  case (4)
    if (large) then
      spot_limb_eclipse = area_s/lens_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 67', spot_limb_eclipse
      endif
      return
    else
      spot_limb_eclipse =  0.0d0
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 68 ', spot_limb_eclipse
      endif
      return
    endif

  end select

endif 

! Occulting ellipse intersects the circle at four points but does not overlap
! the tangent ellipse.
if (btest(flag_c, b_ell_four_intersects).and. &
    btest(flag_s, b_ell_no_overlap) ) then
  ! Test on which side of the line-of-tangents the ellipse-circle intersects
  ! lie (only need to test one)
  test_1 = triangle_area(xy_tng(1:2,1), xy_tng(1:2,2), xy_int_c(1:2,1), &
                         signed=.true.)
  if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
    if (large) then
      spot_limb_eclipse = area_c/lens_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 69', spot_limb_eclipse
      endif
      return
    else
      spot_limb_eclipse =  area_c/crescent_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 70 ', spot_limb_eclipse
      endif
      return
    endif
  else 
    spot_limb_eclipse =  0.0d0
    if (verbose >= v_debug) print *,'spot_limb_eclipse: 71 ', spot_limb_eclipse
  endif

endif

if (btest(flag_c, b_ell_four_intersects).and. &
    btest(flag_s, b_ell_four_intersects) ) then
    
  ! Determine on which side of the line-of-tangents the ellipse-ellipse
  ! intersections occur. 
  ! n_onside = no. of points on SAME side as mid-point on circle between
  ! ellipse-circle tangent points, positions xy_on(1:2,1:n_onside)
  ! n_offside = no. of points on OPPOSITE side as mid-point on circle between
  ! ellipse-circle tangent points, positions xy_off(1:2,1:n_offside)
  n_on_s = 0
  n_off_s = 0
  do i=1,4
    test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), &
                           xy_int_s(1:2,i),signed=.true.)
    if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
      n_on_s =  n_on_s + 1
      xy_on(1:2,n_on_s) = xy_int_s(1:2,i)
      t_on_e(n_on_s) = t_s_e(i)
      t_on_s(n_on_s) = t_s_s(i)
    else
      n_off_s = n_off_s + 1
      xy_off(1:2,n_off_s) = xy_int_s(1:2,i)
      t_off_e(n_off_s) = t_s_e(i)
      t_off_s(n_off_s) = t_s_s(i)
    endif
  enddo 
  
  select case(n_off_s)

  case(0)
    ! Two cases here depending on whether there are 2 or 4 ellipse-circle
    ! intersection points on the same side of the line-of-tangents as the
    ! mid-point on the circle between the tangent points.
    n_on_c = 0
    n_off_c = 0
    do i=1,4
      test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), xy_int_c(1:2,i),&
                             signed=.true.)
      if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
        n_on_c = n_on_c + 1
      else
        n_off_c = n_off_c + 1
        xy_off_c(1:2,n_off_c) = xy_int_c(1:2,i)
        t_off_c_e(n_off_c) = t_c_e(i)
        t_off_c_c(n_off_c) = t_c_c(i)
      endif
    end do

    select case (n_on_c)
    case (2)
      if (large) then
        ! Area between circle and ellipse opposite the mid-point on the circle
        ! between the line of tangents depends on whether the mid-point on the
        ! circle between the "off-side" ellipse-circle intersection points is
        ! on the same side of the line between these points as the mid-point
        ! on the circle between the tangent points.
        t_m = midangle(t_off_c_c(1), t_off_c_c(2))
        xy_m = (/cos(t_m), sin(t_m)/)
        test_c = triangle_area(xy_off_c(1:2,1), xy_off_c(1:2,2), xy_m, &
                               signed=.true.)
        test_m = triangle_area(xy_off_c(1:2,1), xy_off_c(1:2,2), xy_m_c, &
                               signed=.true.)
        if ((test_c > 0.0d0).eqv.(test_m > 0.0d0)) then
          circ_arc_area = pi - arc_area(xy_off_c(1:2,1), xy_off_c(1:2,2))
        else 
          circ_arc_area = arc_area(xy_off_c(1:2,1), xy_off_c(1:2,2))
        endif

        ell_arc_area = ell_sector_area(t_off_c_e(1),t_off_c_e(2),ellipse) - &
                 triangle_area(xy_off_c(1:2,1), xy_off_c(1:2,2), xyc_e)
        spot_limb_eclipse =  1.0d0 - &
          (pi-area_c-circ_arc_area+ell_arc_area-ellipse_s(i_ell_area)+area_s) &
          / lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 72 ', spot_limb_eclipse
        endif
        return
        
      else
        spot_limb_eclipse =  (ellipse_s(i_ell_area) - area_s)/crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 73 ', spot_limb_eclipse
        endif
      endif

      case (4)
      if (large) then
        spot_limb_eclipse = area_s/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 74', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse =  (area_c-area_s)/crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 75 ', spot_limb_eclipse
        endif
        return
      endif

    end select

  case (1)
    ! Two possibilities here depending on whether there are 1 or 3
    ! ellipse-circle intersection points on the same side of the
    ! line-of-tangents as the mid-point on circle between tangent points.
    n_on_c = 0
    n_off_c = 0
    do i=1,4
      test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), xy_int_c(1:2,i),&
                             signed=.true.)
      if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
        n_on_c = n_on_c + 1
        xy_on_c(1:2,n_on_c) = xy_int_c(1:2,i)
        t_on_c_e(n_on_c) = t_c_e(i)
        t_on_c_c(n_on_c) = t_c_c(i)
      else
        n_off_c = n_off_c + 1
        xy_off_c(1:2,n_off_c) = xy_int_c(1:2,i)
        t_off_c_e(n_off_c) = t_c_e(i)
        t_off_c_c(n_off_c) = t_c_c(i)
      endif
    end do

    ! Which tangent point is inside the occulting ellipse?
    if (ell_point_is_inside(xy_tng(1:2,1),ellipse)) then
      k_in = 1
    else
      k_in = 2
    endif

    select case (n_on_c)

    case (1) 
      ! Find which of the three ellipse-ellipse intersection points on the same
      ! side of the line-of-tangents as the mid-point on circle between the
      ! tangent point is closest to the ellipse-circle intersection point on the
      ! same side of the line-of-tangents ("on-side").
      do i=1,3
        d_k(i) = distance(xy_on(1:2,i), xy_on_c(1:2,1))
      end do
      call heapsort(d_k,k)
      ! Calculate the area of the three-sided shape defined by the two
      ! elliptical arcs and the circular arc between by the tangent point inside
      ! the occulting ellipse, the on-side ellipse-circle intersection point and
      ! the nearest on-side ellipse-ellipse intersection point to this
      ! ellipse-circle intersection point.
      
      ! Area of the circular arc
      circ_arc_area = arc_area(xy_on_c(1:2,1), xy_tng(1:2,k_in))

      ! Area of elliptical arc for occulting ellipse
      ell_arc_area = ell_sector_area(t_on_c_e(1),t_on_e(k(1)),ellipse) - &
        triangle_area(xy_on_c(1:2,1), xy_on(1:2,k(1)), xyc_e)
      
      ! Area of elliptical arc for tangent ellipse
      ell_arc_area_s = ell_sector_area(t_tng(k_in),t_on_s(k(1)),ellipse_s) - &
        triangle_area(xy_tng(1:2, k_in), xy_on(1:2,k(1)), xyc_s)

      area_t = ell_arc_area + circ_arc_area - ell_arc_area_s  &
      + triangle_area(xy_on_c(1:2,1), xy_tng(1:2,k_in), xy_on(1:2,k(1)))

      ! Area defined by the two elliptical arcs between their two on-side 
      ! intersections that are not closest to the interior tangent point.
      ell_arc_area = ell_sector_area(t_on_e(k(2)),t_on_e(k(3)),ellipse) - &
        triangle_area(xy_on(1:2,k(2)), xy_on(1:2,k(3)), xyc_e)
      ell_arc_area_s = ell_sector_area(t_on_s(k(2)),t_on_s(k(3)),ellipse_s) - &
        triangle_area(xy_on(1:2,k(2)), xy_on(1:2,k(3)), xyc_s)
      area_e = ell_arc_area - ell_arc_area_s

      if (large) then
        spot_limb_eclipse = (ellipse_s(i_ell_area)+area_t+area_e)/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 76', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse =  (area_t+area_e)/crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 77 ', spot_limb_eclipse
        endif
        return
      endif
      
    case (3)
      ! Calculate the area of the three-sided shape defined by the two
      ! elliptical arcs and the circular arc between the tangent point, the
      ! ellipse-ellipse intersection point and the ellipse-circle intersection
      ! point.
      
      ! Find the mid-point on the circle between offside ellipse-circle
      ! intersection and the interior tangent point and check on which side of
      ! the line-of-tangents it lies.
      t_m = midangle(atan2(xy_tng(2,k_in),xy_tng(1,k_in)), t_off_c_c(1))
      xy_m = (/cos(t_m), sin(t_m)/)
      test_c = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), xy_m, &
                             signed=.true.)
      if ((test_c > 0.0d0).eqv.(test_c_mid_tng > 0.0d0)) then
        circ_arc_area = pi - arc_area(xy_off_c(1:2,1), xy_tng(1:2,k_in))
      else 
        circ_arc_area = arc_area(xy_off_c(1:2,1), xy_tng(1:2,k_in))
      endif

      ! Area of elliptical arc for occulting ellipse
      ell_arc_area = ell_sector_area(t_off_c_e(1),t_off_e(1),ellipse) - &
        triangle_area(xy_off_c(1:2,1), xy_off(1:2,1), xyc_e)

      ! Area of elliptical arc for tangent ellipse depends on whether the
      ! mid-point between xy_tng(1:2,k_in) and xy_off(1:2,1) is on the same side
      ! or opposite side of the line between these points as xy_m_c
      xy_m = ell_t_to_xy(midangle(t_tng(k_in), t_off_s(1)), ellipse_s)
      test_m = triangle_area(xy_tng(1:2,k_in), xy_off(1:2,1), xy_m, &
        signed=.true.)
      test_c = triangle_area(xy_tng(1:2,k_in), xy_off(1:2,1), xy_m_c, &
        signed=.true.)
      if (((test_m > 0.0D0).eqv.(test_c > 0.0D0)).neqv.lcswitch) then
        ell_arc_area_s = ell_sector_area(t_tng(k_in), t_off_s(1), ellipse_s)  & 
          - triangle_area(xy_tng(1:2,k_in), xy_off(1:2,1), xyc_s)
      else
        ell_arc_area_s = ellipse_s(i_ell_area) &
          - ell_sector_area(t_tng(k_in), t_off_s(1), ellipse_s)  & 
          + triangle_area(xy_tng(1:2,k_in), xy_off(1:2,1), xyc_s)
      endif

      area_t = ell_arc_area + circ_arc_area - ell_arc_area_s + &
               triangle_area(xy_off_c(1:2,1), xy_off(1:2,1),xy_tng(1:2,k_in))

      if (large) then
        spot_limb_eclipse = (area_c - area_t)/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 78', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse =  (area_c-area_t - area_s)/crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 79 ', spot_limb_eclipse
        endif
        return
      endif

    end select
    
  case (2) !  = n_off_s, number of off-side ellipse-ellipse intersections
    ! Still in 4 ellipse-ellipse and 4 ellipse-circle intersections case
    ! Four possible configurations here distinguished by whether the tangent
    ! points are inside the occulting ellipse or not - only need to check one of
    ! the tangent points - and the number of circle-ellipse intersection points
    ! on the same side of the line of tangents as the mid-point on the circle
    ! between the tangent points ("on-side"). 
    n_on_c = 0
    do i=1,4
      test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), xy_int_c(1:2,i),&
                             signed=.true.)
      if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
        n_on_c = n_on_c + 1
        xy_on_c(1:2,n_on_c) = xy_int_c(1:2,i)
        t_on_c_e(n_on_c) = t_c_e(i)
        t_on_c_c(n_on_c) = t_c_c(i)
        if (n_on_c == 2) exit
      endif
    end do
    if (ell_point_is_inside(xy_tng(1:2,1),ellipse)) then
        ! Calculate the sum of the areas of the two three-sided shapes defined
        ! by the two elliptical arcs and a circular arc between each tangent
        ! point and the nearest on-side ellipse-ellipse intersection point and
        ! the nearest on-side ellipse-circle intersection point.
        
        if (distance(xy_tng(1:2,1), xy_on_c(1:2,1)) < & 
            distance(xy_tng(1:2,1), xy_on_c(1:2,2)) ) then
          i_c_1 = 1
          i_c_2 = 2
        else
          i_c_1 = 2
          i_c_2 = 1
        endif
        
        if (distance(xy_tng(1:2,1), xy_on(1:2,1)) < & 
            distance(xy_tng(1:2,1), xy_on(1:2,2)) ) then
          i_s_1 = 1
          i_s_2 = 2
        else
          i_s_1 = 2
          i_s_2 = 1
        endif
        ! First tangent point
        circ_arc_area = arc_area(xy_on_c(1:2,i_c_1), xy_tng(1:2,1))
        ell_arc_area = &
          ell_sector_area(t_on_c_e(i_c_1),t_on_e(i_s_1),ellipse) - &
          triangle_area(xy_on_c(1:2,i_c_1), xy_on(1:2,i_s_1), xyc_e)
        ell_arc_area_s = ell_sector_area(t_on_s(i_s_1),t_tng(1),ellipse_s) - &
          triangle_area(xy_on(1:2,i_s_1), xy_tng(1:2,1), xyc_s)
        area_t =  circ_arc_area + ell_arc_area - ell_arc_area_s + &
          triangle_area(xy_on_c(1:2,i_c_1), xy_tng(1:2,1),xy_on(1:2,i_s_1))

        ! Second tangent point
        circ_arc_area = arc_area(xy_on_c(1:2,i_c_2), xy_tng(1:2,2))
        ell_arc_area = &
          ell_sector_area(t_on_c_e(i_c_2),t_on_e(i_s_2),ellipse) - &
          triangle_area(xy_on_c(1:2,i_c_2), xy_on(1:2,i_s_2), xyc_e)
        ell_arc_area_s = ell_sector_area(t_on_s(i_s_2),t_tng(2),ellipse_s) - &
          triangle_area(xy_on(1:2,i_s_2), xy_tng(1:2,2), xyc_s)
        area_t =  area_t + circ_arc_area + ell_arc_area - ell_arc_area_s + &
          triangle_area(xy_on_c(1:2,i_c_2), xy_tng(1:2,2),xy_on(1:2,i_s_2))

        if (large) then
          spot_limb_eclipse = (area_s +  area_t)/lens_area
          if (verbose >= v_debug) then
            print *,'spot_limb_eclipse: 80', spot_limb_eclipse
          endif
          return
        else
          spot_limb_eclipse =  area_t/crescent_area
          if (verbose >= v_debug) then
            print *,'spot_limb_eclipse: 81', spot_limb_eclipse
          endif
          return
        endif

      return

    else ! tangent points are not inside the occulting ellipse

      n_on_c = 0
      n_off_c = 0
      do i=1,4
        test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), xy_int_c(1:2,i),&
                               signed=.true.)
        if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
          n_on_c = n_on_c + 1
          xy_on_c(1:2,n_on_c) = xy_int_c(1:2,i)
          t_on_c_e(n_on_c) = t_c_e(i)
          t_on_c_c(n_on_c) = t_c_c(i)
        else
          n_off_c = n_off_c + 1
          xy_off_c(1:2,n_off_c) = xy_int_c(1:2,i)
          t_off_c_e(n_off_c) = t_c_e(i)
          t_off_c_c(n_off_c) = t_c_c(i)
        endif
      end do
      select case (n_on_c)
      case (0) 
        ! Areas of elliptical arcs defined by the ellipse-ellipse intersection
        ! points on the same side of the line of tangents as the mid-point on
        ! the circle between the tangent points ("on-side").

        ! For the occulting ellipse, need to check whether the mid-point on the
        ! ellipse between the on-side intersection points is also on-side
        xy_m = ell_t_to_xy(midangle(t_on_e(1), t_on_e(2)), ellipse)
        test_m = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), xy_m,&
                               signed=.true.)
        if ((test_m > 0.0D0).eqv.(test_c_mid_tng > 0.0D0)) then
          ell_arc_area = ell_sector_area(t_on_e(1), t_on_e(2), ellipse)  & 
          - triangle_area(xy_on(1:2,1), xy_on(1:2,2), xyc_e)
        else
          ell_arc_area = ellipse(i_ell_area) &
          - ell_sector_area(t_on_e(1), t_on_e(2), ellipse)  & 
          + triangle_area(xy_on(1:2,1), xy_on(1:2,2), xyc_e)
        endif
        ! Area of the smaller elliptical arc of the tangent ellipse between the
        ! same two ellipse-ellipse intersection points.
        ell_arc_area_s = ell_sector_area(t_on_s(1), t_on_s(2), ellipse_s)  & 
          - triangle_area(xy_on(1:2,1), xy_on(1:2,2), xyc_s)
        if (large) then
          spot_limb_eclipse = (area_s - ell_arc_area - ell_arc_area_s)/lens_area
          if (verbose >= v_debug) then
            print *,'spot_limb_eclipse: 82', spot_limb_eclipse
          endif
          return
        else
          spot_limb_eclipse =  (ell_arc_area - ell_arc_area_s)/crescent_area
          if (verbose >= v_debug) then
            print *,'spot_limb_eclipse: 83 ', spot_limb_eclipse
          endif
          return
        endif

      case (2) 
        ! Calculate the sum of the areas of the two three-sided shapes defined
        ! by the two elliptical arcs and a circular arc between each tangent
        ! point and the nearest on-side ellipse-ellipse intersection point and
        ! the nearest on-side ellipse-circle intersection point.
        
        if (distance(xy_tng(1:2,1), xy_on_c(1:2,1)) < & 
            distance(xy_tng(1:2,1), xy_on_c(1:2,2)) ) then
          i_c_1 = 1
          i_c_2 = 2
        else
          i_c_1 = 2
          i_c_2 = 1
        endif
        
        if (distance(xy_tng(1:2,1), xy_on(1:2,1)) < & 
            distance(xy_tng(1:2,1), xy_on(1:2,2)) ) then
          i_s_1 = 1
          i_s_2 = 2
        else
          i_s_1 = 2
          i_s_2 = 1
        endif
        ! First tangent point
        circ_arc_area = arc_area(xy_on_c(1:2,i_c_1), xy_tng(1:2,1))
        ell_arc_area = &
          ell_sector_area(t_on_c_e(i_c_1),t_on_e(i_s_1),ellipse) - &
          triangle_area(xy_on_c(1:2,i_c_1), xy_on(1:2,i_s_1), xyc_e)
        ell_arc_area_s = ell_sector_area(t_on_s(i_s_1),t_tng(1),ellipse_s) - &
          triangle_area(xy_on(1:2,i_s_1), xy_tng(1:2,1), xyc_s)
        area_t =  circ_arc_area - ell_arc_area - ell_arc_area_s + &
          triangle_area(xy_on_c(1:2,i_c_1), xy_tng(1:2,1),xy_on(1:2,i_s_1))

        ! Second tangent point
        circ_arc_area = arc_area(xy_on_c(1:2,i_c_2), xy_tng(1:2,2))
        ell_arc_area = &
          ell_sector_area(t_on_c_e(i_c_2),t_on_e(i_s_2),ellipse) - &
          triangle_area(xy_on_c(1:2,i_c_2), xy_on(1:2,i_s_2), xyc_e)
        ell_arc_area_s = ell_sector_area(t_on_s(i_s_2),t_tng(2),ellipse_s) - &
          triangle_area(xy_on(1:2,i_s_2), xy_tng(1:2,2), xyc_s)
        area_t =  area_t + circ_arc_area - ell_arc_area - ell_arc_area_s + &
          triangle_area(xy_on_c(1:2,i_c_2), xy_tng(1:2,2),xy_on(1:2,i_s_2))

        if (large) then
          spot_limb_eclipse = (area_s + crescent_area - area_t)/lens_area
          if (verbose >= v_debug) then
            print *,'spot_limb_eclipse: 84', spot_limb_eclipse
          endif
          return
        else
          spot_limb_eclipse =  1.0d0 - area_t/crescent_area
          if (verbose >= v_debug) then
            print *,'spot_limb_eclipse: 85 ', spot_limb_eclipse
          endif
          return
        endif

      case (4) 
        ! Areas of elliptical arcs defined by the ellipse-ellipse intersection
        ! points on the same side of the line of tangents as the mid-point on
        ! the circle between the tangent points ("off-side").

        ! For the occulting ellipse, need to check whether the mid-point on the
        ! ellipse between the off-side intersection points is also off-side
        xy_m = ell_t_to_xy(midangle(t_off_e(1), t_off_e(2)), ellipse)
        test_m = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), xy_m,&
                               signed=.true.)
        if ((test_m > 0.0D0).eqv.(test_c_mid_tng > 0.0D0)) then
          ell_arc_area = ellipse(i_ell_area) &
          - ell_sector_area(t_off_e(1), t_off_e(2), ellipse)  & 
          + triangle_area(xy_off(1:2,1), xy_off(1:2,2), xyc_e)
        else
          ell_arc_area = ell_sector_area(t_off_e(1), t_off_e(2), ellipse)  & 
          - triangle_area(xy_off(1:2,1), xy_off(1:2,2), xyc_e)
        endif
        ! Area of the smaller elliptical arc of the tangent ellipse between the
        ! same two ellipse-ellipse intersection points.
        ell_arc_area_s = ell_sector_area(t_off_s(1), t_off_s(2), ellipse_s)  & 
          - triangle_area(xy_off(1:2,1), xy_off(1:2,2), xyc_s)
        if (large) then
          spot_limb_eclipse = (area_c - ell_arc_area + ell_arc_area_s)/lens_area
          if (verbose >= v_debug) then
            print *,'spot_limb_eclipse: 86', spot_limb_eclipse
          endif
          return
        else
          spot_limb_eclipse = (area_c - ell_arc_area + ell_arc_area_s - area_s)&
            /crescent_area
          if (verbose >= v_debug) then
            print *,'spot_limb_eclipse: 87 ', spot_limb_eclipse
          endif
          return
        endif

      end select ! n_on_c

    endif

  case (3) !  = n_off_s, number of off-side ellipse-ellipse intersections
    ! Still in 4 ellipse-ellipse and 4 ellipse-circle intersections case
    !
    ! Two possibilities here depending on whether there are 1 or 3
    ! ellipse-circle intersection points on the same side of the
    ! line-of-tangents as the mid-point on circle between tangent points
    ! ("on-side")
    n_on_c = 0
    n_off_c = 0
    do i=1,4
      test_1 = triangle_area(xy_tng(1:2,1),xy_tng(1:2,2), xy_int_c(1:2,i),&
                             signed=.true.)
      if ((test_c_mid_tng > 0.0d0).eqv.(test_1 > 0.0d0)) then
        n_on_c = n_on_c + 1
        xy_on_c(1:2,n_on_c) = xy_int_c(1:2,i)
        t_on_c_e(n_on_c) = t_c_e(i)
        t_on_c_c(n_on_c) = t_c_c(i)
      else
        n_off_c = n_off_c + 1
        xy_off_c(1:2,n_off_c) = xy_int_c(1:2,i)
        t_off_c_e(n_off_c) = t_c_e(i)
        t_off_c_c(n_off_c) = t_c_c(i)
      endif
    end do

    ! Which tangent point is inside the occulting ellipse?
    if (ell_point_is_inside(xy_tng(1:2,1),ellipse)) then
      k_in = 1
    else
      k_in = 2
    endif

    select case (n_off_c)

    case (1) 
      ! Find which of the three ellipse-ellipse intersection points on the
      ! off-side is closest to the off-side ellipse-circle intersection point
      do i=1,3
        d_k(i) = distance(xy_off(1:2,i), xy_off_c(1:2,1))
      end do
      call heapsort(d_k,k)
      ! Calculate the area of the three-sided shape defined by the two
      ! elliptical arcs and the circular arc between by the tangent point inside
      ! the occulting ellipse, the off-side ellipse-circle intersection point
      ! and the nearest off-side ellipse-ellipse intersection point to this
      ! ellipse-circle intersection point.
      
      ! Area of the circular arc
      circ_arc_area = arc_area(xy_off_c(1:2,1), xy_tng(1:2,k_in))

      ! Area of elliptical arc for occulting ellipse
      ell_arc_area = ell_sector_area(t_off_c_e(1),t_off_e(k(1)),ellipse) - &
        triangle_area(xy_off_c(1:2,1), xy_off(1:2,k(1)), xyc_e)
      
      ! Area of elliptical arc for tangent ellipse
      ell_arc_area_s = ell_sector_area(t_tng(k_in),t_off_s(k(1)),ellipse_s) - &
        triangle_area(xy_tng(1:2, k_in), xy_off(1:2,k(1)), xyc_s)

      area_t = ell_arc_area + circ_arc_area - ell_arc_area_s  &
      + triangle_area(xy_off_c(1:2,1), xy_tng(1:2,k_in), xy_off(1:2,k(1)))

      ! Area defined by the two elliptical arcs between their two off-side 
      ! intersections that are not closest to the interior tangent point.
      ell_arc_area = ell_sector_area(t_off_e(k(2)),t_off_e(k(3)),ellipse) - &
        triangle_area(xy_off(1:2,k(2)), xy_off(1:2,k(3)), xyc_e)
      ell_arc_area_s = ell_sector_area(t_off_s(k(2)),t_off_s(k(3)),ellipse_s)- &
        triangle_area(xy_off(1:2,k(2)), xy_off(1:2,k(3)), xyc_s)
      area_e = ell_arc_area - ell_arc_area_s

      if (large) then
        spot_limb_eclipse = (area_c - area_t -area_e)/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 88', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse =  (area_c - area_t -area_e-area_s)/crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 89 ', spot_limb_eclipse
        endif
        return
      endif
      
    case (3) ! n_off_c = no. of offside ellipse, circle intersects
      ! Calculate the area of the three-sided shape defined by the two
      ! elliptical arcs and the circular arc between the tangent point, the
      ! ellipse-ellipse intersection point and the ellipse-circle intersection
      ! point.
      
      circ_arc_area = arc_area(xy_on_c(1:2,1), xy_tng(1:2,k_in))
      ell_arc_area = ell_sector_area(t_on_c_e(1),t_on_e(1),ellipse) - &
        triangle_area(xy_on_c(1:2,1), xy_on(1:2,1), xyc_e)
      ell_arc_area_s = ell_sector_area(t_tng(k_in), t_on_s(1), ellipse_s)  & 
        - triangle_area(xy_tng(1:2,k_in), xy_on(1:2,1), xyc_s)

      area_t = ell_arc_area + circ_arc_area - ell_arc_area_s + &
               triangle_area(xy_on_c(1:2,1), xy_on(1:2,1),xy_tng(1:2,k_in))

      if (large) then
        spot_limb_eclipse = (area_s + area_t)/lens_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 90', spot_limb_eclipse
        endif
        return
      else
        spot_limb_eclipse =  area_t/crescent_area
        if (verbose >= v_debug) then
          print *,'spot_limb_eclipse: 91 ', spot_limb_eclipse
        endif
        return
      endif

    end select
    
  case (4) !  = n_off_s, number of off-side ellipse-ellipse intersections
    ! Still in 4 ellipse-ellipse and 4 ellipse-circle intersections case

    if (large) then
      spot_limb_eclipse = area_s/lens_area
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 92', spot_limb_eclipse
      endif
      return
    else
      spot_limb_eclipse = 0.0d0
      if (verbose >= v_debug) then
        print *,'spot_limb_eclipse: 93 ', spot_limb_eclipse
      endif
      return
    endif
  end select

  endif

end function spot_limb_eclipse

!------------------------------------------------------------------------------

subroutine project_spot(alpha_s, beta_s, gamma_s, ellipse_s, uv_tng)
!
! Ellipse that is the projection of a circular spot on a spherical star onto
! the plane of the sky, and the coordinates of the tangent points of this
! ellipse with the projected limb of the star for spots on the limb.
!
! The spot is assumed to be on a spherical star of unit radius centred on the
! origin. The spot edge is defined by the intersection of a cone with its vertex
! at the origin and with opening angle gamma_s.
!
! The spot longitude alpha_s is measured from the u-axis towards the v-axis in
! the u-v plane.  The star is viewed from the positive w direction. The spot
! latitude beta_s is measured from the u-v plane towards the w-axis
!
implicit none
double precision, intent(in) :: alpha_s, beta_s, gamma_s ! Spot coords/size
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(out) :: ellipse_s(n_ell_par) ! Projected ellipse
double precision, intent(out) :: uv_tng(2,2)          ! Tangent points

! Local variables
double precision :: sina, cosa, sinb, cosb, sing, cosg
double precision :: a_p, b_p, u_c, v_c, sint_t, cost_t, d
double precision :: ellpar_s(5) ! Ellipse parameters for projected spot

! Projection of the spot onto the u-v plane is an ellipse
sina = sin(alpha_s)
sinb = sin(beta_s)
sing = sin(gamma_s)
cosa = cos(alpha_s)
cosb = cos(beta_s)
cosg = cos(gamma_s)
! ellpar_s = [a_p, b_p, u_c, v_c, phi]
a_p = sing
b_p = abs(sinb)*sing
u_c = cosa*cosb*cosg
v_c = sina*cosb*cosg
ellpar_s = (/a_p, b_p, u_c, v_c, halfpi + alpha_s/)
ellipse_s = ell_init_from_par(ellpar_s)

! For a spot on the limb there are two tangent points between the projected
! ellipse and the unit circle corresponding to z=0. Calculate their positions.
d = cosb*sing
if ( d == 0.0d0) then
  uv_tng(:,:) = bad_dble
else
  sint_t = -abs(sinb*cosg/d)
  if (abs(sint_t) <= 1.0d0) then
    cost_t = sqrt(1.0d0 - sint_t**2)
    uv_tng(1,1) = -a_p*sina*cost_t  - b_p*cosa*sint_t + u_c
    uv_tng(2,1) =  a_p*cosa*cost_t  - b_p*sina*sint_t + v_c
    cost_t = -cost_t
    uv_tng(1,2) = -a_p*sina*cost_t  - b_p*cosa*sint_t + u_c
    uv_tng(2,2) =  a_p*cosa*cost_t  - b_p*sina*sint_t + v_c
  else
    uv_tng(:,:) = not_set_dble
  endif
endif


end subroutine project_spot

end module spots

! This file is part of the ellc binary star model
! Copyright (C) 2016 Pierre Maxted
! 
! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

MODULE  constants
!
! Program constants for ellc and an interface routine to make these accesible
! from python
!
! HISTORY
! -------
! Jan 2016
! First version 
! p.maxted@keele.ac.uk
!
!

implicit none

public  !  All constants are here to be used. 

! Return error values for functions.
! Integer error return value
integer,  parameter :: bad_int  = -2147483647     
! Double precision error return value
double precision, parameter :: bad_dble = -1.7976931348623157d+308

! Dummy value for quantities not yet defined
! Undefined double precision
double precision, parameter :: not_set_dble = 8.9884656743115785d+307
! Undefined integer
integer,  parameter :: not_set_int  = 2147483646

! Number of parameters in the light curve model
integer, parameter :: n_par = 39   ! Number of double-precision parameters
integer, parameter :: n_ipar =10   ! Number of integer parameters

! Star shape models
integer, parameter :: starshape_roche_v   = -2  ! Roche model, exact volume
integer, parameter :: starshape_roche     = -1  ! Roche model
integer, parameter :: starshape_sphere    =  0  ! Sphere
integer, parameter :: starshape_poly1p5   =  1  ! polytrope n = 1.5
integer, parameter :: starshape_poly3p0   =  2  ! polytrope n = 3
integer, parameter :: starshape_love      =  3  ! Correia (2014) model
character*7, parameter, dimension(-2:3) :: &
 starshape_name = (/ 'roche_v', 'roche  ', 'sphere ', 'poly1p5', &
 'poly3p0', 'love   ' /)

! Indices for spot parameters in a spot data array
integer, parameter :: n_spot_par = 4
integer, parameter :: i_spot_lon  = 1 ! longitude, alpha
integer, parameter :: i_spot_lat  = 2 ! latitude, beta
integer, parameter :: i_spot_gam  = 3 ! opening angle/size, gamma
integer, parameter :: i_spot_fac  = 4 ! contrast factor, f

! Verbosity levels
! Tests against these values should always be of the form
! "IF (verbose >= v_error) ... " since verbosity levels can be outside this
! range of values. 
integer, parameter :: v_silent = 0  ! strictly no output
integer, parameter :: v_error  = 1  ! print error messages only
integer, parameter :: v_warn   = 2  ! print error messages and warnings
integer, parameter :: v_user   = 3  ! print user information
integer, parameter :: v_debug  = 4  ! debugging level

! Limb darkening laws
! N.B. values < -1 are the negative of the number of points in an array of 
! specific intensity values over a regular grid of mu values from 0 to 1.
integer, parameter :: ld_mugrid       =  -1
integer, parameter :: ld_none         =  0
integer, parameter :: ld_linear       =  1
integer, parameter :: ld_quadratic    =  2
integer, parameter :: ld_sing         =  3
integer, parameter :: ld_claret       =  4
integer, parameter :: ld_logarithmic  =  5
integer, parameter :: ld_square_root  =  6
integer, parameter :: ld_exponential  =  7
integer, parameter :: ld_power2       =  8

! Bit flags for eclipse types
integer, parameter :: bit_eclipse          =  0 ! There is an eclipse
integer, parameter :: bit_eclipse_of_star1 =  1 ! Star 1 is eclipsed by star 2
integer, parameter :: bit_eclipse_of_star2 =  2 ! Star 2 is eclipsed by star 1
integer, parameter :: bit_eclipse_is_total =  3 ! Eclipse is total
integer, parameter :: bit_eclipse_is_a_transit =  4 ! Eclipse is a transit 
! Eclipse is "double-partial" (4 intersection points).
integer, parameter :: bit_eclipse_is_double_partial  =  5

! Useful mathematical constants

double precision, parameter :: pi =  3.141592653589793238d0 ! pi
double precision, parameter :: rtod = 57.295779513082320876d0 ! rad to deg
double precision, parameter :: dtor =  0.017453292519943295d0 ! deg to rad
double precision, parameter :: twopi   = 6.283185307179586476d0 ! 2*pi
double precision, parameter :: threepi = 9.424777960769379715d0 ! 3*pi
double precision, parameter :: halfpi  = 1.570796326794896619d0 ! pi/2
double precision, parameter :: third   = 0.333333333333333333d0 ! 1/3
double precision, parameter :: fourpi_3 = 4.188790204786391d0    ! 4pi/3
  
! Astronomical and physical constants from 
! The IAU 2009 system of astronomical constants: the report of the IAU working
! group on numerical standards for Fundamental Astronomy
! Luzum  et al., ! 2011CeMDA.110..293L
! Speed of light, SI units
double precision, parameter :: iau_c  = 2.99792458d8     
! Astronomical units, SI units
double precision, parameter :: iau_au = 1.49597870700d11 
! Gravitational constant, SI units
! 2014 CODATA value from Mamajek et al. arXiv:1510.07674
double precision, parameter :: iau_G = 6.67408d-11
  
! IAU nominal values of solar constants in SI units and related constants and
! functions in consistent units.
! From www.iau.org/static/resolutions/IAU2015_English.pdf
!
! Solar radius, SI units
double precision, parameter :: solar_radius = 6.957d8
! Solar luminosity, SI units
double precision, parameter :: solar_luminosity = 3.828d26
! Solar mass * gravitational constant, SI units
double precision, parameter :: solar_gm = 1.3271244d20
! Solar mass, SI units
double precision, parameter :: solar_mass = solar_gm/iau_G
! Solar effective temperature, SI units
double precision, parameter :: solar_teff = 5772.0d0

! a.sin(i) in solar radii for K in km/s, P in mean solar days
double precision, parameter :: solar_asini_kms_d = 0.019765685498705825d0

! Mean solar day in seconds - taken from
! http://tycho.usno.navy.mil/leapsec.html, Apr 2015.
double precision, parameter :: seconds_per_mean_solar_day = 86400.002d0

contains 

integer function get_integer(variable_name)
implicit none
character(*), intent(in) :: variable_name

if (index(variable_name,'bad_int') == 1) then
  get_integer = bad_int
else if (index(variable_name,'n_par') == 1) then
  get_integer = n_par
else if (index(variable_name,'n_ipar') == 1) then
  get_integer = n_ipar
else if (index(variable_name,'starshape_roche_v') == 1) then
  get_integer = starshape_roche_v
else if (index(variable_name,'starshape_roche') == 1) then
  get_integer = starshape_roche
else if (index(variable_name,'starshape_poly1p5') == 1) then
  get_integer = starshape_poly1p5
else if (index(variable_name,'starshape_poly3p0') == 1) then
  get_integer = starshape_poly3p0
else if (index(variable_name,'n_spot_par') == 1) then
  get_integer = n_spot_par
else if (index(variable_name,'i_spot_lon') == 1) then
  get_integer = i_spot_lon
else if (index(variable_name,'i_spot_lat') == 1) then
  get_integer = i_spot_lat
else if (index(variable_name,'i_spot_gam') == 1) then
  get_integer = i_spot_gam
else if (index(variable_name,'i_spot_fac') == 1) then
  get_integer = i_spot_fac
else if (index(variable_name,'ld_none') == 1) then
  get_integer = ld_none
else if (index(variable_name,'ld_linear') == 1) then
  get_integer = ld_linear
else if (index(variable_name,'ld_quadratic') == 1) then
  get_integer = ld_quadratic
else if (index(variable_name,'ld_sing') == 1) then
  get_integer = ld_sing
else if (index(variable_name,'ld_claret') == 1) then
  get_integer = ld_claret
else if (index(variable_name,'ld_logarithmic') == 1) then
  get_integer = ld_logarithmic
else if (index(variable_name,'ld_square_root') == 1) then
  get_integer = ld_square_root
else if (index(variable_name,'ld_exponential') == 1) then
  get_integer = ld_exponential
else if (index(variable_name,'ld_power2') == 1) then
  get_integer = ld_power2
else if (index(variable_name,'ld_mugrid') == 1) then
  get_integer = ld_mugrid
else if (index(variable_name,'bit_eclipse') == 1) then
  get_integer = bit_eclipse
else if (index(variable_name,'bit_eclipse_of_star1') == 1) then
  get_integer = bit_eclipse_of_star1
else if (index(variable_name,'bit_eclipse_of_star2') == 1) then
  get_integer = bit_eclipse_of_star2
else if (index(variable_name,'bit_eclipse_is_total') == 1) then
  get_integer = bit_eclipse_is_total
else if (index(variable_name,'bit_eclipse_is_a_transit') == 1) then
  get_integer = bit_eclipse_is_a_transit
else if (index(variable_name,'bit_eclipse_is_double_partial') == 1) then
  get_integer = bit_eclipse_is_double_partial
else
  get_integer = bad_int
endif
return

end function get_integer

end module constants

! This file is part of the ellc binary star model
! Copyright (C) 2016 Pierre Maxted
! 
! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

module utils
!
! Utility functions and general numerical procedures for ellc
!
! HISTORY
! -------
! Jan 2016
! First version 
! p.maxted@keele.ac.uk
!
!

use constants

implicit none

private  

public swap              ! swap double precision values 
public swap_int          ! swap integer values 
public slowsort          ! sort dble values by direct insertion (slow)
public heapsort          ! calculate sort key for array of dble values 
public poly              ! evaluate a polynomial
public eval_poly_deriv   ! evaluate a polynomial and its derivative
public zbrent            ! Brent's algorithm for bracketed root of a function
public brent             ! Minimisation of a bracketed root
public rtsafe            ! Find bracketed root,  Newton's method + bisection
public laguerre          ! Find a root of a polynomial using Laguerre's method
public affine            ! Apply affine transformation to an array of points
public determinant       ! Determinant of a 2x2 or 3x3 matrix
public deflate_poly      ! Coefficients of a polynomial divided by (x-c)
public midangle          ! Bisector of two angles
public triangle_area     ! Area of a triangle defined by three points
public arc_area          ! Area of an arc on a unit circle
public ucircle_line_intersect ! Intersection of a line with unit circle
public circles_intersect  ! Intersection points of two circles on a plane
public sph_circ_intersect ! Intersection points of two circles on a sphere
public distance          ! Separation between two points in 2-d Euclidean space
public angular_distance  ! Great circle distance between points on a sphere.
public parfit            ! Parabolic fit to three points
public unitfunc          ! =1
public verbose_for_calls ! Set verbose value for function calls.
public acot              ! Inverse cotangent function
public cross3            ! Cross product of 3-element vectors

! Bit flags for circles_intersect and sph_circ_intersect
integer, parameter, public :: b_circles_no_overlap         = 0
integer, parameter, public :: b_circles_1_inside_2         = 1
integer, parameter, public :: b_circles_2_inside_1         = 2
integer, parameter, public :: b_circles_tangent            = 3
integer, parameter, public :: b_circles_intersect          = 4
integer, parameter, public :: b_circles_identical          = 5
integer, parameter, public :: b_circles_invalid            = 6

contains

!-------------------------------------------------------------------------------

subroutine swap(a,b)
  implicit none
  double precision, intent(inout) :: a, b
  !f2py intent(in,out) :: a, b
  double precision :: t
  t=b
  b=a
  a=t
  return
end subroutine swap

!-------------------------------------------------------------------------------

subroutine swap_int(a,b)
  implicit none
  integer, intent(inout) :: a, b
  integer :: t
  t=b
  b=a
  a=t
  return
end subroutine swap_int

!-------------------------------------------------------------------------------

subroutine slowsort(a,reverse)

double precision, intent(inout) :: a(:)    ! Array of values to be sorted
logical, intent(in), optional :: reverse ! Set true to sort in descending order

! Local variables
integer ::  j, k, l
logical :: reverse_l

if (present(reverse)) then
  reverse_l = reverse
else
  reverse_l = .false.
endif

if (reverse_l) then
  do j=1,size(a)-1
    k=maxloc(a(j:),1)
    l = j-1+k
    if (j /= l) call swap(a(l),a(j))
  end do
else
  do j=1,size(a)-1
    k=minloc(a(j:),1)
    l = j-1+k
    if (j /= l) call swap(a(l),a(j))
  end do
endif
return
end subroutine slowsort

!-------------------------------------------------------------------------------

subroutine heapsort(xdata, key) 
  implicit none 
  double precision, intent(in) :: xdata(:)
  integer, intent(out) :: key(:) 

! Local variables
  double precision  :: x 
  integer   :: ndata, i, l, ir, ik, j 

  ndata = size(xdata)
  if (size(key) < ndata) then
   key(1) = bad_int
   return
  endif

  do i = 1, ndata 
    key(i) = i 
  end do 
  if(ndata == 1) return 
!
  l = ndata/2+1 
  ir = ndata 
  do
    if(l > 1) then 
      l = l - 1 
      ik = key(l) 
      x = xdata(ik) 
    else 
      ik = key(ir) 
      x = xdata(ik) 
      key(ir) = key(1) 
      ir = ir - 1 
      if(ir == 1) then 
        key(1) = ik 
        return 
      endif 
    endif 
    i = l 
    j = l + l 
    do while (j <= ir) 
      if(j < ir) then 
        if(xdata(key(j)) < xdata(key(j+1))) j = j + 1 
      endif 
      if(x < xdata(key(j))) then 
        key(i) = key(j) 
        i = j 
        j = j + j 
      else 
        j = ir + 1 
      endif 
    end do
    key(i) = ik 
  end do 
end subroutine heapsort
                                                                        
!-------------------------------------------------------------------------------

double precision function poly(a,x,reverse)
implicit none
double precision, intent(in) :: a(:) ! Array of coefficients
double precision, intent(in) :: x    ! Value at which to evaluate polynomial
logical, intent(in), optional :: reverse ! Coeffs in descending order if true

! Local variables
logical :: reverse_l
integer :: i, n

if (present(reverse)) then
  reverse_l = reverse
else
  reverse_l = .false.
endif

n = size(a)

if (reverse_l) then

  select case (n)
  case(:0)
    poly=bad_dble
  case(1) 
    poly=a(1)
  case(2) 
    poly=x*a(1)+a(2)
  case(3) 
    poly=x*(x*a(1)+a(2))+a(3)
  case(4) 
    poly=x*(x*(x*a(1)+a(2))+a(3))+a(4)
  case(5) 
    poly=x*(x*(x*(x*a(1)+a(2))+a(3))+a(4))+a(5)
  case(6) 
    poly=x*(x*(x*(x*(x*a(1)+a(2))+a(3))+a(4))+a(5))+a(6)
  case(7) 
    poly=x*(x*(x*(x*(x*(x*a(1)+a(2))+a(3))+a(4))+a(5))+a(6))+a(7)
  case(8) 
    poly=x*(x*(x*(x*(x*(x*(x*a(1)+a(2))+a(3))+a(4))+a(5))+a(6))+a(7))+a(8)
  case(9) 
    poly=x*(x*(x*(x*(x*(x*(x*(x*a(1)+a(2))+a(3))+a(4))+a(5)) &
        +a(6))+a(7))+a(8))+a(9)
  case(10) 
    poly=x*(x*(x*(x*(x*(x*(x*(x*(x*a(1)+a(2))+a(3))+a(4))+a(5)) &
        +a(6))+a(7))+a(8))+a(9))+a(10)
  case(11) 
    poly=x*(x*(x*(x*(x*(x*(x*(x*(x*(x*a(1)+a(2))+a(3))+a(4)) &
        +a(5))+a(6))+a(7))+a(8))+a(9))+a(10))+a(11)
  case default
    poly=a(1)
    do i=2,n
      poly = poly*x + a(i)
    end do
  end select

  else

    select case (n)
    case(:0)
      poly=bad_dble
    case(1) 
      poly=a(1)
    case(2) 
      poly=x*a(2)+a(1)
    case(3) 
      poly=x*(x*a(3)+a(2))+a(1)
    case(4) 
      poly=x*(x*(x*a(4)+a(3))+a(2))+a(1)
    case(5) 
      poly=x*(x*(x*(x*a(5)+a(4))+a(3))+a(2))+a(1)
    case(6) 
      poly=x*(x*(x*(x*(x*a(6)+a(5))+a(4))+a(3))+a(2))+a(1)
    case(7) 
      poly=x*(x*(x*(x*(x*(x*a(7)+a(6))+a(5))+a(4))+a(3))+a(2))+a(1)
    case(8) 
      poly=x*(x*(x*(x*(x*(x*(x*a(8)+a(7))+a(6))+a(5))+a(4))+a(3)) &
          +a(2))+a(1)
    case(9) 
      poly=x*(x*(x*(x*(x*(x*(x*(x*a(9)+a(8))+a(7))+a(6))+a(5)) &
          +a(4))+a(3))+a(2))+a(1)
    case(10) 
      poly=x*(x*(x*(x*(x*(x*(x*(x*(x*a(10)+a(9))+a(8))+a(7)) &
          +a(6))+a(5))+a(4))+a(3))+a(2))+a(1)
    case(11) 
      poly=x*(x*(x*(x*(x*(x*(x*(x*(x*(x*a(11)+a(10))+a(9)) &
          +a(8))+a(7))+a(6))+a(5))+a(4))+a(3))+a(2))+a(1)
    case default
      poly=a(n)
      do i=n-1,1,-1
        poly = poly*x + a(i)
      end do
    end select

    endif 

    return
    end function poly

!-----------------------------------------------------------------------------

double precision function zbrent(func,x1,x2,tol,npar,par,verbose)
!
! Find root of function func(x,npar,par,verbose-1) using Brent's method
!
implicit none 
integer, intent(in)  :: npar, verbose
double precision, intent(in) :: x1, x2, tol, par(npar)
interface
  function func(fx,fnpar, fpar, fverbose)
  double precision             :: func
  double precision, intent(in) :: fx
  integer, intent(in)  :: fnpar
  double precision, intent(in) :: fpar(fnpar)
  integer, intent(in)  :: fverbose
  end function func
end interface
integer :: iter
double precision :: fa, fb, fc, a, b, c, d, e, tol1, xm, p, q, r, s
integer, parameter :: itmax = 100
double precision, parameter :: eps = epsilon(0.0d0)

if (verbose >= v_debug) print *,'Enter zbrent'
zbrent = bad_dble

a = x1
b = x2
c = 0.d0
d = 0.d0
e = 0.d0
fa = func(a,npar,par,verbose-1)
fb = func(b,npar,par,verbose-1)
if ((fb == bad_dble).or.(fa == bad_dble)) return

if (fa*fb > 0.0d0) then
  if (verbose >= v_error) then
    print *, 'zbrent: input values do not bracket root'
    print *, a,b
    print *, fa,fb
  endif
  return
endif

fc = fb
do iter=1, itmax
  if (fb*fc > 0.0d0) then
    c = a
    fc = fa
    d = b-a
    e=d
  endif
  if (abs(fc) < abs(fb)) then
    a = b
    b = c
    c = a
    fa = fb
    fb = fc
    fc = fa
  endif
  tol1 = 2.0d0*eps*abs(b)+0.5d0*tol
  xm = (c-b)/2.0d0
  if (abs(xm) <  tol1 .or. fb == 0.0d0) then
    zbrent = b
    return
  endif
  if (abs(e) > tol1 .and. abs(fa) >  abs(fb)) then
    s = fb/fa
    if (a == c) then
      p = 2.0d0*xm*s
      q = 1.0d0-s
    else
      q = fa/fc
      r = fb/fc
      p = s*(2.0d0*xm*q*(q-r)-(b-a)*(r-1.0d0))
      q = (q-1.0d0)*(r-1.0d0)*(s-1.0d0)
    endif
    if (p > 0.0d0) q = - q
    p = abs(p)
    if (2.0d0*p < min(3.0d0*xm*q-abs(tol1*q),abs(e*q))) then
      e = d
      d = p/q
    else
      d = xm
      e = d
    endif
  else
    d = xm
    e = d
  endif
  a = b
  fa = fb
  if( abs(d) > tol1) then
    b = b + d
  else
    b = b + sign(tol1, xm)
  endif
  fb = func(b,npar,par,verbose-1)
  if (fb == bad_dble) return
end do
if (verbose >= v_error) then
  print *, 'zbrent exceeded maximum iterations.'
  print *, a,b
  print *, fa,fb
endif
return
end function zbrent

!-----------------------------------------------------------------------------

double precision function rtsafe(func,dfunc,x1,x2,tol,npar,par,verbose)
!
! Find root of function func(x,npar,par,verbose-1) with derivative
! dfunc(x,npar,par,verbose-1) Newton-Raphson iteration combined
! with bisection.
!
! Follows the algorithm described in Numerical Recipes in Fortran 90
! (Press et al., http://www.nr.com)
!
! If the algorithm fails to converge after maxit iterations return bad_dble
! 
! If input values of x1 and x2 do not bracket the root, print warning and
! return with best estimate of root.
!
implicit none 
integer, intent(in)  :: npar, verbose
double precision, intent(in) :: x1, x2, tol, par(npar)
interface
  function func(fx,fnpar, fpar, fverbose)
  double precision             :: func
  double precision, intent(in) :: fx
  integer, intent(in)  :: fnpar
  double precision, intent(in) :: fpar(fnpar)
  integer, intent(in)  :: fverbose
  end function func
  function dfunc(fx,fnpar, fpar, fverbose)
  double precision             :: dfunc
  double precision, intent(in) :: fx
  integer, intent(in)  :: fnpar
  double precision, intent(in) :: fpar(fnpar)
  integer, intent(in)  :: fverbose
  end function dfunc
end interface

integer, parameter :: maxit = 1024  ! Maximum number of iterations
double precision, parameter :: ftol = 4.d0*epsilon(0.d0)
integer :: j
double precision :: df, dx, dxold, f, fh, fl, temp, xh, xl

rtsafe = bad_dble

fl = func(x1, npar, par, verbose-1)
fh = func(x2, npar, par, verbose-1)

if (((fl > 0.0d0).and.(fh > 0.0d0)).or.((fl < 0.0d0).and.(fh < 0.0d0))) then
if (verbose >= v_error) then
    print *, 'rtsafe: input values do not bracket root'
    print *, x1, x2
    print *, fl,fh
  endif
  return
endif

if (fl == 0.0d0) then
  rtsafe = x1
  return
else if (fh == 0.0d0) then
  rtsafe = x2
  return
else if (fl < 0.0d0) then
  xl = x1
  xh = x2
else
  xh = x1
  xl = x2
endif

rtsafe = 0.5d0*(x1+x2)
dxold  =abs(x2-x1)
dx=dxold
f= func(rtsafe,npar, par, verbose-1)
df = dfunc(rtsafe,npar, par, verbose-1)
do j=1,maxit

  if( ((rtsafe-xh)*df-f)*((rtsafe-x1)*df-f) > 0.0d0 .or.  &
      abs(2.0d0*f) > abs(dxold*df) ) then
    ! Newton out-of-range or not decreasing fast enough - bisect
    dxold = dx
    dx = 0.5d0*(xh-xl)
    rtsafe = xl+dx
    if(xl == rtsafe) return ! Change in root is negligible.
  else
    dxold = dx
    dx=f/df
    temp=rtsafe
    rtsafe=rtsafe-dx
    if(temp == rtsafe) return
  endif
  if (abs(dx) < tol) return  ! Convergence criterion.
  f= func(rtsafe,npar, par, verbose-1)
  ! Added a test here to return if abs(f) < ftol
  if (abs(f) < ftol) return  
  df = dfunc(rtsafe,npar, par, verbose-1)
  if( f < 0.d0) then
    xl = rtsafe
  else 
    xh=rtsafe
  endif
end do
if (verbose >= v_error) then
  print *, 'rtsafe: Failed to converge'
  print *, xl, xh
  print *, x1, x2
  print *, f, df,ftol
endif
return
end function rtsafe

!-----------------------------------------------------------------------------

double complex function laguerre(a,m,x)
! Given a degree m and the complex coefficients a(1:m+1) of the polynomial
! sum(i=1,m+1) a(i) * x**(i-1), and given a complex value x, this routine
! improves x by Laguerre's method until it converges, within the achievable
! round-off limit, to a root of the given polynomial. 
!  If the algorithm fails to converge return value is (bad_dble, bad_dble)
! 
! Follows the algorithm described in Numerical Recipes in Fortran 90
! (Press et al., http://www.nr.com)
!
integer, intent(in)        :: m      ! Degree of the polynomial
double complex, intent(in) :: a(m+1) ! Polynomial coefficients (ascending power)
double complex, intent(in) :: x      ! Initial/final estimate of root

! Parameters
integer, parameter  :: mr = 8         ! Number of fractional values to test
integer, parameter  :: mt = 10        ! Step frequency for limit cycle tests
integer, parameter  :: maxit = mr*mt  ! Maximum number of iterations

! Local variables
integer     :: iter, j
double precision :: abx, abp, abm, err, frac(mr)
double complex :: dx, x1, b, d, f, g, h, sq, gp, gm, g2
save frac
! Fractions used to break limit cycle
data frac /0.5d0, 0.25d0, 0.75d0, 0.13d0, 0.38d0, 0.62d0, 0.88d0, 1.0d0/

laguerre = x

do iter=1,maxit
  b=a(m+1)
  err=abs(b)
  d=dcmplx(0.0d0,0.0d0)
  f=dcmplx(0.0d0,0.0d0)
  abx=abs(laguerre)
  do j=m,1,-1
    f = laguerre*f + d
    d = laguerre*d + b
    b = laguerre*b + a(j)
    err = abs(b) + abx*err
  end do
  err = epsilon(0.0d0)*err
  if (abs(b) <= err) then
    return
  else
    g = d/b
    g2=g**2
    h = g2-2.0d0*f/b
    sq = sqrt((m-1)*(m*h-g2))
    gp = g + sq
    gm = g - sq
    abp = abs(gp)
    abm = abs(gm)
    if (abp < abm) gp = gm
    if (max(abp,abm) > 0.0d0) then
      dx = m/gp
    else
      dx = exp(dcmplx(log(1.0d0+abx),dble(iter)))
    endif
  endif
  x1 = laguerre - dx
  if (laguerre == x1) return
  if (mod(iter,mt) /= 0) then
    laguerre = x1
  else
    laguerre = laguerre - dx*frac(iter/mt)
  endif
end do
laguerre = dcmplx(bad_dble,bad_dble)
return
end function laguerre


!-----------------------------------------------------------------------------

function affine(x,tr,inverse) result(xt)
implicit none
! Apply the affine transformation tr(2,3) to an array of points x(2).
!  The result is
!   xt(1,i) = tr(1,3) + tr(1,1)*x(1,i) + tr(1,2)*x(2,i)
!   xt(2,i) = tr(2,3) + tr(2,1)*x(1,i) + tr(2,2)*x(2,i)
!
! If the argument inverse is present and .true. then the results is
!
!   (  tr(2,2)*(x(1,i)-tr(1,3)) - tr(1,2)*(x(2,i)-tr(2,3)) )/D
!   ( -tr(2,1)*(x(1,i)-tr(1,3)) + tr(1,1)*(x(2,i)-tr(2,3)) )/D
! where D = tr(1,1)*tr(2,2) -  tr(1,2)*tr(2,1) 
! N.B. if D == 0, all values are returned as bad_dble.
!
double precision, intent(in)         :: x(2)
double precision, intent(in)         :: tr(2,3)
double precision                     :: xt(2)
logical, optional,intent(in) :: inverse 

! Local variables
double precision :: d
logical  :: inverse_l

if (present(inverse)) then
  inverse_l = inverse
else
  inverse_l = .false.
endif

if (inverse_l) then
  d = tr(1,1)*tr(2,2) -  tr(1,2)*tr(2,1) 
  if (d == 0.0d0) then
    xt(:) = bad_dble
    return
  endif
  xt(1) = ( tr(2,2)*(x(1)-tr(1,3)) - tr(1,2)*(x(2)-tr(2,3)))/d
  xt(2) = (-tr(2,1)*(x(1)-tr(1,3)) + tr(1,1)*(x(2)-tr(2,3)))/d
else
  xt(1) = tr(1,3) + tr(1,1)*x(1) + tr(1,2)*x(2)
  xt(2) = tr(2,3) + tr(2,1)*x(1) + tr(2,2)*x(2)
endif
end function affine

!-----------------------------------------------------------------------------

double precision function determinant(a,n) 
! Determinant of a 2x2 or 3x3 matrix
integer,  intent(in) :: n
double precision,intent(in) :: a(n,n)

select case (n)
case(0)
  determinant = 0.d0
case(1)
  determinant = a(1,1)
case(2)
  determinant = a(1,1)*a(2,2) - a(1,2)*a(2,1)
case(3) 
  determinant = ( (a(3,1)*a(2,2)-a(2,1)*a(3,2))   &
                 *(a(2,1)*a(1,3)-a(1,1)*a(2,3)) ) &
              - ( (a(2,1)*a(1,2)-a(1,1)*a(2,2))   &
                 *(a(3,1)*a(2,3)-a(2,1)*a(3,3)) )
case default
  print *,'determinant: n>3 not implemented.'
  stop
end select
return
end function determinant

!-----------------------------------------------------------------------------

function deflate_poly(a, n, c) result(b)
! Divide a polynomial by a monomial factor (x-c)
! a(1:n) are the coefficients of the polynomial in ascending power order
! b(1:n-1) are the coefficients of the divided polynomial
! b(n) is the remainder
integer, intent(in) :: n
double precision,intent(in) :: a(n), c
double precision :: b(n)

! Local variables
integer  :: i
double precision :: r

r = a(n)
do i=n-1,1,-1
  b(i) = r
  r = a(i)+r*c
end do
b(n) = r
return
end function deflate_poly

!-----------------------------------------------------------------------------

double precision function midangle(th0,th1, reflex)
! Bisector of the angles th0 and th1 in the range 0 -> twopi
! If reflex is present and .true., return the bisector the forms
! an reflex angle with the two input angles.
implicit none
double precision, intent(in) :: th0, th1
logical, intent(in), optional :: reflex
! Local variables
logical reflex_l

if (present(reflex)) then
  reflex_l = reflex
else
  reflex_l = .false.
endif

if (reflex_l) then

  if (abs(th1-th0).gt.pi) then
    midangle = 0.5d0*(th0+th1)
  else 
    midangle = mod(pi+0.5d0*(th0+th1), twopi)
  endif

else

  if (abs(th1-th0).gt.pi) then
    midangle = 0.5d0*(th0+th1) - pi
    if (midangle.lt.0.d0) midangle = midangle + twopi
  else 
    midangle = 0.5d0*(th0+th1)
  endif

endif

end function midangle
                                                                        
!-------------------------------------------------------------------------------

double precision function triangle_area(p_1,p_2,p_3,signed)
! Area of a triangle defined by three points
! p_1 = (x_1, y_1), p_2 = (x_2, y_2) and p_3 = (x_3, y_3)
! If signed=.true. then the result is positive/negative according to whether
! the points are clockwise/counterclockwise
implicit none
double precision, intent(in) :: p_1(2), p_2(2),p_3(2)
logical, optional,intent(in) :: signed

! Local variables
logical :: signed_l

if (present(signed)) then
  signed_l = signed
else
  signed_l = .false.
endif

if (signed_l) then
 triangle_area = 0.5d0*(p_1(1)*(p_2(2)-p_3(2)) &
               - p_2(1)*(p_1(2)-p_3(2)) + p_3(1)*(p_1(2)-p_2(2)))
else
 triangle_area = abs(0.5d0*(p_1(1)*(p_2(2)-p_3(2)) &
               - p_2(1)*(p_1(2)-p_3(2)) + p_3(1)*(p_1(2)-p_2(2))))
endif

return
end function triangle_area

!-----------------------------------------------------------------------------

function ucircle_line_intersect(qline) result(t)
!
! Intersection of a line with unit circle centred on the origin
!
! The line is defined by the parametric equation
!  (x, y) = (x_0, y_0) + t*(dx, dy) 
!
! qline = [x_0, y_0, dx, dy]
!
! Values of t for which the line intersects the unit circle are returned in 
! t(1:2)
!     
! If there is only one intersection then t(1) = t(2)
!     
! If there are no intersections then t(1) = -huge(0.d0) and t(2) = huge(0.d0)
!
implicit none
double precision, intent(in) :: qline(4) ! Parametric equation of the line
double precision :: t(2)                 ! Line parameter values at intercept

! Local variables
double precision :: a,b,c,d,r,w

a = qline(3)**2 + qline(4)**2
b = 2.0d0*(qline(1)*qline(3) + qline(2)*qline(4))
c = qline(1)**2 + qline(2)**2 - 1.0d0
d = b**2 - 4.0d0*a*c
if (d < 0.0) then
  t(1) = -huge(0.d0)
  t(2) =  huge(0.d0)
else
  r = sqrt(d)
  w = -(b + sign(r,b))
  t(1) = 2.0d0*c/w
  t(2) = 0.5d0*w/a
endif
return 
end function ucircle_line_intersect
                                                                        
!-------------------------------------------------------------------------------

double precision function arc_area(p_1,p_2)
! Area of the arc defined by a unit circle centred on the origin and the lines
! between two points on its circumference, p_1 = (x_1, y_1) and p_2 = (x_2, y_2)
! N.B. requires hypot(x_1, y_2) = hypot(x_2, y_2) = 1 - not checked!
implicit none
double precision, intent(in) :: p_1(2), p_2(2)

! Local variables
double precision :: t_1, t_2, dt
double precision, parameter ::p_0(2) = (/0.d0,0.d0/)

t_1 = atan2(p_1(2),p_1(1))
t_2 = atan2(p_2(2),p_2(1))
dt = mod(abs(t_1 - t_2), twopi)
if (dt > pi) dt = twopi - dt
arc_area = 0.5d0*dt - triangle_area(p_0,p_1,p_2)
return
end function arc_area
                                                                        
!-------------------------------------------------------------------------------

subroutine circles_intersect(circle_1, circle_2, xy, circles_flags)
! Number and positions of intersections points of two circles on a plane
implicit none
double precision, intent(in)  :: circle_1(3) ! (x_c, y_c) and radius of circle 1
double precision, intent(in)  :: circle_2(3) ! (x_c, y_c) and radius of circle 2
double precision, intent(out) :: xy(2,2)     ! (x,y) for intersections 
integer, intent(out)  :: circles_flags ! Bit mask for flags
! circles_flags is a bit mask with the following flags
! b_circles_no_overlap  (but may have a tangent point)
! b_circles_1_inside_2  (and may have a tangent point)
! b_circles_2_inside_1  (and may have a tangent point)
! b_circles_tangent     (there is a tangent point, xy(1:2,1) = xy(1:2,2)
! b_circles_intersect   (no tangent points, two distinct intersection points)
! b_circles_identical   (xy not defined in this case)
! b_circles_invalid     (radius <=  0 for either circle)
!
! To test these bit flags, use btest(circles_flags, <bit flag name>)

! Local variables
double precision :: a, dx, dy, d, h, rx, ry, x2, y2, r_1, r_2

r_1 = circle_1(3)
r_2 = circle_2(3)
circles_flags = 0 
if ((r_1 <= 0.0d0).or.(r_2 <= 0.0d0)) then
  xy(:,:) = not_set_dble
  circles_flags = ibset(circles_flags, b_circles_invalid)
  return
endif

dx = circle_2(1) - circle_1(1)
dy = circle_2(2) - circle_1(2)
d = hypot(dx,dy)

if ((d == 0.0d0).and.(r_1 == r_2)) then
  xy(:,:) = not_set_dble
  circles_flags = ibset(circles_flags, b_circles_identical)
  return
endif

if (d > (r_1 + r_2)) then
  xy(:,:) = not_set_dble
  circles_flags = ibset(circles_flags, b_circles_no_overlap)
  return
endif

if (d < abs(r_2 - r_1)) then
  xy(:,:) = not_set_dble
  if (r_1 < r_2) then
    circles_flags = ibset(circles_flags, b_circles_1_inside_2)
  else
    circles_flags = ibset(circles_flags, b_circles_2_inside_1)
  endif
  return
endif

a = (r_1**2 - r_2**2 + d**2) / (2.0d0 * d)
x2 = circle_1(1) + dx * a/d
y2 = circle_1(2) + dy * a/d

if (d == (r_1 + r_2)) then
  xy(1:2,1) = (/ x2, y2 /)
  xy(1:2,2) = (/ x2, y2 /)
  circles_flags = ibset(circles_flags, b_circles_tangent)
  circles_flags = ibset(circles_flags, b_circles_no_overlap)
  return
endif

if (d == abs(r_1 - r_2)) then
  xy(1:2,1) = (/ x2, y2 /)
  xy(1:2,2) = (/ x2, y2 /)
  circles_flags = ibset(circles_flags, b_circles_tangent)
  if (r_1 < r_2) then
    circles_flags = ibset(circles_flags, b_circles_1_inside_2)
  else
    circles_flags = ibset(circles_flags, b_circles_2_inside_1)
  endif
  return
endif

h = sqrt(r_1**2 - a**2)
rx = -dy * h/d
ry =  dx * h/d
xy(1:2,1) = (/ x2 + rx, y2 + ry /)
xy(1:2,2) = (/ x2 - rx, y2 - ry /)
circles_flags = ibset(circles_flags, b_circles_intersect)

return

end subroutine circles_intersect
                                                         
                                                                        
!-------------------------------------------------------------------------------

subroutine sph_circ_intersect(circle_1, circle_2, xpts, circles_flags)
! Number and positions of intersections points of two circles on a sphere
! See https://gis.stackexchange.com/questions/48937/calculating-intersection-of-two-circles
! All input/output angles are in radians, including the radii of the circles.
implicit none
double precision, intent(in)  :: circle_1(3) ! (lon, lat) and radius of circle 1
double precision, intent(in)  :: circle_2(3) ! (lon, lat) and radius of circle 2
double precision, intent(out) :: xpts(2,2)   ! (lon,lat) for intersections 
integer, intent(out)  :: circles_flags ! Bit mask for flags
! circles_flags is a bit mask with the following flags
! b_circles_no_overlap  (but may have a tangent point)
! b_circles_1_inside_2  (and may have a tangent point)
! b_circles_2_inside_1  (and may have a tangent point)
! b_circles_tangent     (there is a tangent point, xy(1:2,1) = xy(1:2,2)
! b_circles_intersect   (no tangent points, two distinct intersection points)
! b_circles_identical   (xy not defined in this case)
! b_circles_invalid     (parameters invalid for either circle)
!
! To test these bit flags, use btest(circles_flags, <bit flag name>)

! Local variables
double precision :: x_1(3), x_2(3), n(3), x_0(3)
double precision :: r_1, r_2, q, d, a, b, t

circles_flags = 0 
r_1 = circle_1(3)
r_2 = circle_2(3)

if ( (r_1 <= 0.0d0).or.(r_1 >= halfpi).or. &
     (r_2 <= 0.0d0).or.(r_2 >= halfpi) ) then
  xpts(:,:) = not_set_dble
  circles_flags = ibset(circles_flags, b_circles_invalid)
  return
endif

d = angular_distance(circle_1(1),circle_1(2),circle_2(1),circle_2(2))

if ((d <  epsilon(0.0d0)).and.(abs(r_1 - r_2)< epsilon(0.0d0))) then
    xpts(:,:) = not_set_dble
    circles_flags = ibset(circles_flags, b_circles_identical)
    return
endif

if (d > (r_1+r_2)) then
  xpts(:,:) = not_set_dble
  circles_flags = ibset(circles_flags, b_circles_no_overlap)
  return
endif

if (d < abs(r_2 - r_1)) then
  xpts(:,:) = not_set_dble
  if (r_1 < r_2) then
    circles_flags = ibset(circles_flags, b_circles_1_inside_2)
  else
    circles_flags = ibset(circles_flags, b_circles_2_inside_1)
  endif
  return
endif


x_1 = (/cos(circle_1(1))*cos(circle_1(2)), &
        sin(circle_1(1))*cos(circle_1(2)), &
        sin(circle_1(2)) /)
x_2 = (/cos(circle_2(1))*cos(circle_2(2)), &
        sin(circle_2(1))*cos(circle_2(2)), &
        sin(circle_2(2)) /)

q = dot_product(x_1, x_2)
a = (cos(r_1) - cos(r_2)*q) / (1.0d0 - q**2)
b = (cos(r_2) - cos(r_1)*q) / (1.0d0 - q**2)

n = cross3(x_1, x_2)

x_0 = a*x_1 + b*x_2

t = sqrt((1.0d0 - min(1.0d0,dot_product(x_0,x_0)))/dot_product(n,n))

if (t == 0.0d0) then
    circles_flags = ibset(circles_flags, b_circles_tangent)
endif

x_1 = x_0 + t*n
x_2 = x_0 - t*n

xpts(1,1) =  atan2(x_1(2), x_1(1))
xpts(2,1) =  atan2(x_1(3), hypot(x_1(1), x_1(2))) 
xpts(1,2) =  atan2(x_2(2), x_2(1))
xpts(2,2) =  atan2(x_2(3), hypot(x_2(1), x_2(2))) 
      
return

end subroutine sph_circ_intersect
                                                         
!-------------------------------------------------------------------------------

double precision function distance(xy_1, xy_2) 
implicit none
double precision, intent(in) :: xy_1(2), xy_2(2)
distance = hypot(xy_1(1)-xy_2(1), xy_1(2)-xy_2(2))
return
end function distance

!-------------------------------------------------------------------------------

double precision function angular_distance(lon_1, lat_1, lon_2, lat_2)
! Great circle distance in radians between points (lon1, lat1) and 
! (lon2, lat2), also in radians. 
! See https://www.movable-type.co.uk/scripts/gis-faq-5.1.html
implicit none
double precision, intent(in)  :: lon_1, lat_1, lon_2, lat_2

double precision :: dlon, dlat, a
dlon = lon_2-lon_1
dlat = lat_2-lat_1
a = sin(0.5d0*dlat)**2 + cos(lat_1)*cos(lat_2)*sin(0.5d0*dlon)**2
angular_distance = 2.0d0 * asin(min(1.0d0,sqrt(a)))
return
end function angular_distance

!----------------------------------------------------------------------

function parfit(dx,dy) result (a)

double precision, intent(in) :: dx(3),dy(3)
double precision :: a(3)
! Returns the coefficients of the unique parabola intersecting three
! points. Calculation done in double precision.
! If no such parabola exists, all three coefficients are set to bad_dble
!
!-----------------------------------------------------------------------

double precision :: dv1,dv2,d
      
dv1 = dx(3) * (dx(3) - dx(1))
dv2 = dx(2) * (dx(2) - dx(1))
d =  dv1*(dx(1)-dx(2)) - dv2*(dx(1)-dx(3)) 
if (abs(d) < epsilon(0.0d0)) then
  a(1:3) = bad_dble
  return
endif
a(1) = ( dv1*(dx(1)*dy(2)-dx(2)*dy(1)) -  &
         dv2*(dx(1)*dy(3)-dx(3)*dy(1)) )/d

dv1 = dx(3)*dx(3)-dx(1)*dx(1)
dv2 = dx(2)*dx(2)-dx(1)*dx(1)
d =  dv1*(dx(2)-dx(1)) - dv2*(dx(3)-dx(1))  
if (abs(d) < epsilon(0.0d0)) then
  a(1:3) = bad_dble
  return
endif
a(2) = ( dv1*(dy(2)-dy(1)) - dv2*(dy(3)-dy(1)) )/d

dv1 = dx(3) - dx(1)
dv2 = dx(2) - dx(1) 
d =  dv1*(dx(2)*dx(2)-dx(1)*dx(1)) - dv2*(dx(3)*dx(3)-dx(1)*dx(1))
if (abs(d) < epsilon(0.0d0)) then
  a(1:3) = bad_dble
  return
endif
a(3) = ( dv1*(dy(2)-dy(1)) - dv2*(dy(3)-dy(1)) )/d
      
return

end function parfit

!-----------------------------------------------------------------------------      

double precision function unitfunc(u,v,npar,par,verbose) 
implicit none
integer, intent(in)  :: npar, verbose
double precision, intent(in) :: u,v,par(npar)
unitfunc = 1.0d0
return
end function unitfunc

!----------------------------------------------------------------------

integer function verbose_for_calls(verbose)
! When debugging, reduce verbose by one for all function/subroutine calls.
integer, intent(in) :: verbose
if (verbose >= v_debug) then
  verbose_for_calls = verbose -1
else
  verbose_for_calls = verbose
endif
end function verbose_for_calls

!----------------------------------------------------------------------

function eval_poly_deriv(x,np,p,verbose) result(px_dpdx)
! Evaluate a polynomial and its derivative
! Argument list suitable for calling by rtsafe or zbrent for root finding.
implicit none
double precision, intent(in) :: x     ! Value at which to evaluate polynomial
integer, intent(in)          :: np    ! No. of coefficients
double precision, intent(in) :: p(np) ! Array of coefficients, ascending powers
integer, intent(in)          :: verbose 
double precision             :: px_dpdx(2) ! p(x) and dp/dx

! Local variables
integer :: i
double precision :: px,dpdx

if (verbose >= v_debug) print *,'eval_poly_deriv: np,p =',real(np),real(p(1:np)) 
select case (np)
case(:0) 
  px = bad_dble
  dpdx = bad_dble
case(1) 
  px = p(1)
  dpdx = 0.d0
case(2) 
  px = x*p(2)+p(1)
  dpdx = p(2)
case(3) 
  px = x*(x*p(3)+p(2))+p(1)
  dpdx = 2.d0*x*p(3)+p(2)
case(4) 
  px = x*(x*(x*p(4)+p(3))+p(2))+p(1)
  dpdx = x*(x*p(4)*3.d0+p(3)*2.d0)+p(2)
case(5) 
  px = x*(x*(x*(x*p(5)+p(4))+p(3))+p(2))+p(1)
  dpdx = x*(x*(x*p(5)*4.d0+p(4)*3.d0)+p(3)*2.d0)+p(2)
case  default
  px = p(np)*x + p(np-1)
  dpdx = p(np)
  do i=np-2,1,-1
    dpdx = dpdx*x*px
    px = px*x + p(i)
  end do
end select
px_dpdx(1) = px
px_dpdx(2) = dpdx
return
end function eval_poly_deriv
                                                                        
!----------------------------------------------------------------------

double precision function brent(ax, bx, cx, f, npar, par, tol, xmin, verbose)

! Given a function F, and given a bracketing triplet of abscissas AX,BX,CX
! such that BX is between AX and CX, and F(BX) is less than both F(AX)
! and F(CX), this routine isolates the minimum to a fractional precision
! of about TOL using Brent's method. The abscissa of the minimum is returned
! as XMIN, and the minimum function value is returned as BRENT, the returned
! function value

implicit  none
integer, intent(in) :: npar, verbose
double precision,intent(in) :: ax, bx, cx, tol, par(:)
double precision,intent(out) :: xmin

! Maximum allowed number of iterations, golden ratio and a small
! number to prevent trying for a fractional accuracy in a minimum
! which is zero
double precision, parameter :: cgold = 0.3819660d0
double precision, parameter :: zeps = 1.0d-10

integer, parameter  ::  itmax=100 
integer :: iter, verbose1
double precision :: w, x, e, fx, fv, fw, fu, u, v
double precision :: xm, tol1, tol2, r, q, p, a, b, d, etemp

interface
  function f(fx,fnpar, fpar, fverbose)
  double precision             :: f
  double precision, intent(in) :: fx
  integer, intent(in)  :: fnpar
  double precision, intent(in) :: fpar(fnpar)
  integer, intent(in)  :: fverbose
  end function f
end interface

verbose1 = verbose_for_calls(verbose)
brent = not_set_dble
d = not_set_dble
a = min(ax, cx)
b = max(ax, cx)
v = bx
w = v
x = v
e = 0.0d0
fx = f(x,npar,par,verbose1)
fv = fx
fw = fx
do iter = 1, itmax
  xm = 0.5d0*(a+b)
  tol1 = tol*abs(x)+zeps
  tol2 = 2.0d0*tol1
  if(abs(x-xm) <= (tol2-0.5d0*(b-a))) then
    xmin = x
    brent = fx
    return
  endif
  if(abs(e) > tol1) then
    r = (x-w)*(fx-fv)
    q = (x-v)*(fx-fw)
    p = (x-v)*q - (x-w)*r
    q = 2.0d0*(q-r)
    if(q > 0.0d0) p = - p
    q = abs(q)
    etemp = e
    e = d
    if(abs(p) >= abs(.5*q*etemp).or. &
       p <= q*(a-x) .or. p >= q*(b-x)) then
       e = merge(a-x, b-x, p >= q*(b-x))
       d = cgold*e
     else
       d = p/q
       u=x+d
       if ( u-a < tol2 .or. b-u < tol2) d = sign(tol1, xm-x)
     endif
   else
     e = merge(a-x, b-x, x >= xm)
     d = cgold*e
   endif
   u = merge(x+d, x+sign(tol1,d), abs(d) >= tol1)
   fu = f(u,npar,par,verbose1)
   if (fu <= fx) then
     if ( u >= x) then
       a = x
     else
       b = x
     endif
     call shft(v,w,x,u)
     call shft(fv,fw,fx,fu)
   else
     if (u < x) then
       a = u
     else
       b = u
     endif
     if (fu <= fw .or. w == x) then
       v=w
       fv=fw
       w=u
       fw=fu
     else if (fu <= fv .or. v == x .or. v == w) then
       v=u
       fv=fu
     endif
   endif
 end do
 if (verbose >= v_warn) print *,'brent: failed to converge'
 contains

 subroutine shft(a,b,c,d)
 double precision, intent(out) :: a
 double precision, intent(inout) :: b, c
 double precision, intent(in) :: d
 a=b
 b=c
 c=d
 end subroutine shft
 end function brent

!----------------------------------------------------------------------

double precision function acot(x)
implicit none
double precision, intent(in) :: x  ! Input value

if (x < 0.d0 ) then
  acot = -halfpi - atan(x)
else
  acot =  halfpi - atan(x)
endif 
end function acot

!----------------------------------------------------------------------

function cross3(a, b) result(x)
implicit none
double precision, intent(in) :: a(3), b(3)
double precision :: x(3)

x = (/ a(2) * b(3) - a(3) * b(2), &
       a(3) * b(1) - a(1) * b(3), &
       a(1) * b(2) - a(2) * b(1) /)

end function cross3

!-----------------------------------------------------------------------------
end module utils

MODULE Solve_Real_Poly
! CACM Algorithm 493 by Jenkins & Traub

! Compliments of netlib   Sat Jul 26 11:57:43 EDT 1986
 
! Code converted using TO_F90 by Alan Miller
! Date: 2003-06-02  Time: 10:42:22
! 
! Code converted to a form suitable for calling from python using f2py by
! restricting polynomial degree to 4 (enough for this application).
! Also converted all REALs to DOUBLE PRECISION
! p.maxted@keele.ac.uk
! 29 Nov 2015

IMPLICIT NONE
! INTEGER, PARAMETER  :: dp = SELECTED_REAL_KIND(14, 60)

! COMMON /global/ p, qp, k, qk, svk, sr, si, u, v, a, b, c, d, a1,  &
!    a2, a3, a6, a7, e, f, g, h, szr, szi, lzr, lzi, eta, are, mre, n, nn

DOUBLE PRECISION, SAVE  :: p(5), qp(5), k(5), qk(5), svk(5)
DOUBLE PRECISION, SAVE :: sr, si, u, v, a, b, c, d, a1, a2, a3, a6,  &
                          a7, e, f, g, h, szr, szi, lzr, lzi
DOUBLE PRECISION, SAVE             :: eta, are, mre
INTEGER, SAVE          :: n, nn

!PRIVATE
!PUBLIC  :: dp, rpoly


CONTAINS


SUBROUTINE rpoly(op, degree, zeror, zeroi, fail)

! Finds the zeros of a real polynomial
! op  - double precision vector of coefficients in order of
!       decreasing powers.
! degree   - integer degree of polynomial.
! zeror, zeroi - output double precision vectors of real and imaginary parts
!                of the zeros.
! fail  - output logical parameter, true only if leading coefficient is zero
!         or if rpoly has found fewer than degree zeros.
!         In the latter case degree is reset to the number of zeros found.

! To change the size of polynomials which can be solved, reset the dimensions
! of the arrays in the common area and in the following declarations.
! The subroutine uses single precision calculations for scaling, bounds and
! error calculations.  All calculations for the iterations are done in
! double precision.


DOUBLE PRECISION, INTENT(IN)    :: op(5)
INTEGER, INTENT(IN OUT)  :: degree
DOUBLE PRECISION, INTENT(OUT)   :: zeror(4), zeroi(4)
LOGICAL, INTENT(OUT)     :: fail

DOUBLE PRECISION :: temp(5)
DOUBLE PRECISION :: pt(5)

DOUBLE PRECISION :: t, aa, bb, cc, factor
DOUBLE PRECISION      :: lo, MAX, MIN, xx, yy, cosr, sinr, xxx, x, sc, bnd,  &
             xm, ff, df, dx, infin, smalno, base
INTEGER   :: cnt, nz, i, j, jj, l, nm1
LOGICAL   :: zerok

! The following statements set machine constants used in various parts of the
! program.  The meaning of the four constants are...
! eta     the maximum relative representation error which can be described
!         as the smallest positive floating point number such that
!         1.d0+eta is greater than 1.
! infiny  the largest floating-point number.
! smalno  the smallest positive floating-point number if the exponent range
!         differs in single and double precision then smalno and infin should
!         indicate the smaller range.
! base    the base of the floating-point number system used.

base = RADIX(0.0d0)
eta = EPSILON(1.0d0)
infin = HUGE(0.0d0)
smalno = TINY(0.0d0)

temp = 0

! are and mre refer to the unit error in + and * respectively.
! They are assumed to be the same as eta.
are = eta
mre = eta
lo = smalno / eta

! Initialization of constants for shift rotation
xx = SQRT(0.5)
yy = -xx
cosr = -0.069756474d0
sinr = 0.99756405d0
fail = .false.
n = degree
nn = n + 1

! Algorithm fails if the leading coefficient is zero.
IF (op(1) == 0.d0) THEN
  fail = .true.
  degree = 0
  RETURN
endif

! Remove the zeros at the origin if any
10 IF (op(nn) == 0.0D0) THEN
  j = degree - n + 1
  zeror(j) = 0.d0
  zeroi(j) = 0.d0
  nn = nn - 1
  n = n - 1
  GO TO 10
endif

! Make a copy of the coefficients
p(1:nn) = op(1:nn)

! Start the algorithm for one zero
30 IF (n <= 2) THEN
  IF (n < 1) RETURN

! calculate the final zero or pair of zeros
  IF (n /= 2) THEN
    zeror(degree) = -p(2) / p(1)
    zeroi(degree) = 0.0D0
    RETURN
  endif
  CALL quad(p(1), p(2), p(3), zeror(degree-1), zeroi(degree-1),  &
            zeror(degree), zeroi(degree))
  RETURN
endif

! Find largest and smallest moduli of coefficients.
MAX = 0
MIN = infin
DO  i = 1, nn
  x = ABS( DBLE(p(i)) )
  IF (x > MAX) MAX = x
  IF (x /= 0. .AND. x < MIN) MIN = x
END DO

! Scale if there are large or very small coefficients computes a scale
! factor to multiply the coefficients of the polynomial.
! The scaling is done to avoid overflow and to avoid undetected underflow
! interfering with the convergence criterion.
! The factor is a power of the base
sc = lo / MIN
IF (sc <= 1.0) THEN
  IF (MAX < 10.) GO TO 60
  IF (sc == 0.) sc = smalno
ELSE
  IF (infin/sc < MAX) GO TO 60
endif
l = INT(LOG(sc) / LOG(base) + .5)
factor = (base*1.0D0) ** l
IF (factor /= 1.d0) THEN
  p(1:nn) = factor * p(1:nn)
endif

! compute lower bound on moduli of zeros.
60 pt(1:nn) = ABS(p(1:nn))
pt(nn) = -pt(nn)

! compute upper estimate of bound
x = EXP((LOG(-pt(nn)) - LOG(pt(1))) / n)
IF (pt(n) /= 0.) THEN
! if newton step at the origin is better, use it.
  xm = -pt(nn) / pt(n)
  IF (xm < x) x = xm
endif

! chop the interval (0,x) until ff .le. 0
80 xm = x * .1
ff = pt(1)
DO  i = 2, nn
  ff = ff * xm + pt(i)
END DO
IF (ff > 0.) THEN
  x = xm
  GO TO 80
endif
dx = x

! do newton iteration until x converges to two decimal places
100 IF (ABS(dx/x) > .005) THEN
  ff = pt(1)
  df = ff
  DO  i = 2, n
    ff = ff * x + pt(i)
    df = df * x + ff
  END DO
  ff = ff * x + pt(nn)
  dx = ff / df
  x = x - dx
  GO TO 100
endif
bnd = x

! compute the derivative as the intial k polynomial
! and do 5 steps with no shift
nm1 = n - 1
DO  i = 2, n
  k(i) = (nn-i) * p(i) / n
END DO
k(1) = p(1)
aa = p(nn)
bb = p(n)
zerok = k(n) == 0.d0
DO  jj = 1, 5
  cc = k(n)
  IF (.NOT.zerok) THEN
! use scaled form of recurrence if value of k at 0 is nonzero
    t = -aa / cc
    DO  i = 1, nm1
      j = nn - i
      k(j) = t * k(j-1) + p(j)
    END DO
    k(1) = p(1)
    zerok = ABS(k(n)) <= ABS(bb) * eta * 10.
  ELSE
! use unscaled form of recurrence
    DO  i = 1, nm1
      j = nn - i
      k(j) = k(j-1)
    END DO
    k(1) = 0.d0
    zerok = k(n) == 0.d0
  endif
END DO

! save k for restarts with new shifts
temp(1:n) = k(1:n)

! loop to select the quadratic  corresponding to each
! new shift
DO  cnt = 1, 20
! Quadratic corresponds to a double shift to a non-real point and its complex
! conjugate.  The point has modulus bnd and amplitude rotated by 94 degrees
! from the previous shift
  xxx = cosr * xx - sinr * yy
  yy = sinr * xx + cosr * yy
  xx = xxx
  sr = bnd * xx
  si = bnd * yy
  u = -2.0D0 * sr
  v = bnd

! second stage calculation, fixed quadratic
  CALL fxshfr(20*cnt,nz)
  IF (nz /= 0) THEN

! The second stage jumps directly to one of the third stage iterations and
! returns here if successful.
! Deflate the polynomial, store the zero or zeros and return to the main
! algorithm.
    j = degree - n + 1
    zeror(j) = szr
    zeroi(j) = szi
    nn = nn - nz
    n = nn - 1
    p(1:nn) = qp(1:nn)
    IF (nz == 1) GO TO 30
    zeror(j+1) = lzr
    zeroi(j+1) = lzi
    GO TO 30
  endif

! If the iteration is unsuccessful another quadratic
! is chosen after restoring k
  k(1:nn) = temp(1:nn)
END DO

! Return with failure if no convergence with 20 shifts
fail = .true.
degree = degree - n
RETURN
END SUBROUTINE rpoly




SUBROUTINE fxshfr(l2, nz)

! Computes up to  l2  fixed shift k-polynomials, testing for convergence in
! the linear or quadratic case.  Initiates one of the variable shift
! iterations and returns with the number of zeros found.
! l2 - limit of fixed shift steps
! nz - number of zeros found

INTEGER, INTENT(IN)   :: l2
INTEGER, INTENT(OUT)  :: nz

DOUBLE PRECISION :: svu, svv, ui, vi, s
DOUBLE PRECISION :: betas, betav, oss, ovv, ss, vv, ts, tv, ots, otv, tvv, tss
INTEGER   :: TTYPE, j, iflag
LOGICAL   :: vpass, spass, vtry, stry

nz = 0
betav = .25
betas = .25
oss = sr
ovv = v

! Evaluate polynomial by synthetic division
CALL quadsd(nn, u, v, p, qp, a, b)
CALL calcsc(TTYPE)
DO  j = 1, l2
! calculate next k polynomial and estimate v
  CALL nextk(TTYPE)
  CALL calcsc(TTYPE)
  CALL newest(TTYPE, ui, vi)
  vv = vi

! Estimate s
  ss = 0
  IF (k(n) /= 0.d0) ss = -p(nn) / k(n)
  tv = 1
  ts = 1
  IF (j /= 1 .AND. TTYPE /= 3) THEN
! Compute relative measures of convergence of s and v sequences
    IF (vv /= 0.) tv = ABS((vv-ovv)/vv)
    IF (ss /= 0.) ts = ABS((ss-oss)/ss)

! If decreasing, multiply two most recent convergence measures
    tvv = 1
    IF (tv < otv) tvv = tv * otv
    tss = 1
    IF (ts < ots) tss = ts * ots

! Compare with convergence criteria
    vpass = tvv < betav
    spass = tss < betas
    IF (spass .OR. vpass) THEN

! At least one sequence has passed the convergence test.
! Store variables before iterating
      svu = u
      svv = v
      svk(1:n) = k(1:n)
      s = ss

! Choose iteration according to the fastest converging sequence
      vtry = .false.
      stry = .false.
      IF (spass .AND. ((.NOT.vpass) .OR. tss < tvv)) GO TO 40
      20 CALL quadit(ui, vi, nz)
      IF (nz > 0) RETURN

! Quadratic iteration has failed. flag that it has
! been tried and decrease the convergence criterion.
      vtry = .true.
      betav = betav * .25

! Try linear iteration if it has not been tried and
! the s sequence is converging
      IF (stry.OR.(.NOT.spass)) GO TO 50
      k(1:n) = svk(1:n)
      40 CALL realit(s, nz, iflag)
      IF (nz > 0) RETURN

! Linear iteration has failed.  Flag that it has been
! tried and decrease the convergence criterion
      stry = .true.
      betas = betas * .25
      IF (iflag /= 0) THEN

! If linear iteration signals an almost double real
! zero attempt quadratic interation
        ui = -(s+s)
        vi = s * s
        GO TO 20
      endif

! Restore variables
      50 u = svu
      v = svv
      k(1:n) = svk(1:n)

! Try quadratic iteration if it has not been tried
! and the v sequence is converging
      IF (vpass .AND. (.NOT.vtry)) GO TO 20

! Recompute qp and scalar values to continue the second stage
      CALL quadsd(nn, u, v, p, qp, a, b)
      CALL calcsc(TTYPE)
    endif
  endif
  ovv = vv
  oss = ss
  otv = tv
  ots = ts
END DO
RETURN
END SUBROUTINE fxshfr




SUBROUTINE quadit(uu, vv, nz)

! Variable-shift k-polynomial iteration for a quadratic factor, converges
! only if the zeros are equimodular or nearly so.
! uu,vv - coefficients of starting quadratic
! nz - number of zero found

DOUBLE PRECISION, INTENT(IN)  :: uu
DOUBLE PRECISION, INTENT(IN)  :: vv
INTEGER, INTENT(OUT)   :: nz

DOUBLE PRECISION :: ui, vi
DOUBLE PRECISION :: mp, omp, ee, relstp, t, zm
INTEGER   :: TTYPE, i, j
LOGICAL   :: tried

nz = 0
tried = .false.
u = uu
v = vv
j = 0
relstp = 0
omp = 0

! Main loop
10 CALL quad(1.d0, u, v, szr, szi, lzr, lzi)

! Return if roots of the quadratic are real and not
! close to multiple or nearly equal and  of opposite sign.
IF (ABS(ABS(szr)-ABS(lzr)) > .01D0*ABS(lzr)) RETURN

! Evaluate polynomial by quadratic synthetic division
CALL quadsd(nn, u, v, p, qp, a, b)
mp = ABS(a-szr*b) + ABS(szi*b)

! Compute a rigorous  bound on the rounding error in evaluting p
zm = SQRT(ABS( DBLE(v)))
ee = 2. * ABS( DBLE(qp(1)))
t = -szr * b
DO  i = 2, n
  ee = ee * zm + ABS( DBLE(qp(i)) )
END DO
ee = ee * zm + ABS( DBLE(a) + t)
ee = (5.*mre+4.*are) * ee - (5.*mre+2.*are) * (ABS( DBLE(a)  + t) +  &
     ABS( DBLE(b))*zm) + 2. * are * ABS(t)

! Iteration has converged sufficiently if the
! polynomial value is less than 20 times this bound
IF (mp <= 20.*ee) THEN
  nz = 2
  RETURN
endif
j = j + 1

! Stop iteration after 20 steps
IF (j > 20) RETURN
IF (j >= 2) THEN
  IF (.NOT.(relstp > .01 .OR. mp < omp .OR. tried)) THEN

! A cluster appears to be stalling the convergence.
! five fixed shift steps are taken with a u,v close to the cluster
    IF (relstp < eta) relstp = eta
    relstp = SQRT(relstp)
    u = u - u * relstp
    v = v + v * relstp
    CALL quadsd(nn, u, v, p, qp, a, b)
    DO  i = 1, 5
      CALL calcsc(TTYPE)
      CALL nextk(TTYPE)
    END DO
    tried = .true.
    j = 0
  endif
endif
omp = mp

! Calculate next k polynomial and new u and v
CALL calcsc(TTYPE)
CALL nextk(TTYPE)
CALL calcsc(TTYPE)
CALL newest(TTYPE,ui,vi)

! If vi is zero the iteration is not converging
IF (vi == 0.d0) RETURN
relstp = ABS((vi-v)/vi)
u = ui
v = vi
GO TO 10
END SUBROUTINE quadit




SUBROUTINE realit(sss,nz,iflag)

! Variable-shift h polynomial iteration for a real
! zero.
! sss   - starting iterate
! nz    - number of zero found
! iflag - flag to indicate a pair of zeros near real axis.

DOUBLE PRECISION, INTENT(IN OUT)  :: sss
INTEGER, INTENT(OUT)       :: nz, iflag

DOUBLE PRECISION :: pv, kv, t, s
DOUBLE PRECISION :: ms, mp, omp, ee
INTEGER   :: i, j

nz = 0
s = sss
iflag = 0
j = 0
t = 0
omp = 0

! Main loop
10 pv = p(1)

! Evaluate p at s
qp(1) = pv
DO  i = 2, nn
  pv = pv * s + p(i)
  qp(i) = pv
END DO
mp = ABS(pv)

! Compute a rigorous bound on the error in evaluating p
ms = ABS(s)
ee = (mre/(are+mre)) * ABS( DBLE(qp(1)))
DO  i = 2, nn
  ee = ee * ms + ABS( DBLE(qp(i)))
END DO

! Iteration has converged sufficiently if the
! polynomial value is less than 20 times this bound
IF (mp <= 20.*((are+mre)*ee - mre*mp)) THEN
  nz = 1
  szr = s
  szi = 0.d0
  RETURN
endif
j = j + 1

! Stop iteration after 10 steps
IF (j > 10) RETURN
IF (j >= 2) THEN
  IF (ABS(t) <= .001*ABS(s-t) .AND. mp > omp) THEN
! A cluster of zeros near the real axis has been encountered,
! return with iflag set to initiate a quadratic iteration
    iflag = 1
    sss = s
    RETURN
  endif
endif

! Return if the polynomial value has increased significantly
omp = mp

! Compute t, the next polynomial, and the new iterate
kv = k(1)
qk(1) = kv
DO  i = 2, n
  kv = kv * s + k(i)
  qk(i) = kv
END DO
IF (ABS(kv) > ABS(k(n))*10.*eta) THEN
! Use the scaled form of the recurrence if the value of k at s is nonzero
  t = -pv / kv
  k(1) = qp(1)
  DO  i = 2, n
    k(i) = t * qk(i-1) + qp(i)
  END DO
ELSE
! Use unscaled form
  k(1) = 0.0D0
  DO  i = 2, n
    k(i) = qk(i-1)
  END DO
endif
kv = k(1)
DO  i = 2, n
  kv = kv * s + k(i)
END DO
t = 0.d0
IF (ABS(kv) > ABS(k(n))*10.*eta) t = -pv / kv
s = s + t
GO TO 10
END SUBROUTINE realit




SUBROUTINE calcsc(TTYPE)

! This routine calculates scalar quantities used to
! compute the next k polynomial and new estimates of
! the quadratic coefficients.
! type - integer variable set here indicating how the
! calculations are normalized to avoid overflow

INTEGER, INTENT(OUT)  :: TTYPE

! Synthetic division of k by the quadratic 1,u,v
CALL quadsd(n, u, v, k, qk, c, d)
IF (ABS(c) <= ABS(k(n))*100.*eta) THEN
  IF (ABS(d) <= ABS(k(n-1))*100.*eta) THEN
    TTYPE = 3
! type=3 indicates the quadratic is almost a factor of k
    RETURN
  endif
endif

IF (ABS(d) >= ABS(c)) THEN
  TTYPE = 2
! type=2 indicates that all formulas are divided by d
  e = a / d
  f = c / d
  g = u * b
  h = v * b
  a3 = (a+g) * e + h * (b/d)
  a1 = b * f - a
  a7 = (f+u) * a + h
  RETURN
endif
TTYPE = 1
! type=1 indicates that all formulas are divided by c
e = a / c
f = d / c
g = u * e
h = v * b
a3 = a * e + (h/c+g) * b
a1 = b - a * (d/c)
a7 = a + g * d + h * f
RETURN
END SUBROUTINE calcsc




SUBROUTINE nextk(TTYPE)

! Computes the next k polynomials using scalars computed in calcsc.

INTEGER, INTENT(IN)  :: TTYPE

DOUBLE PRECISION :: temp
INTEGER   :: i

IF (TTYPE /= 3) THEN
  temp = a
  IF (TTYPE == 1) temp = b
  IF (ABS(a1) <= ABS(temp)*eta*10.) THEN
! If a1 is nearly zero then use a special form of the recurrence
    k(1) = 0.d0
    k(2) = -a7 * qp(1)
    DO  i = 3, n
      k(i) = a3 * qk(i-2) - a7 * qp(i-1)
    END DO
    RETURN
  endif

! Use scaled form of the recurrence
  a7 = a7 / a1
  a3 = a3 / a1
  k(1) = qp(1)
  k(2) = qp(2) - a7 * qp(1)
  DO  i = 3, n
    k(i) = a3 * qk(i-2) - a7 * qp(i-1) + qp(i)
  END DO
  RETURN
endif

! Use unscaled form of the recurrence if type is 3
k(1) = 0.d0
k(2) = 0.d0
DO  i = 3, n
  k(i) = qk(i-2)
END DO
RETURN
END SUBROUTINE nextk




SUBROUTINE newest(TTYPE,uu,vv)

! Compute new estimates of the quadratic coefficients
! using the scalars computed in calcsc.

INTEGER, INTENT(IN)     :: TTYPE
DOUBLE PRECISION, INTENT(OUT)  :: uu
DOUBLE PRECISION, INTENT(OUT)  :: vv

DOUBLE PRECISION :: a4, a5, b1, b2, c1, c2, c3, c4, temp

! Use formulas appropriate to setting of type.
IF (TTYPE /= 3) THEN
  IF (TTYPE /= 2) THEN
    a4 = a + u * b + h * f
    a5 = c + (u+v*f) * d
  ELSE
    a4 = (a+g) * f + h
    a5 = (f+u) * c + v * d
  endif

! Evaluate new quadratic coefficients.
  b1 = -k(n) / p(nn)
  b2 = -(k(n-1)+b1*p(n)) / p(nn)
  c1 = v * b2 * a1
  c2 = b1 * a7
  c3 = b1 * b1 * a3
  c4 = c1 - c2 - c3
  temp = a5 + b1 * a4 - c4
  IF (temp /= 0.d0) THEN
    uu = u - (u*(c3+c2)+v*(b1*a1+b2*a7)) / temp
    vv = v * (1.+c4/temp)
    RETURN
  endif
endif

! If type=3 the quadratic is zeroed
uu = 0.d0
vv = 0.d0
RETURN
END SUBROUTINE newest




SUBROUTINE quadsd(nn, u, v, p, q, a, b)

! Divides p by the quadratic  1,u,v  placing the
! quotient in q and the remainder in a,b.

INTEGER, INTENT(IN)     :: nn
DOUBLE PRECISION, INTENT(IN)   :: u, v, p(nn)
DOUBLE PRECISION, INTENT(OUT)  :: q(nn), a, b

DOUBLE PRECISION  :: c
INTEGER    :: i

b = p(1)
q(1) = b
a = p(2) - u * b
q(2) = a
DO  i = 3, nn
  c = p(i) - u * a - v * b
  q(i) = c
  b = a
  a = c
END DO
RETURN
END SUBROUTINE quadsd




SUBROUTINE quad(a, b1, c, sr, si, lr, li)

! Calculate the zeros of the quadratic a*z**2+b1*z+c.
! The quadratic formula, modified to avoid overflow, is used to find the
! larger zero if the zeros are real and both zeros are complex.
! The smaller real zero is found directly from the product of the zeros c/a.

DOUBLE PRECISION, INTENT(IN)             :: a, b1, c
DOUBLE PRECISION, INTENT(OUT)            :: sr, si, lr, li

DOUBLE PRECISION :: b, d, e

IF (a /= 0.d0) GO TO 20
sr = 0.d0
IF (b1 /= 0.d0) sr = -c / b1
lr = 0.d0
10 si = 0.d0
li = 0.d0
RETURN

20 IF (c == 0.d0) THEN
  sr = 0.d0
  lr = -b1 / a
  GO TO 10
endif

! Compute discriminant avoiding overflow
b = b1 / 2.d0
IF (ABS(b) >= ABS(c)) THEN
  e = 1.d0 - (a/b) * (c/b)
  d = SQRT(ABS(e)) * ABS(b)
ELSE
  e = a
  IF (c < 0.d0) e = -a
  e = b * (b/ABS(c)) - e
  d = SQRT(ABS(e)) * SQRT(ABS(c))
endif
IF (e >= 0.d0) THEN

! Real zeros
  IF (b >= 0.d0) d = -d
  lr = (-b+d) / a
  sr = 0.d0
  IF (lr /= 0.d0) sr = (c/lr) / a
  GO TO 10
endif
! complex conjugate zeros
sr = -b / a
lr = sr
si = ABS(d/a)
li = -si
RETURN
END SUBROUTINE quad

END MODULE Solve_Real_Poly

! This file is part of the ellc binary star model
! Copyright (C) 2016 Pierre Maxted
! 
! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

module coords
implicit none

!
! Coordinate transformation for ellc 
!
! Assumes that the stellar rotation axis and orbital angular momentum axes are
! parallel.
! 
! The star is defined by an ellipsoid which is offset by a distance D from the
! centre-of-mass of the star towards the companion.
!
! Star coordinate system is (x, y, z) with origin at the star's centre-of-mass
! - x towards the companion
! - y in the orbital plane with star motion towards negative y
! - z parallel to rotation/orbital angular momentum vector
!
! Ellipsoid coordinate system is (x', y', z') with origin at the centre of the
! ellipsoid, i.e., x' = x - D, y' = y, z' = z.
!
! Observer coordinate system (u, v, w) with origin at the centre-of-mass of the
! binary
! - u in the plane of the sky perpendicular to the angular momentum vector
! - v in the plane of the sky parallel to the angular momentum vector
! - w pointing towards the observer
!
! The ellipsoid defining the star projected onto the plane of the sky is an
! ellipse. The projected coordinate system is (s, t, p) with the same origin as
! (x',y',z') and the same orientation as (u, v, w).
! 
! The inclination, incl, is the angle between the orbital angular momentum
! vector and the line of sight.
!
! The angle phi is measured from the x-axis to the projection of the w-axis
! in the x-y plane.
!
!  The distance from the centre-of-mass of the binary to the centre-of-mass for 
! star 1 is r_1, and similarly for star_2, r_2.
!
! HISTORY
! -------
!
! Sep 2016
! First version 
! p.maxted@keele.ac.uk
!
!

! *** All angles in radians ***
public xyz2stp  ! Star to projected
public stp2xyz  ! Projected to star
public uvw2stp  ! Observer to projected

contains

function xyz2stp(xyz,D,incl,phi) result (stp)
implicit none

double precision,intent(in) :: xyz(3),D,incl,phi
double precision            :: stp(3)

! Local variables
double precision :: xp, yp, zp, sini, cosi, sinphi, cosphi

sini = sin(incl)
cosi = cos(incl)
sinphi = sin(phi)
cosphi = cos(phi)
xp = xyz(1) - D
yp = xyz(2)
zp = xyz(3)
stp(1) =  xp*sinphi      + yp*cosphi
stp(2) = -xp*cosphi*cosi + yp*sinphi*cosi + zp*sini
stp(3) =  xp*cosphi*sini - yp*sinphi*sini + zp*cosi

end function xyz2stp

!--------------------------------------------------------------------------

function stp2xyz(stp,D,incl,phi) result (xyz)
implicit none

double precision,intent(in) :: stp(3),D,incl,phi
double precision            :: xyz(3)

! Local variables
double precision :: s, t, p, sini, cosi, sinphi, cosphi

sini = sin(incl)
cosi = cos(incl)
sinphi = sin(phi)
cosphi = cos(phi)
s = stp(1)
t = stp(2)
p = stp(3)
xyz(1) =  s*sinphi - t*cosphi*cosi + p*cosphi*sini + D
xyz(2) =  s*cosphi + t*sinphi*cosi - p*sinphi*sini
xyz(3) =             t*sini        + p*cosi

end function stp2xyz

!--------------------------------------------------------------------------

function uvw2stp(uvw,D,incl,phi,r_i) result (stp)
implicit none

double precision,intent(in) :: uvw(3),D,incl,phi, r_i
! r_i is distance from binary c-of-m to c-of-m for star i 
double precision            :: stp(3)

! Local variables
double precision :: u, v, w, sini, cosi, sinphi, cosphi, s_0, t_0, p_0

sini = sin(incl)
cosi = cos(incl)
sinphi = sin(phi)
cosphi = cos(phi)

! Origin of (u, v, w) coordinate system in (s, t, p) coordinate system
s_0 =  (r_i-D)*sinphi
t_0 = -(r_i-D)*cosphi*cosi
p_0 =  (r_i-D)*cosphi*sini
u = uvw(1)
v = uvw(2)
w = uvw(3)
stp(1) =  s_0 + u
stp(2) =  t_0 + v
stp(3) =  p_0 + w

end function uvw2stp

end module coords

! This file is part of the ellc binary star model
! Copyright (C) 2016 Pierre Maxted
! 
! This program is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! You should have received a copy of the GNU General Public License
! along with this program.  If not, see <http://www.gnu.org/licenses/>.

module ellipse
! Module for storage and manipulation of ellipses 
!
! Ellipse data stored in one double precision array with n_ell_par parameters
!
! Ellipses can be represented as a quadratic curve
!   ax**2 + 2bxy + cy**2 + 2dx + 2fy + g = 0
!
! Ellipses can also be described by the following 5 parameters
!  a_p = semi-major axis
!  b_p = semi-minor axis
!  x_c, y_c = coordinates of centre
!  phi  = angle measured ccw from x-axis to the major axis in radians 
!
! The parametric equation of the ellipse is
!   x = a_p*cos(phi)*cos(t) - b_p*sin(phi)*sin(t) + x_c
!   y = a_p*sin(phi)*cos(t) + b_p*cos(phi)*sin(t) + y_c
!
! The ellipse parameters and properties can be accessed as follows
!  ellipse(i_ell_qcoeff) = [a, b, c, d, f, g]
!  ellipse(i_ell_ellpar) = [a_p, b_p, x_c, y_c, phi]
!  ellipse(i_ell_a_p) = a_p
!  ellipse(i_ell_b_p) = b_p
!  ellipse(i_ell_x_c) = x_c
!  ellipse(i_ell_y_c) = y_c
!  ellipse(i_ell_phi) = phi
!  ellipse(i_ell_area) = area
!  ellipse(i_ell_cosphi) = x-axis projection factor cos(phi)
!  ellipse(i_ell_sinphi) = y-axis projection factor sin(phi)
!
! Affine transformations are stored in an array tr(2,3)
!   x_t = tr(1,3) + tr(1,1)*x + tr(1,2)*y
!   y_t = tr(2,3) + tr(2,1)*x + tr(2,2)*y
! 
! HISTORY
! Apr 2019
!  Added check for very-nearly identical ellipses
!
! Jun 2017
!  Changed root polishing in ell_ell_roots to Maehly's procedure
!
! May 2016
!  Added a warning if root polishing failed to converge in ell_ell_roots
!
! Apr 2016
! Added do while loop to root polishing in ell_ell_roots
! p.maxted@keele.ac.uk
!
! Jan 2016
! First version 
! p.maxted@keele.ac.uk
!

use constants
use utils
use solve_real_poly

private

! Functions to create ellipses
public ell_init_from_par     ! New ellipse from parameters
public ell_init_from_qcoeff  ! New ellipse from coefficients of quadratic curve
public ell_project_ellipsoid ! Ellipse that is the projection of an ellipsoid
! Functions to transform ellipses
public ell_affine            ! Apply an affine transformation to an ellipse
public ell_move              ! Translation ellipse
public ell_rotate            ! Rotate ellipse around the origin
public ell_shrink            ! Scaling along x- and y- axes
public ell_ell_normalize     ! Transform to unit circle + horizontal ellipse
! Functions to find a point on an ellipse
public ell_xy_to_t           ! Parametric angle of a point on an ellipse
public ell_t_to_xy           ! Point on ellipse for a given parametric angle
! Functions to calculate properties of ellipses
public ell_evaluate_qcoeff   ! Evaluate quadratic curve polynomial at a point.
public ell_point_is_inside   ! Test if point is inside ellipse
public ell_line_intersect    ! Intersection of a line with ellipse
public ell_nearfar           ! Nearest/furthest points from the origin
public ell_ell_overlap       ! Area bounded by overlap of two ellipses
public ell_ell_intersect     ! Intersection points of two ellipses (non-tangent)
public ell_ucircle_overlap   ! Ellipse/unit circle overlap area
public ell_sector_area       ! Area of an elliptical sector

!------------------------------------------------------------------------------

! Indices for ellipse parameters
integer, parameter, public :: n_ell_par = 14
integer, parameter, public :: i_ell_qcoeff(6) = [1, 2, 3, 4, 5, 6]
integer, parameter, public :: i_ell_ellpar(5) = [7, 8, 9, 10, 11]
integer, parameter, public :: i_ell_a_p = 7
integer, parameter, public :: i_ell_b_p = 8
integer, parameter, public :: i_ell_x_c = 9
integer, parameter, public :: i_ell_y_c = 10
integer, parameter, public :: i_ell_phi = 11
integer, parameter, public :: i_ell_area = 12
integer, parameter, public :: i_ell_cosphi = 13
integer, parameter, public :: i_ell_sinphi = 14

! Bit flags for ell_ell_overlap, ell_ell_intersect, ell_ucircle_overlap 
integer, parameter, public :: b_ell_no_overlap         = 0
integer, parameter, public :: b_ell_1_inside_2         = 1
integer, parameter, public :: b_ell_2_inside_1         = 2
integer, parameter, public :: b_ell_two_intersects     = 3
integer, parameter, public :: b_ell_four_intersects    = 4
integer, parameter, public :: b_ell_identical          = 5
integer, parameter, public :: b_ell_invalid            = 7
integer, parameter, public :: b_ell_error              = 8
integer, parameter, public :: b_ell_warn_inaccurate    = 9
integer, parameter, public :: b_ell_ellipse_inside_circle = 1
integer, parameter, public :: b_ell_circle_inside_ellipse = 2

contains

function ell_init_from_par(ellpar) result(ellipse)
! Set ellipse data from parameters of the ellipse.
!  ellpar = [a_p, b_p, x_c, y_c, phi]
!  
!  If a_p <= 0 or b_p <= then all elements of ellipse are set to bad_dble
implicit none
double precision,intent(in) :: ellpar(5)
!f2py integer, parameter :: n_ell_par = 14
double precision            :: ellipse(n_ell_par) 

! Local variables
double precision :: a_p, b_p, x_c, y_c, phi
double precision :: cosphi,cosphi2,sinphi,sinphi2,asq,bsq
double precision :: tmp0,tmp1,anorm, qcoeff(6)

a_p = ellpar(1)
b_p = ellpar(2)
x_c = ellpar(3)
y_c = ellpar(4)
phi = ellpar(5)
if ((a_p <= 0.0d0).or.(b_p<=0.0d0)) then
  ellipse(:) = bad_dble
  return
endif
if (a_p < b_p) then
  call swap(a_p,b_p)
  phi = mod(phi+halfpi,twopi)
endif

! Calculate coefficients of the quadratic curve
cosphi = cos(phi)
sinphi = sin(phi)
cosphi2 = cosphi**2
sinphi2 = 1.0d0 - cosphi2
asq = a_p**2
bsq = b_p**2
anorm = min(asq,bsq)
tmp0 = (cosphi*x_c + sinphi*y_c)/asq
tmp1 = (sinphi*x_c - cosphi*y_c)/bsq
qcoeff(1) = (cosphi2/asq + sinphi2/bsq) * anorm
qcoeff(2) = cosphi*sinphi*(1.d0/asq - 1.d0/bsq) * anorm
qcoeff(3) = (sinphi2/asq + cosphi2/bsq) * anorm
qcoeff(4) = (-cosphi*tmp0 - sinphi*tmp1) * anorm
qcoeff(5) = (-sinphi*tmp0 + cosphi*tmp1) * anorm
qcoeff(6) = (tmp0**2*asq + tmp1**2*bsq - 1.d0) * anorm
ellipse(i_ell_qcoeff) = qcoeff

! Copy ellipse parameters to ellipse array
ellipse(i_ell_a_p) = a_p
ellipse(i_ell_b_p) = b_p
ellipse(i_ell_x_c) = x_c
ellipse(i_ell_y_c) = y_c
ellipse(i_ell_phi) = phi

! Calculate and store area and projection factors
ellipse(i_ell_area) = pi*a_p*b_p
ellipse(i_ell_cosphi) = cosphi 
ellipse(i_ell_sinphi) = sinphi 

end function ell_init_from_par

!-------------------------------------------------------------------------------

function ell_init_from_qcoeff(qcoeff) result(ellipse)
! Set ellipse data from coefficients of the quadratic curve.
!  ax**2 + 2bxy + cy**2 + 2dx + 2fy + g = 0
!  qcoeff = [a, b, c, d, f, g]
!
! If these coefficients do not describe an ellipse then all elements of
! ellipse are set to bad_dble
!
! Equations for a_p, b_p and phi adapted from 
!  mathworld.wolfram.com/Ellipse.html
! (equation numbers given in comments).
! Modified calculation so that a_p > b_p in all cases.
!
      
implicit none
double precision,intent(in) :: qcoeff(6)
!f2py integer, parameter :: n_ell_par = 14
double precision            :: ellipse(n_ell_par) 

! Local variables
double precision :: a, b, c, d, f, g
double precision :: a_p, b_p, x_c, y_c, phi
double precision :: num, ss, t1,t2
double precision :: b2, d2, f2, dd, jj, ii

! Initialise to error flag value so we can return on error
ellipse(:) = bad_dble

a = qcoeff(1)
b = qcoeff(2)
c = qcoeff(3)
d = qcoeff(4)
f = qcoeff(5)
g = qcoeff(6)

! Calculate ellipse parameters
b2 = b**2
d2 = d**2
f2 = f**2

! (16)
dd = a*(c*g-f2) - b*(b*g-f*d) + d*(b*f-c*d) 
if (dd == 0.d0) return
! (17)
jj = a*c - b2  
if (jj <= 0.d0) return
! (18)
ii = a + c     
if (ii == 0.d0) return
if (dd/ii >= 0.d0) return

! (19), (20)
x_c = (b*f - c*d)/jj 
y_c = (b*d - a*f)/jj

num =2.d0*(a*f2 + c*d2 + g*b2 - 2.d0*b*d*f - a*c*g) 
ss = sqrt((a-c)**2 + 4.d0*b2)

! (21), (22) - added logic here so that a_p > b_p
t1 = sqrt(num/(jj*(ii - ss)))  
t2 = sqrt(num/(jj*(ii + ss)))  
if (t1 > t2) then
  a_p = t1 
  b_p = t2
else
  a_p = t2 
  b_p = t1
endif

! (23)
if (a == c) then
  if (t1 > t2) then
    phi = 1.5d0*halfpi
  else
    phi = 0.5d0*halfpi
  endif
else if ((a < c).eqv.(t1 > t2)) then
  if (b == 0.d0) then
    phi = 0.d0
  else
    phi =  acot((a-c)/(2.d0*b))/2.d0
  endif
else
  if (b == 0.d0) then
    phi = halfpi
  else
    phi = halfpi+ acot((a-c)/(2.d0*b))/2.d0
  endif
endif

! Copy quadratic curve function into ellipse array
ellipse(i_ell_qcoeff) = qcoeff

! Copy  ellipse parameters into into ellipse array
ellipse(i_ell_a_p) = a_p
ellipse(i_ell_b_p) = b_p
ellipse(i_ell_x_c) = x_c
ellipse(i_ell_y_c) = y_c
ellipse(i_ell_phi) = phi

! Calculate and store area and projection factors
ellipse(i_ell_area) = pi*a_p*b_p
ellipse(i_ell_cosphi) = cos(phi)
ellipse(i_ell_sinphi) = sin(phi)

end function ell_init_from_qcoeff

!------------------------------------------------------------------------------

double precision function ell_evaluate_qcoeff(xy,ellipse)
! Evaluate  ax**2 + 2bxy + cy**2 + 2dx + 2fy + g 
implicit none
double precision, intent(in) :: xy(2)       ! (x, y)
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse(n_ell_par) ! Ellipse

! Local variable
double precision :: x, y
x = xy(1)
y = xy(2)
ell_evaluate_qcoeff = ellipse(1)*x**2 + 2.d0*ellipse(2)*x*y  &
                    + ellipse(3)*y**2 + 2.d0*ellipse(4)*x  &
                    + 2.d0*ellipse(5)*y + ellipse(6)
return
end function ell_evaluate_qcoeff

!-----------------------------------------------------------------------------

function ell_move(u, v, ellipse) result(ellipse_tr)
! Apply a translation (u, v) to ellipse
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: u, v, ellipse(n_ell_par)
double precision :: ellipse_tr(n_ell_par)

!Local variables
double precision :: a, b, c, d, f, g

ellipse_tr(:) = ellipse(:)

ellipse_tr(i_ell_x_c) = ellipse(i_ell_x_c) + u
ellipse_tr(i_ell_y_c) = ellipse(i_ell_y_c) + v

a = ellipse(1)
b = ellipse(2)
c = ellipse(3)
d = ellipse(4)
f = ellipse(5)
g = ellipse(6)
ellipse_tr(4) = d - a*u - b*v 
ellipse_tr(5) = f - b*u - c*v
ellipse_tr(6) = g + a*u*u  + c*v*v + 2.d0*(b*u*v - d*u - f*v)
      
end function ell_move

!------------------------------------------------------------------------------

function ell_rotate(theta, ellipse) result(ellipse_r)
! Rotate an ellipse theta radians counter-clockwise around the origin
implicit none
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: theta, ellipse(n_ell_par)
double precision :: ellipse_r(n_ell_par)

!Local variables
double precision :: ellpar(5)

ellpar(1) = ellipse(i_ell_a_p)
ellpar(2) = ellipse(i_ell_b_p)
ellpar(3) = cos(theta)*ellipse(i_ell_x_c) - sin(theta)*ellipse(i_ell_y_c)
ellpar(4) = sin(theta)*ellipse(i_ell_x_c) + cos(theta)*ellipse(i_ell_y_c)
ellpar(5) = mod(ellipse(i_ell_phi)+twopi+theta,twopi)

ellipse_r = ell_init_from_par(ellpar)

end function ell_rotate

!------------------------------------------------------------------------------

function ell_shrink(xscale, yscale, ellipse) result(ellipse_s)
! Apply change of scale x' = xscale*x and y' = yscale*y to ellipse
implicit none
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: xscale, yscale, ellipse(n_ell_par)
double precision :: ellipse_s(n_ell_par)

!Local variables
double precision :: qcoeff(6)

qcoeff(1) = xscale**2 * ellipse(1)
qcoeff(2) = xscale*yscale * ellipse(2)
qcoeff(3) = yscale**2 * ellipse(3)
qcoeff(4) = xscale * ellipse(4)
qcoeff(5) = yscale * ellipse(5)
qcoeff(6) = ellipse(6)

ellipse_s = ell_init_from_qcoeff(qcoeff)

end function ell_shrink

!-----------------------------------------------------------------------------

logical function ell_point_is_inside(xy,ellipse,q_value)
! Return true if the given point is inside the given ellipse
! Points on the circumference of ellipse return false.
implicit none
double precision, intent(in) :: xy(2)       ! (x, y)
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse(n_ell_par) ! 
double precision, intent(out), optional :: q_value 

! Local variables
double precision :: q
q = ell_evaluate_qcoeff(xy,ellipse)
ell_point_is_inside = (q.ne.0.d0) .and. &
                      ((q < 0.d0).eqv.(ellipse(i_ell_qcoeff(1)) > 0.d0))
if (present(q_value)) q_value = q

end function ell_point_is_inside

!-----------------------------------------------------------------------------

function ell_line_intersect(ellipse, qline) result(t)
!
! Intersection of a line with ellipse.
!
! The line is defined by the parametric equation
!  (x, y) = (x_0, y_0) + t*(dx, dy) 
!
! qline = [x_0, y_0, dx, dy]
!
! Values of t for which the line intersects the ellipse are returned in t(2)
!
! If there is only one intersection then t(1) = t(2)
! 
! If there are no intersections then t(1) = -huge(0.d0) and t(2) = huge(0.d0)
!
implicit none
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse(n_ell_par) ! Ellipse
double precision, intent(in) :: qline(4)    ! Parametric equation of the line
double precision :: t(2)                    ! Line parameter values at intercept

! Local variables
double precision :: a,b,c,d,f,g,x0,y0,dx,dy
double precision :: aa,bb,cc,dd

a = ellipse(1)
b = ellipse(2)
c = ellipse(3)
d = ellipse(4)
f = ellipse(5)
g = ellipse(6)
x0 = qline(1)
y0 = qline(2)
dx = qline(3)
dy = qline(4)
aa = a*dx**2 + 2.d0*b*dx*dy + c*dy**2
bb = 2.d0*(a*x0*dx + b*(x0*dy+y0*dx) + c*y0*dy + d*dx + f*dy)
cc = a*x0**2 + c*y0**2 + 2.d0*(d*x0 + b*x0*y0 +f*y0) + g
dd = bb**2 - 4.d0*aa*cc
if (dd < 0.d0) then
  t(1) = -huge(0.d0)
  t(2) =  huge(0.d0)
else
  if (bb >= 0.d0) then
    t(1) = (-bb - sqrt(dd))/(2.d0*aa)
    t(2) = 2.d0*cc/(-bb-sqrt(dd))
  else
    t(1) = 2.d0*cc/(-bb+sqrt(dd))
    t(2) = (-bb + sqrt(dd))/(2.d0*aa)
  endif
endif
return
end function ell_line_intersect

!-----------------------------------------------------------------------------


double precision function ell_xy_to_t(xy, ellipse)
! Parametric angle in the range 0 to 2.pi for a point on an ellipse.
! In fact this works for any point in space apart from the origin of the ellipse
! in which case it is the parametric angle of the point of intersection of the
! line through the centre and the input point with the ellipse. 
implicit none
double precision, intent(in) :: xy(2)  ! Point on ellipse (xy(1), xy(2))
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse(n_ell_par) ! Ellipse

! Local variables
double precision :: a_p, b_p, x_c, y_c, phi

a_p = ellipse( 7)
b_p = ellipse( 8)
x_c = ellipse( 9)
y_c = ellipse(10)
phi = ellipse(11)
ell_xy_to_t = atan2( ((xy(2)-y_c)*cos(phi)-(xy(1)-x_c)*sin(phi))/b_p, &
                     ((xy(1)-x_c)*cos(phi)+(xy(2)-y_c)*sin(phi))/a_p )
if (ell_xy_to_t < 0.0d0) ell_xy_to_t = ell_xy_to_t + twopi
end function ell_xy_to_t
                                                                        
!-------------------------------------------------------------------------------

function ell_t_to_xy(t, ellipse) result(xy)
! Point on an ellipse corresponding to a given parametric angle.
implicit none
double precision, intent(in) :: t                  ! Parametric angle
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse(n_ell_par) ! Ellipse
double precision             :: xy(2)              ! (x, y)

! Local variables
double precision :: a_p, b_p, x_c, y_c, cosphi, sinphi, cost, sint

a_p = ellipse(i_ell_a_p)
b_p = ellipse(i_ell_b_p)
x_c = ellipse(i_ell_x_c)
y_c = ellipse(i_ell_y_c)
cosphi = ellipse(i_ell_cosphi)
sinphi = ellipse(i_ell_sinphi)
cost = cos(t)
sint = sin(t)
xy(1) = a_p*cosphi*cost - b_p*sinphi*sint + x_c
xy(2) = a_p*sinphi*cost + b_p*cosphi*sint + y_c

end function ell_t_to_xy

!-------------------------------------------------------------------------------

function ell_project_ellipsoid(abc, phi, incl) result(ellipse)
! 
! Ellipse that is the projection in the sky plane (s,t) of the triaxial 
! ellipsoid with semi-axes a, b, c and centred on the origin after the
! following rotation matrix has been applied.
!
! [s]   [  sin(phi)            cos(phi)           0         ][x']
! [t] = [ -cos(phi)cos(incl)   sin(phi)cos(incl)  sin(incl) ][y']
! [p]   [  cos(phi)sin(incl)  -sin(phi)sin(incl)  cos(incl) ][z']
!
! Input:
!  abc(3) - semi-axes on x'-axis, y'-axis and z'-axis, resp.
!  phi    - angle between the line-of-sight (p-axis, towards observer)
!           projected in the x'-y' plane and the  x'-axis
!  incl   - angle between the p-axis and the z'-axis
!
! Output:
!  Projected ellipse.
!  All elements set to bad_dble for invalid input.
!
implicit none
double precision, intent(in)  :: abc(3), phi, incl
!f2py integer, parameter :: n_ell_par = 14
double precision              :: ellipse(n_ell_par)

! Local variables
double precision :: t1, t2, t3, t4, t5, t6, t7, a2, b2, c2
double precision :: sini, cosi, sinphi, cosphi
double precision :: sin2phi, cos2phi, sin2i, cos2i
double precision :: qcoeff(6), aa, cc, anorm

if ( minval(abc) <= 0.d0) then

  ellipse(:) = bad_dble

else

  sini = sin(incl)
  cosi = cos(incl)
  sinphi = sin(phi)
  cosphi = cos(phi)
  sin2phi = sinphi**2
  cos2phi = cosphi**2
  sin2i = sini**2
  cos2i = cosi**2
  a2 = 1.d0/abc(1)**2
  b2 = 1.d0/abc(2)**2
  c2 = 1.d0/abc(3)**2
  t1 = sinphi*cosphi*(a2-b2)
  t2 = sini*cosi*(c2 - cos2phi*a2 - sin2phi*b2)
  t3 = sin2i*(cos2phi*a2 + sin2phi*b2) + cos2i*c2
  t4 = sin2phi*a2 + cos2phi*b2
  t5 = cos2phi*cos2i*a2 + sin2phi*cos2i*b2 + sin2i*c2 
  t6 = t1*sini
  t7 = -t1*cosi

  aa = t6**2/t3 - t4
  cc = t2**2/t3 - t5
  anorm = max(abs(aa),abs(cc))
  qcoeff(1) = aa/anorm
  qcoeff(2) = (t2*t6/t3 - t7)/anorm
  qcoeff(3) = cc/anorm
  qcoeff(4) = 0.d0
  qcoeff(5) = 0.d0
  qcoeff(6) = 1.d0/anorm

  ellipse = ell_init_from_qcoeff(qcoeff)
endif

return 

end function ell_project_ellipsoid

!-------------------------------------------------------------------------------

function ell_affine(tr, ellipse, inverse) result(ellipse_tr)
! Apply an affine transformation to an ellipse
!  The result of applything the affine transformation to a point (x, y) is
!   x = tr(1,3) + tr(1,1)*x + tr(1,2)*y
!   y = tr(2,3) + tr(2,1)*x + tr(2,2)*y
!
! If the array tr does not contain an invertable transformation then the
! all values in the return value are set to bad_dble
!
! Set inverse=.true, to apply the inverse transformation
!
implicit none
double precision, intent(in) :: tr(2,3)
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse(n_ell_par)
double precision             :: ellipse_tr(n_ell_par)
logical, optional,intent(in) :: inverse 
logical  :: inverse_l

!Local variables
double precision :: a, b, c, d, f, g
double precision :: p, q, r, s, u, v
double precision :: at, bt, ct, dt, ft, gt, anorm
double precision :: qcoeff(6), det

if (present(inverse)) then
  inverse_l = inverse
else
  inverse_l = .false.
endif

a = ellipse(1)
b = ellipse(2)
c = ellipse(3)
d = ellipse(4)
f = ellipse(5)
g = ellipse(6)

if (inverse_l) then

  p = tr(1,1)
  q = tr(1,2)
  r = tr(2,1)
  s = tr(2,2)
  u = tr(1,3)
  v = tr(2,3)

  ! First the translation
  gt = g + a*u**2 + c*v**2 + 2.d0*(b*u*v + d*u + f*v)
  anorm = max(abs(a),abs(c))
  at  = a/anorm
  bt  = b/anorm
  ct  = c/anorm
  dt  = (d + a*u + b*v)/anorm
  ft  = (f + b*u + c*v)/anorm
  gt  = gt/anorm
  
  ! Then the rotation/scaling/shearing matrix
  qcoeff(1) = at*p**2 + 2.d0*bt*p*r + ct*r**2
  qcoeff(2) = at*p*q + bt*(s*p + r*q) + ct*r*s
  qcoeff(3) = at*q**2 + 2.d0*bt*s*q + ct*s**2
  qcoeff(4) = dt*p + ft*r
  qcoeff(5) = dt*q + ft*s
  qcoeff(6) = gt

else

  det = tr(1,1)*tr(2,2) - tr(1,2)*tr(2,1)
  if (det == 0.d0) then
    ellipse_tr(:) = bad_dble
    return
  endif
  p =  tr(2,2)/det
  q = -tr(1,2)/det
  r = -tr(2,1)/det
  s =  tr(1,1)/det
  u = -tr(1,3)
  v = -tr(2,3)

  ! First the rotation/scaling/shearing matrix
  at = a*p**2 + 2.d0*b*p*r + c*r**2
  bt = a*p*q + b*(s*p + r*q) + c*r*s
  ct = a*q**2 + 2.d0*b*s*q + c*s**2
  dt = d*p + f*r
  ft = d*q + f*s

  ! Now apply the translation
  anorm = max(abs(at),abs(ct))
  qcoeff(1) = at/anorm
  qcoeff(2) = bt/anorm
  qcoeff(3) = ct/anorm
  qcoeff(4) = (dt + at*u + bt*v)/anorm
  qcoeff(5) = (ft + bt*u + ct*v)/anorm
  qcoeff(6) = (g + at*u**2 + ct*v**2 + 2.d0*(bt*u*v + dt*u + ft*v))/anorm

endif

ellipse_tr = ell_init_from_qcoeff(qcoeff)

end function ell_affine

!------------------------------------------------------------------------------

function ell_ell_normalize(ellipse_1, ellipse_2) result (tr)
! Calculate the affine transformation that transforms ellipse_1 to a unit circle
! centred at the origin and ellipse_2 to a horizontal ellipse  centred in the
! upper quadrant.
!
! The affine transformation is returned as an array tr(2,3) that can be applied 
! to a point (x,y) as follows
!  u = tr(1,3) + tr(1,1)*x + tr(1,2)*y
!  v = tr(2,3) + tr(2,1)*x + tr(2,2)*y
! 
! In this coordinate system the parametric equation of the ellipse is
!   u = u_c + a_u cos(s)
!   v = v_c + b_u sin(s)
!  with
!   u_c >= 0
!   v_c >= 0
!   a_u >= b_u
!
!
implicit none
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse_1(n_ell_par)
double precision, intent(in) :: ellipse_2(n_ell_par)
double precision             :: tr(2,3)

! Local variables
double precision             :: s(2,3)
double precision :: uv(2), cosdphi,sindphi
double precision :: ellipse_t(n_ell_par)

! Affine transformation for rotation by -phi_1 and scaling by axis lengths.
s(1,1) =  ellipse_1(i_ell_cosphi)/ellipse_1(i_ell_a_p)
s(1,2) =  ellipse_1(i_ell_sinphi)/ellipse_1(i_ell_a_p)
s(2,1) = -ellipse_1(i_ell_sinphi)/ellipse_1(i_ell_b_p)
s(2,2) =  ellipse_1(i_ell_cosphi)/ellipse_1(i_ell_b_p)
s(1,3) = 0.d0
s(2,3) = 0.d0

! Apply this affine transformation to the origin of ellipse_1
uv(1) = ellipse_1(i_ell_x_c)
uv(2) = ellipse_1(i_ell_y_c)
uv = affine(uv,s)

! Apply the same affine transformation ellipse_2 to find its new orientation
ellipse_t = ell_affine(s, ellipse_2)
cosdphi = ellipse_t(i_ell_cosphi)
sindphi = ellipse_t(i_ell_sinphi)

tr(1,1) =  cosdphi*s(1,1) + sindphi*s(2,1) 
tr(1,2) =  cosdphi*s(1,2) + sindphi*s(2,2) 
tr(2,1) = -sindphi*s(1,1) + cosdphi*s(2,1) 
tr(2,2) = -sindphi*s(1,2) + cosdphi*s(2,2) 
tr(1,3) = -cosdphi*uv(1) - sindphi*uv(2) 
tr(2,3) =  sindphi*uv(1) - cosdphi*uv(2) 

return

end function ell_ell_normalize

!------------------------------------------------------------------------------

function ell_ell_overlap(ellipse_1, ellipse_2, verbose, &
                         xy_intersect, t_int_1, t_int_2) result (area_flags)
!
! Area in the region bounded by the overlap of two ellipses and type of overlap
! The result is returned as a 2-element array
!
! area_flags(1) = area (or bad_dble for invalid input)
!
! area_flags(2) = bit mask with the following flags
!  b_ell_no_overlap       = zero area of overlap (*)
!  b_ell_1_inside_2       = ellipse_1 inside ellipse_2 (*)
!  b_ell_2_inside_1       = ellipse_2 inside ellipse_1 (*)
!  b_ell_two_intersects   = there are two intersection points  (*)
!  b_ell_four_intersects  = there are four intersection points 
!  b_ell_identical        = ellipses are identical
!  b_ell_invalid          = invalid input
!  b_ell_error            = error during calculation
!  b_ell_warn_inaccurate  = results may be inaccurate
!
! Notes
! (*) - the ellipses may (also) share one or two tangent points in these cases.
!  To test these flags, use btest(int(area_flags(2)),<bit flag name>)
!
implicit none
double precision             :: area_flags(2)
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse_1(n_ell_par)
double precision, intent(in) :: ellipse_2(n_ell_par)
integer, intent(in)  :: verbose 
double precision, optional, intent(out)  :: xy_intersect(2,4)
double precision, optional, intent(out)  :: t_int_1(4), t_int_2(4)

! Fraction limit on areas to avoid spurious 4-point intersections due to
! near-tangent points.
double precision, parameter :: atol = 1.0d-5

! Local variables
double precision :: area_tol, separation
double precision :: xyc_1(2), xyc_2(2)
double precision :: area, xyqc(2), xy_int(2,4), qline(4), s_t_a, t_1, t_2, tq(4)
double precision :: xy1(2), xy2(2), theta_1(4), theta_2(4)
integer  :: flags, k(4), j0, j1, i, intersect_flags
logical  :: l_1, l_2, whichell

! Initialize
flags = 0
! Minimum area for integration
area_tol = atol*min(ellipse_1(i_ell_area),ellipse_2(i_ell_area))

call ell_ell_intersect(ellipse_1, ellipse_2, verbose-1, intersect_flags, &
                       xy_int, theta_1, theta_2)

if (present(xy_intersect)) xy_intersect(:,:) = xy_int(:,:)
if (present(t_int_1)) t_int_1(:) = theta_1(:)
if (present(t_int_2)) t_int_2(:) = theta_2(:)

if (btest(intersect_flags, b_ell_identical)) then
  if (verbose >= v_debug) then
    print *,'ell_ell_overlap: identical ellipses.'
  endif
  flags = ibset(flags,b_ell_identical)
  area_flags(1) = ellipse_1(i_ell_area)
  area_flags(2) = flags
  return
endif

if (btest(intersect_flags, b_ell_1_inside_2)) then
    flags = ibset(flags,b_ell_1_inside_2)
    area_flags(1) = ellipse_1(i_ell_area)
    area_flags(2) = flags
    return
endif

if (btest(intersect_flags, b_ell_2_inside_1)) then
  flags = ibset(flags,b_ell_2_inside_1)
  area_flags(1) = ellipse_2(i_ell_area)
  area_flags(2) = flags
  return
endif

if (btest(intersect_flags, b_ell_no_overlap)) then
  flags = ibset(flags, b_ell_no_overlap)
  area_flags(1) = 0.d0
  area_flags(2) = flags
  return
endif

if (btest(intersect_flags, b_ell_two_intersects)) then

  flags = ibset(flags,b_ell_two_intersects)
  xy1 = ell_t_to_xy(midangle(theta_1(1),theta_1(2)), ellipse_1)
  l_1 = ell_point_is_inside(xy1,ellipse_2)
  xyc_1(1:2) = [ellipse_1(i_ell_x_c),ellipse_1(i_ell_y_c)]
  if (l_1) then
    area =  ell_sector_area(theta_1(1),theta_1(2),ellipse_1)  &
         - triangle_area(xyc_1,xy_int(1:2,1),xy_int(1:2,2))
  else
    area = ellipse_1(i_ell_area) &
         - ell_sector_area(theta_1(1),theta_1(2),ellipse_1)  &
         + triangle_area(xyc_1,xy_int(1:2,1),xy_int(1:2,2))
  endif
  xy2 = ell_t_to_xy(midangle(theta_2(1),theta_2(2)), ellipse_2)
  l_2 = ell_point_is_inside(xy2,ellipse_1)
  xyc_2(1:2) = [ellipse_2(i_ell_x_c),ellipse_2(i_ell_y_c)]
  if (l_2) then
    area = area + ell_sector_area(theta_2(1),theta_2(2),ellipse_2)  &
         - triangle_area(xyc_2,xy_int(1:2,1),xy_int(1:2,2))
  else
    area = area + ellipse_2(i_ell_area) &
         - ell_sector_area(theta_2(1),theta_2(2),ellipse_2)  &
         + triangle_area(xyc_2,xy_int(1:2,1),xy_int(1:2,2))
  endif
  if (verbose >= v_debug) then
    print *,'ell_ell_overlap, two intersections, area = ',area
  endif
  area_flags(1) = area
  area_flags(2) = flags
  return

endif

if (btest(intersect_flags, b_ell_four_intersects)) then
  flags = ibset(flags,b_ell_four_intersects)
  
  ! Deal with intersection points in clockwise order, sorted by the angle to the
  ! x-axis measured from their centroid.
  xyqc = sum(xy_int,dim=2)/4.d0
  tq = atan2(xy_int(2,1:4)-xyqc(2),xy_int(1,1:4)-xyqc(1))
  call heapsort(tq,k)

  ! Area of quadrilateral
  area = 0.5d0*abs( &
          (xy_int(1,k(3))-xy_int(1,k(1)))*(xy_int(2,k(4))-xy_int(2,k(2))) &
        - (xy_int(1,k(4))-xy_int(1,k(2)))*(xy_int(2,k(3))-xy_int(2,k(1))) )
  ! Can catch a problem here with a near-tangent point producing four
  ! intersections all very close together
  if (area < area_tol) then
    separation = hypot(ellipse_1(i_ell_x_c)-ellipse_2(i_ell_x_c), &
                       ellipse_1(i_ell_y_c)-ellipse_2(i_ell_y_c) )
    if (separation >= (ellipse_1(i_ell_a_p)+ellipse_2(i_ell_a_p))) then
      flags = ibset(0, b_ell_no_overlap)
      area = 0
    else 
      if (ellipse_1(i_ell_area) < ellipse_2(i_ell_area)) then
        flags = ibset(0,b_ell_1_inside_2)
        area = ellipse_1(i_ell_area)
      else
        flags = ibset(0,b_ell_2_inside_1)
        area = ellipse_2(i_ell_area)
      endif
    endif
    if (verbose >= v_debug) then
      print *,'ell_ell_overlap: resolving near-tangent'
      print *,'ell_ell_overlap: ',ellipse_1
      print *,'ell_ell_overlap: ',ellipse_2
      print *,'ell_ell_overlap: ',flags
      print *,'ell_ell_overlap: ',area
    endif
    area_flags(1) = area
    area_flags(2) = flags
    return
  endif

  !  For each pair of adjacent intersection points we should either use the 
  ! area of the elliptical arc for  ellipse_1 or ellipse_2.
  !  Determine which ellipse to use for the first pair of intersection points
  ! by looking which ellipse is intersected first by a line from the centroid
  ! of the quadrilateral through the mid-point of the quadrilateral edge.
  !  Store the result of this test in whichell, then use this
  ! to  alternate the use of ellipse_1/elliptical_2 arc area as the
  ! calculation  proceeds around intersection points.

  qline(1:2) = xyqc
  qline(3) = 0.5d0*(xy_int(1,k(1))+xy_int(1,k(2))) - xyqc(1)
  qline(4) = 0.5d0*(xy_int(2,k(1))+xy_int(2,k(2))) - xyqc(2)
  t_1 = maxval(ell_line_intersect(ellipse_1, qline))
  t_2 = maxval(ell_line_intersect(ellipse_2, qline))
  whichell = (t_1 < t_2)
  xyc_1(1:2) = [ellipse_1(i_ell_x_c),ellipse_1(i_ell_y_c)]
  xyc_2(1:2) = [ellipse_2(i_ell_x_c),ellipse_2(i_ell_y_c)]
  do i=1,4
    j0 = k(i)
    j1 = k(mod(i,4)+1)
    if (whichell) then 
      !  Note cunning using of triangle area calculation with sign here to
      !  determine whether to use the larger or smaller of the two possible
      !  circle/ellipse sectors defined by the intersection points.
      s_t_a=triangle_area(xyc_1,xy_int(1:2,j0),xy_int(1:2,j1),signed=.true.)
      if(s_t_a > 0.d0) then
        area = area + ell_sector_area(theta_1(j0),theta_1(j1),ellipse_1) - s_t_a
      else
        area = area + ellipse_1(i_ell_area) &
        - ell_sector_area(theta_1(j0),theta_1(j1),ellipse_1) - s_t_a
      endif
    else 
      s_t_a=triangle_area(xyc_2,xy_int(1:2,j0),xy_int(1:2,j1),signed=.true.)
      if(s_t_a > 0.d0) then
        area = area + ell_sector_area(theta_2(j0),theta_2(j1),ellipse_2) - s_t_a
      else
        area = area + ellipse_2(i_ell_area) &
        - ell_sector_area(theta_2(j0),theta_2(j1),ellipse_2) - s_t_a
      endif

    endif
    whichell = .not.whichell
  end do

  area_flags(1) =  area
  area_flags(2) =  flags
  return
endif

if (verbose >= v_error) then
  print *,'ell_ell_overlap : unknown error'
  print *,intersect_flags
  print *,ellipse_1(i_ell_ellpar)
  print *,ellipse_2(i_ell_ellpar)
endif
area_flags(1) =  bad_dble
area_flags(2) =  b_ell_error
return

end function ell_ell_overlap

!------------------------------------------------------------------------------

subroutine ell_ell_intersect(ellipse_1, ellipse_2, verbose, & 
                             flags, xy_intersect, &
                             theta_1, theta_2)

! Non-tangent intersection points for two ellipses.
implicit none
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse_1(n_ell_par) 
double precision, intent(in) :: ellipse_2(n_ell_par)
integer, intent(in)  :: verbose
integer, intent(out) :: flags
double precision, intent(out):: xy_intersect(2,4)
! Parametric angle to intersection points for ellipse_1 and ellipse_2
double precision, intent(out), optional :: theta_1(4)
double precision, intent(out), optional :: theta_2(4)
! flags is bit mask with the following flags
!  b_ell_no_overlap       = zero area of overlap (*)
!  b_ell_1_inside_2       = ellipse_1 inside ellipse_2 (*)
!  b_ell_2_inside_1       = ellipse_2 inside ellipse_1 (*)
!  b_ell_two_intersects   = there are two intersection points  (+)
!  b_ell_four_intersects  = there are four intersection points 
!  b_ell_identical        = ellipses are identical
!  b_ell_invalid          = invalid input
!  b_ell_error            = error during calculation
!
! Notes
! (*) - the ellipses may (also) share one or two tangent points in these cases.
! (+) - the ellipses may also share an additional tangent point
!  To test these flags, use btest(int(area_flags(2)),<bit flag name>)

! Local variables
double precision :: xroots(4), yroots(4)
double precision :: xy(2,16,3), t_1(4), t_2(4), t_left, t_right
double precision :: xy_left(2), xy_right(2), xyc_1(2), xyc_2(2), separation
double precision :: ellipse_1t(n_ell_par),ellipse_2t(n_ell_par)
double precision, parameter :: roothalf = 0.70710678118654757d0
double precision :: tr1(2,3) = reshape([ roothalf,roothalf, &
                                       -roothalf,roothalf, &
                                           0.0d0,   0.0d0], [2,3])
double precision, parameter :: sin60 = 0.86602540378443860d0
double precision :: tr2(2,3) = reshape([ 0.5d0,sin60, &
                                        -sin60,0.5d0, &
                                           0.0d0,   0.0d0], [2,3])
!double precision :: tr3(2,3) = reshape([ sin60,0.5d0, &
!                                        -0.5d0,sin60, &
!                                           0.0d0,   0.0d0], [2,3])
double precision :: tr3(2,3) = reshape([ 1.0d0,0.0d0, &
                                         0.0d0,1.0d0, &
                                           0.0d0,   0.0d0], [2,3])
integer :: ix, iy, nxroots, nyroots
integer :: ii, jj, kk, ll
integer :: npair(3), ntouch, key(3)
double precision :: xy_touch(2,4)
logical :: fail, new, l_left, l_right, lx1, lx2

! Tolerance parameters

! Maximum separation between points on ellipses to be considered as 
! intersection as a fraction of the minimum
! Also used to remove duplicate intersections.
double precision, parameter :: xytol = 1.0d-9
! Tolerance on ellipse parameters to identify identical ellipses
double precision, parameter :: stol = 1d-12

flags = 0  ! Initialize/clear bit mask flags

! Deal with a few easy cases ...
separation = hypot(ellipse_1(i_ell_x_c)-ellipse_2(i_ell_x_c), &
                   ellipse_1(i_ell_y_c)-ellipse_2(i_ell_y_c) )
if (separation >= (ellipse_1(i_ell_a_p)+ellipse_2(i_ell_a_p))) then
  flags = ibset(flags, b_ell_no_overlap)
  return
endif

if (separation <= (ellipse_1(i_ell_b_p)-ellipse_2(i_ell_a_p))) then
  flags = ibset(flags, b_ell_2_inside_1)
  return
endif

if (separation <= (ellipse_2(i_ell_b_p)-ellipse_1(i_ell_a_p))) then
  flags = ibset(flags, b_ell_1_inside_2)
  return
endif

if (all(abs(ellipse_2(i_ell_ellpar)-ellipse_1(i_ell_ellpar)) < stol)) then
  flags = ibset(flags, b_ell_identical)
  return
endif


do ii = 1,3
  ! Find x-/y-values of intersection points
  select case (ii)
  case (1)
    ellipse_1t = ell_affine(tr1, ellipse_1)
    ellipse_2t = ell_affine(tr1, ellipse_2)
    call ell_ell_roots(ellipse_1t, ellipse_2t, xroots,nxroots,yroots=.false.)
    call ell_ell_roots(ellipse_1t, ellipse_2t, yroots,nyroots,yroots=.true.)
  case(2)
    ellipse_1t = ell_affine(tr2, ellipse_1)
    ellipse_2t = ell_affine(tr2, ellipse_2)
    call ell_ell_roots(ellipse_1t, ellipse_2t, xroots,nxroots,yroots=.false.)
    call ell_ell_roots(ellipse_1t, ellipse_2t, yroots,nyroots,yroots=.true.)
  case(3)
    ellipse_1t = ell_affine(tr3, ellipse_1)
    ellipse_2t = ell_affine(tr3, ellipse_2)
    call ell_ell_roots(ellipse_1t, ellipse_2t, xroots,nxroots,yroots=.false.)
    call ell_ell_roots(ellipse_1t, ellipse_2t, yroots,nyroots,yroots=.true.)
  end select

  if (verbose >= v_debug) then
    print *,'ell_ell_intersect: nxroots, nyroots = ',nxroots, nyroots
  endif


  if ((nxroots == 5).or.(nyroots == 5)) then ! Identical ellipses
    flags = ibset(flags,b_ell_identical)
    return
  endif

  if ((nxroots == -5).or.(nyroots == -5)) then ! root finding failed.
    flags = ibset(flags,b_ell_error)
  endif

  if ((nxroots < 0 ).or.(nyroots < 0 )) then ! roots may be inaccurate
    nxroots = abs(nxroots)
    nyroots = abs(nyroots)
    flags = ibset(flags,b_ell_warn_inaccurate)
  endif

  ! Store every pair-wise combination of x-,y- roots
  npair(ii) = 0 
  do ix=1,nxroots
    do iy=1,nyroots
      npair(ii) = npair(ii) + 1
      select case (ii)
      case (1)
        xy(1:2,npair(ii),1) = affine([xroots(ix), yroots(iy)],tr1,&
          inverse=.true.)
      case (2)
        xy(1:2,npair(ii),2) = affine([xroots(ix), yroots(iy)],tr2,&
          inverse=.true.)
      case (3)
        xy(1:2,npair(ii),3) = affine([xroots(ix), yroots(iy)],tr3,&
          inverse=.true.)
      end select
    end do
  end do

end do

! Search for (x,y) pairs that produce an intersection for at least 2 of the
! ellipse orientations (within distance xytol).
ntouch = 0 
do ii = 1,2
do jj = ii+1,3
  do kk = 1,npair(ii)
  do ll = 1,npair(jj)

    if (distance(xy(1:2,kk,ii),xy(1:2,ll,jj)) < xytol) then
      new = .true.
      do ix=1,ntouch
        if((distance(xy(1:2,kk,ii),xy_touch(1:2,ix)) < xytol) &
        .or.(distance(xy(1:2,ll,jj),xy_touch(1:2,ix)) < xytol))then
          new = .false.
          exit
        endif
      end do
      if (new) then
        ntouch = ntouch + 1
        if (ntouch > 4) then
          print *,'ell_ell_intersect: ntouch > 4'
          print *, ellipse_1
          print *, ellipse_2
          stop
        endif
        xy_touch(1:2,ntouch) = 0.5d0*(xy(1:2,kk,ii)+xy(1:2,ll,jj))
      endif
    endif
  end do
  end do
end do
end do
if (verbose >= v_debug) then
  print *,'ell_ell_intersect: ntouch= ',ntouch
endif


select case (ntouch)
  case (0,1)

  xyc_1(1:2) = [ellipse_1(i_ell_x_c), ellipse_1(i_ell_y_c)]
  if (ell_point_is_inside(xyc_1, ellipse_2).and. &
     (ellipse_1(i_ell_area) < ellipse_2(i_ell_area))) then
    flags = ibset(flags,b_ell_1_inside_2)
    return
  endif

  xyc_2(1:2) = [ellipse_2(i_ell_x_c),ellipse_2(i_ell_y_c)]
  if (ell_point_is_inside(xyc_2, ellipse_1).and. &
      (ellipse_2(i_ell_area) < ellipse_1(i_ell_area))) then
    flags = ibset(flags,b_ell_2_inside_1)
    return
  endif

  flags = ibset(flags, b_ell_no_overlap)
  return

case (2)

  ! Calculate parametric angle in ellipse 1 for the points where the ellipses
  ! touch
  do ii = 1,2
    t_1(ii) = ell_xy_to_t(xy_touch(1:2,ii),ellipse_1)
    t_2(ii) = ell_xy_to_t(xy_touch(1:2,ii),ellipse_2)
  end do
  
  ! Test for tangent points/intersection points by testing whether the points
  ! mid-way between the intersection points are inside/outside ellipse_2.
  t_right = 0.5d0*(t_1(1)+t_1(2))
  t_left = t_right + pi
  xy_right = ell_t_to_xy(t_left ,ellipse_1)
  xy_left  = ell_t_to_xy(t_right,ellipse_1)
  l_right = ell_point_is_inside(xy_right,ellipse_2)
  l_left  = ell_point_is_inside(xy_left ,ellipse_2)
  if (l_right.neqv.l_left) then
    xy_intersect(1:2,1:2) = xy_touch(1:2,1:2)
    if (present(theta_1)) theta_1(1:2) = t_1(1:2)
    if (present(theta_2)) theta_2(1:2) = t_2(1:2)
    flags = ibset(flags, b_ell_two_intersects)
    return
  endif

  ! Need to catch a rare case here where one of the mid-points between the
  ! intersection/tangent points is also a tangent point (or nearly so), in which
  ! case the test above fails. Double-check here whether the xy_touch(1:2,1:2)
  ! are tangent points by testing whether points just either side of these
  ! points are both inside/outside the other ellipse. 
  t_right = t_1(1)+1.0D-3
  t_left  = t_1(1)-1.0D-3
  xy_right = ell_t_to_xy(t_left ,ellipse_1)
  xy_left  = ell_t_to_xy(t_right,ellipse_1)
  l_right = ell_point_is_inside(xy_right,ellipse_2)
  l_left  = ell_point_is_inside(xy_left ,ellipse_2)
  lx1 = (l_right.neqv.l_left) ! True if xy_touch(1:2,1) is not tangent 

  t_right = t_1(2)+1.0D-3
  t_left  = t_1(2)-1.0D-3
  xy_right = ell_t_to_xy(t_left ,ellipse_1)
  xy_left  = ell_t_to_xy(t_right,ellipse_1)
  l_right = ell_point_is_inside(xy_right,ellipse_2)
  l_left  = ell_point_is_inside(xy_left ,ellipse_2)
  lx2 = (l_right.neqv.l_left) ! True if xy_touch(1:2,2) is not tangent 

  if (lx1.or.lx2) then ! At least one point is a non-tangent intersection
    ! Both points should be non-tangent, raise warning if not
    if (lx1.neqv.lx2) then
      flags = ibset(flags,b_ell_warn_inaccurate)
    endif
    xy_intersect(1:2,1:2) = xy_touch(1:2,1:2)
    if (present(theta_1)) theta_1(1:2) = t_1(1:2)
    if (present(theta_2)) theta_2(1:2) = t_2(1:2)
    flags = ibset(flags, b_ell_two_intersects)
    return
  endif


  xyc_1(1:2) = [ellipse_1(i_ell_x_c), ellipse_1(i_ell_y_c)]
  if (ell_point_is_inside(xyc_1, ellipse_2).and. &
  (ellipse_1(i_ell_area) < ellipse_2(i_ell_area))) then
    flags = ibset(flags,b_ell_1_inside_2)
    return
  endif

  xyc_2(1:2) = [ellipse_2(i_ell_x_c),ellipse_2(i_ell_y_c)]
  if (ell_point_is_inside(xyc_2, ellipse_1).and. &
  (ellipse_2(i_ell_area) < ellipse_1(i_ell_area))) then
    flags = ibset(flags,b_ell_2_inside_1)
    return
  endif

  flags = ibset(flags, b_ell_no_overlap)
  return

case (3) ! One of the points where the ellipses touch is a tangent point

  flags = ibset(flags, b_ell_two_intersects)
  do ii = 1,3
    t_1(ii) = ell_xy_to_t(xy_touch(1:2,ii),ellipse_1)
    t_2(ii) = ell_xy_to_t(xy_touch(1:2,ii),ellipse_2)
  end do
  call heapsort(t_1(1:3),key)

  t_right = 0.5d0*(t_1(key(2))+t_1(key(1)))
  t_left  = 0.5d0*(t_1(key(2))+t_1(key(3))) 
  xy_right = ell_t_to_xy(t_left ,ellipse_1)
  xy_left  = ell_t_to_xy(t_right,ellipse_1)
  l_right = ell_point_is_inside(xy_right,ellipse_2)
  l_left  = ell_point_is_inside(xy_left ,ellipse_2)
  if (l_right.eqv.l_left) then
    xy_intersect(1:2,1) = xy_touch(1:2,key(1))
    xy_intersect(1:2,2) = xy_touch(1:2,key(3))
    if (present(theta_1)) theta_1(1:2) = [t_1(key(1)),t_1(key(3))]
    if (present(theta_2)) theta_2(1:2) = [t_2(key(1)),t_2(key(3))]
    return
  endif

  t_right = 0.5d0*(t_1(key(1))+t_1(key(3)))+pi
  t_left  = 0.5d0*(t_1(key(1))+t_1(key(2))) 
  xy_right = ell_t_to_xy(t_left ,ellipse_1)
  xy_left  = ell_t_to_xy(t_right,ellipse_1)
  l_right = ell_point_is_inside(xy_right,ellipse_2)
  l_left  = ell_point_is_inside(xy_left ,ellipse_2)
  if (l_right.eqv.l_left) then
    xy_intersect(1:2,1) = xy_touch(1:2,key(2))
    xy_intersect(1:2,2) = xy_touch(1:2,key(3))
    if (present(theta_1)) theta_1(1:2) = [t_1(key(2)),t_1(key(3))]
    if (present(theta_2)) theta_2(1:2) = [t_2(key(2)),t_2(key(3))]
    return
  endif

  t_right = 0.5d0*(t_1(key(3))+t_1(key(1)))+pi
  t_left  = 0.5d0*(t_1(key(3))+t_1(key(2))) 
  xy_right = ell_t_to_xy(t_left ,ellipse_1)
  xy_left  = ell_t_to_xy(t_right,ellipse_1)
  l_right = ell_point_is_inside(xy_right,ellipse_2)
  l_left  = ell_point_is_inside(xy_left ,ellipse_2)
  if (l_right.eqv.l_left) then
    xy_intersect(1:2,1) = xy_touch(1:2,key(2))
    xy_intersect(1:2,2) = xy_touch(1:2,key(2))
    if (present(theta_1)) theta_1(1:2) = [t_1(key(1)),t_1(key(2))]
    if (present(theta_2)) theta_2(1:2) = [t_2(key(1)),t_2(key(2))]
    return
  endif

  print *,'ell_ell_interect: case(3) error - no tangent found.'
  print *,ellipse_1(i_ell_ellpar)
  print *,ellipse_2(i_ell_ellpar)
  stop

case (4)

  xy_intersect(1:2,1:4) = xy_touch(1:2,1:4)
  flags = ibset(flags, b_ell_four_intersects)
  if (present(theta_1)) then
    do ii = 1,4
    theta_1(ii) = ell_xy_to_t(xy_touch(1:2,ii),ellipse_1)
    end do
  endif
  if (present(theta_2)) then
    do ii = 1,4
      theta_2(ii) = ell_xy_to_t(xy_touch(1:2,ii),ellipse_2)
    end do
  endif
  return

case default

  print *,'ell_ell_intersect, ntouch = ', ntouch
  print *,ellipse_1
  print *,ellipse_2
  stop

end select



contains
  subroutine ell_ell_roots(ellipse_1, ellipse_2, roots, nroot, yroots)
  ! Roots of the polynomial in x or y that correspond to the intersections
  ! of two ellipses.
  ! Return nroot = -(# of roots) if root-polishing exceeds iteration limit
  ! Return nroot = -5 of algorithm fails
  double precision, intent(in) :: ellipse_1(n_ell_par) 
  double precision, intent(in) :: ellipse_2(n_ell_par)
  logical, intent(in), optional :: yroots
  double precision, intent(out) :: roots(4)
  integer, intent(out) :: nroot

  ! Test those potential real roots for which the imaginary part is < ztol. 
  double precision, parameter :: ztol = 1.0d-15

  ! Converge tolerance on x/y root position
  double precision, parameter :: xytol = 1.0d-9
  
  ! Fractional tolerance on sum of successive corrections in Maehly's 
  ! procedure to identify cases where the algorithm is bouncing around 
  ! either side of the root.
  double precision, parameter :: dtol = 1.0d-6

  double precision :: s0,s1,s2,s3,s4,s5
  double precision :: t0,t1,t2,t3,t4,t5
  double precision :: d31,d10,d30,d34,d40,d12,d32,d42,d51,d35,d45
  double precision :: e52,e20,e50,e54,e40,e21,e51,e41,e32,e53,e43
  double precision :: a(5), xreal(4), ximag(4)
  double precision :: xcand, p, p1, x1, x2, s, d1, d2
  integer :: degree, i, j, iter
  integer, parameter :: itmax = 64
  logical :: yroots_l, newroot, root_polishing_failed

  if (present(yroots)) then
    yroots_l = yroots
  else
    yroots_l = .false.
  endif
  s0 = ellipse_1(i_ell_qcoeff(6))
  s1 = 2.0D0*ellipse_1(i_ell_qcoeff(4))
  s2 = 2.0D0*ellipse_1(i_ell_qcoeff(5))
  s3 = ellipse_1(i_ell_qcoeff(1))
  s4 = 2.0D0*ellipse_1(i_ell_qcoeff(2))
  s5 = ellipse_1(i_ell_qcoeff(3))

  t0 = ellipse_2(i_ell_qcoeff(6))
  t1 = 2.0D0*ellipse_2(i_ell_qcoeff(4))
  t2 = 2.0D0*ellipse_2(i_ell_qcoeff(5))
  t3 = ellipse_2(i_ell_qcoeff(1))
  t4 = 2.0D0*ellipse_2(i_ell_qcoeff(2))
  t5 = ellipse_2(i_ell_qcoeff(3))

  if (yroots_l) then
    ! Coefficients of quartic whose roots are y values of intersections.
    d10 = s1*t0 - s0*t1
    d12 = s1*t2 - s2*t1
    d30 = s3*t0 - s0*t3
    d31 = s3*t1 - s1*t3
    d32 = s3*t2 - s2*t3
    d34 = s3*t4 - s4*t3
    d35 = s3*t5 - s5*t3
    d40 = s4*t0 - s0*t4
    d42 = s4*t2 - s2*t4
    d45 = s4*t5 - s5*t4
    d51 = s5*t1 - s1*t5
    a(1) = d34*d45-d35**2
    a(2) = d34*(d42-d51) + d31*d45 - 2.0d0*d35*d32
    a(3) = d34*(d40+d12) + d31*(d42-d51) - d32**2 - 2.0d0*d35*d30 
    a(4) = d34*d10 + d31*(d40+d12) - 2.0d0*d32*d30
    a(5) = d31*d10 - d30**2
  else
    ! Coefficients of quartic whose roots are x values of intersections.
    e20 = s2*t0 - s0*t2
    e21 = s2*t1 - s1*t2
    e50 = s5*t0 - s0*t5
    e52 = s5*t2 - s2*t5
    e51 = s5*t1 - s1*t5
    e54 = s5*t4 - s4*t5
    e53 = s5*t3 - s3*t5
    e40 = s4*t0 - s0*t4
    e41 = s4*t1 - s1*t4
    e43 = s4*t3 - s3*t4
    e32 = s3*t2 - s2*t3

    a(1) = e54*e43-e53**2
    a(2) = e54*(e41-e32) + e52*e43 - 2.0d0*e53*e51
    a(3) = e54*(e40+e21) + e52*(e41-e32) - e51**2 - 2.0d0*e53*e50 
    a(4) = e54*e20 + e52*(e40+e21) - 2.0d0*e51*e50
    a(5) = e52*e20 - e50**2
  endif
  ! Find unique real (or nearly-real) roots of these quartics
  degree = 4
  do i = 1,5
    if (a(i) == 0.0d0) then
      degree = degree -1
    else 
      exit
    endif
  end do
  if (degree == 0) then ! Identical ellipses
    nroot = 5 
    return
  endif

  ! Use Jenkins & Traub algorithm to get candidate roots
  call rpoly(a(5-degree:5),degree,xreal, ximag, fail)
  if (fail) then 
    print *,'ell_ell_roots: rpoly fail, a',fail,a
    print *,ellipse_1
    print *,ellipse_2
    print *,a
    print *,degree
    nroot = -5
    return
  endif

  nroot = 0 
  root_polishing_failed = .false.
  do i = 1, degree
    if(abs(ximag(i)) < ztol) then
      newroot = .true.
      xcand = xreal(i)
      do j = 1,nroot
        if (abs(xcand - roots(j)) <  epsilon(0.0d0)) then
          newroot = .false.
          exit
        endif
      end do
      if (newroot) then
        x1 = xcand
        x2 = xcand + 1.0d0
        iter = 0 
        d1 = not_set_dble

        do while ((abs(x1-x2) > xytol).and.(iter<itmax))
          p = x1*(x1*(x1*(x1*a(1)+a(2))+a(3))+a(4))+a(5)
          if (p == 0.0d0) then 
            x2 = x1
          else! Polish root using Maehly's method
            iter = iter + 1
            if (iter == itmax) then
              root_polishing_failed = .true.
              x2 = x1
            else
              p1 = x1*(x1*(4.0d0*x1*a(1)+3.0d0*a(2))+2.0d0*a(3))+a(4)
              s = 0
              do j = 1, nroot
                s = s + 1.0d0/(x1-roots(j))
              end do
              d2 = d1
              d1 = p/(p1 - p*s)
              if (abs(d1+d2) < dtol*abs(d1)) then
                x2 = x1
              else
                x2 = x1 - d1
              endif
              call swap(x1,x2)
            endif
          endif
        end do
        nroot = nroot + 1
        roots(nroot) = x1
      endif
    endif
  end do
  if (root_polishing_failed) nroot = -nroot

  end subroutine ell_ell_roots

!---

end subroutine ell_ell_intersect

!---------------------------------------------------------------------------

function ell_ucircle_overlap(ellipse, verbose, xy_intersect, t_ell,  &
                             t_circ) result (area_flags)
!
! Area in the region bounded by the overlap of an ellipse and a unit circle
! and type of overlap. The result is returned as a 2-element array
!
! area_flags(1) = area (or bad_dble for invalid input)
!
! area_flags(2) = bit mask with the following flags
!  b_ell_no_overlap            = zero area of overlap (*)
!  b_ell_ellipse_inside_circle = ellipse inside unit circle (*)
!  b_ell_circle_inside_ellipse = unit circle inside ellipse (*)
!  b_ell_two_intersects        = there are two intersection points  (*)
!  b_ell_four_intersects       = there are four intersection points 
!  b_ell_identical             = ellipses are identical
!  b_ell_invalid               = invalid input
!  b_ell_error                 = error during calculation
!  b_ell_warn_inaccurate       = results may be inaccurate
!
! Notes
! (*) - the ellipse and circle may (also) share one or two tangent points in 
!       these cases.
!
!  To test these flags, use btest(int(area_flags(2)),<bit flag name>)
!
implicit none
double precision             :: area_flags(2)
!f2py integer, parameter :: n_ell_par = 14
double precision, intent(in) :: ellipse(n_ell_par)
integer, intent(in)  :: verbose 
double precision, optional, intent(out) :: xy_intersect(2,4)
double precision, optional, intent(out) :: t_ell(4), t_circ(4)

! Local variables
double precision :: xyc(2)
double precision :: area, xyqc(2), xy_int(2,4), qline(4), s_t_a, t_1, t_2, tq(4)
double precision :: xy1(2), xy2(2), theta_e(4), theta_c(4)
integer  :: flags, k(4), j0, j1, i, intersect_flags
logical  :: l_1, l_2, whichell
integer :: verbose1
double precision :: circle(n_ell_par) = [1.0d0,0.0d0,1.0d0,0.0d0,0.0d0,-1.0d0,&
                                         1.0d0,1.0d0,0.0d0,0.0d0,0.0d0, 0.0d0,&
                                         1.0d0,0.0d0]
! Initialize
flags = 0
verbose1 = verbose_for_calls(verbose)

call ell_ell_intersect(ellipse, circle, verbose1, intersect_flags, &
                           xy_int, theta_e, theta_c)

if (present(xy_intersect)) xy_intersect(:,:) = xy_int(:,:)
if (present(t_ell)) t_ell(:) = theta_e(:)
if (present(t_circ)) t_circ(:) = theta_c(:)

if (btest(intersect_flags, b_ell_identical)) then
  if (verbose >= v_debug) then
    print *,'ell_ucircle_overlap: ellipse identical to unit circle.'
  endif
  flags = ibset(flags,b_ell_identical)
  area_flags(1) = pi
  area_flags(2) = flags
  return
endif

if (btest(intersect_flags, b_ell_circle_inside_ellipse)) then
  if (verbose >= v_debug) then
    print *,'ell_ucircle_overlap: unit circle inside ellipse.'
  endif
  flags = ibset(flags,b_ell_circle_inside_ellipse)
  area_flags(1) = pi
  area_flags(2) = flags
  return
endif

if (btest(intersect_flags, b_ell_ellipse_inside_circle)) then
  if (verbose >= v_debug) then
    print *,'ell_ucircle_overlap: unit circle inside ellipse.'
  endif
  flags = ibset(flags,b_ell_ellipse_inside_circle)
  area_flags(1) = ellipse(i_ell_area)
  area_flags(2) = flags
  return
endif

if (btest(intersect_flags, b_ell_no_overlap)) then
  if (verbose >= v_debug) then
    print *,'ell_ucircle_overlap: no overlap.'
  endif
  flags = ibset(flags, b_ell_no_overlap)
  area_flags(1) = 0.d0
  area_flags(2) = flags
  return
endif

if (btest(intersect_flags, b_ell_two_intersects)) then

  flags = ibset(flags,b_ell_two_intersects)
  xy1 = ell_t_to_xy(midangle(theta_e(1),theta_e(2)), ellipse)
  l_1 = (xy1(1)**2 + xy1(2)**2) < 1.0d0 
  xyc(1:2) = [ellipse(i_ell_x_c),ellipse(i_ell_y_c)]
  if (l_1) then
    area =  ell_sector_area(theta_e(1),theta_e(2),ellipse)  &
         - triangle_area(xyc,xy_int(1:2,1),xy_int(1:2,2))
  else
    area = ellipse(i_ell_area) &
         - ell_sector_area(theta_e(1),theta_e(2),ellipse)  &
         + triangle_area(xyc,xy_int(1:2,1),xy_int(1:2,2))
  endif
  t_2 = midangle(theta_c(1),theta_c(2))
  xy2 = [ cos(t_2), sin(t_2) ]
  l_2 = ell_point_is_inside(xy2,ellipse)
  if (l_2) then
    area = area + arc_area(xy_int(1:2,1),xy_int(1:2,2))
  else
    area = area + pi - arc_area(xy_int(1:2,1),xy_int(1:2,2))
  endif
  if (verbose >= v_debug) then
    print *,'ell_ucircle_overlap, two intersections, area = ',area
  endif
  area_flags(1) = area
  area_flags(2) = flags
  return

endif

if (btest(intersect_flags, b_ell_four_intersects)) then
  flags = ibset(flags,b_ell_four_intersects)
  
  ! Deal with intersection points in clockwise order, sorted by the angle to the
  ! x-axis measured from their centroid.
  xyqc = sum(xy_int,dim=2)/4.d0
  tq = atan2(xy_int(2,1:4)-xyqc(2),xy_int(1,1:4)-xyqc(1))
  call heapsort(tq,k)

  ! Area of quadrilateral
  area = 0.5d0*abs( &
          (xy_int(1,k(3))-xy_int(1,k(1)))*(xy_int(2,k(4))-xy_int(2,k(2))) &
        - (xy_int(1,k(4))-xy_int(1,k(2)))*(xy_int(2,k(3))-xy_int(2,k(1))) )
  !  For each pair of adjacent intersection points we should either use the 
  ! area of the elliptical arc or the circular arc. Determine which to use for
  ! the first pair of intersection points by looking whether the ellipse or the
  ! circle is intersected first by a line from the centroid of the 
  ! quadrilateral through the mid-point of the quadrilateral edge.
  !  Store the result of this test in whichell, then use this
  ! to  alternate the use of ellipse/circle arc area as the
  ! calculation  proceeds around intersection points.

  qline(1:2) = xyqc
  qline(3) = 0.5d0*(xy_int(1,k(1))+xy_int(1,k(2))) - xyqc(1)
  qline(4) = 0.5d0*(xy_int(2,k(1))+xy_int(2,k(2))) - xyqc(2)
  t_1 = maxval(ell_line_intersect(ellipse, qline))
  t_2 = maxval(ucircle_line_intersect(qline))
  whichell = (t_1 < t_2)
  xyc(1:2) = [ellipse(i_ell_x_c),ellipse(i_ell_y_c)]
  do i=1,4
    j0 = k(i)
    j1 = k(mod(i,4)+1)
    if (whichell) then 
      !  Note cunning using of triangle area calculation with sign here to
      !  determine whether to use the larger or smaller of the two possible
      !  circle/ellipse sectors defined by the intersection points.
      s_t_a=triangle_area(xyc,xy_int(1:2,j0),xy_int(1:2,j1),signed=.true.)
      if(s_t_a > 0.d0) then
        area = area + ell_sector_area(theta_e(j0),theta_e(j1),ellipse) - s_t_a
      else
        area = area + ellipse(i_ell_area) &
        - ell_sector_area(theta_e(j0),theta_e(j1),ellipse) - s_t_a
      endif
    else 
      s_t_a = xy_int(1,j0)*xy_int(2,j1) - xy_int(1,j1)*xy_int(2,j0)
      if(s_t_a > 0.d0) then
        area = area + arc_area(xy_int(1:2,j0),xy_int(1:2,j1))
      else
        area = area + pi - arc_area(xy_int(1:2,j0),xy_int(1:2,j1))
      endif

    endif
    whichell = .not.whichell
  end do

  area_flags(1) =  area
  area_flags(2) =  flags
  return
endif

if (verbose >= v_error) then
  print *,'ell_ucircle_overlap : unknown error'
  print *,intersect_flags
  print *,ellipse(i_ell_ellpar)
endif
area_flags(1) =  bad_dble
area_flags(2) =  b_ell_error
return

end function ell_ucircle_overlap

!---------------------------------------------------------------------------

double precision function ell_sector_area(t_0,t_1,ellipse)
! Area of the elliptical sector defined by the parametric angles t0 and t1
! N.B. This is always the smallest possible sector defined by t0 and t1
! irrespective of whether t0 > t1 or t0 < t1.
implicit none
!f2py integer, parameter :: n_ell_par = 14
double precision,intent(in) :: ellipse(n_ell_par) 
double precision,intent(in) :: t_0, t_1

! Local variables
double precision :: dt

dt = mod(abs(t_1 - t_0), twopi)
if (dt > pi) dt = twopi - dt
ell_sector_area = dt*ellipse(i_ell_area)/twopi
return
end function ell_sector_area

!------------------------------------------------------------------------------

end module ellipse
